SystemOrganization addCategory: #'GT-Spotter-EventRecorder-Analysis'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Builders'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Core'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Obsolete'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity-Symbols'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Tests'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Traits'!
SystemOrganization addCategory: 'GT-Spotter-EventRecorder-Analysis-Utilities'!

Trait named: #TGTABookmarkIt
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 10:30'!
bookmarkIt
	self explicitRequirement! !

!TGTABookmarkIt methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:47'!
bookmarks
	self explicitRequirement! !

!TGTABookmarkIt methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 10:27'!
gtInspectorActionBookmarkIt
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self bookmarkIt ];
		icon: Smalltalk ui icons glamorousBookmark;
		title: 'Bookmark It'! !

!TGTABookmarkIt methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/19/2015 10:46'!
gtInspectorBookmarksIn: composite
	<gtInspectorPresentationOrder: -1>
	composite tabulator 
		when: [ self isBookmarked ];
		title: 'Bookmarks';
		with: [ :browser | 
			browser
				row: #table;
				row: #description.
			browser transmit 
				to: #table;
				andShow: [ :c |
					c table 
						display: [ :anEventCollection | anEventCollection relatedBookmarks ];
						column: 'Garbage'
							evaluated: [ :each | each garbageString ]
							width: 57;
						column: 'Description'
							evaluated:  [ :each | GTObjectPrinter new asTruncatedTextFrom: 
															each description asString ];
						updateOn: GTACollectionAnnouncement 
							from: [ :aEventCollection | 
										aEventCollection bookmarks announcer ];
						selectionAct: [ :list :bookmark | 
								self toggleGarbage: list rawSelection.
								list update ]
							entitled: 'Toggle garbage';
						selectionAct: [ :list :relatedBookmarks |
								self removeBookmark: list selection.
								list update ]
							entitled: 'Remove bookmark' ].
			browser transmit
				to: #description;
				from: #table port: #selection;
				andShow: [ :c |
					c rubricText
						display: #description;
						act: [ :port :bookmark | 
								bookmark description: port text asString.
								self bookmarks save.
								port pane browser panes do: #update ] 
							on: $s
							entitled: 'Save' ]
		] ! !

!TGTABookmarkIt methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:49'!
isBookmarked
	^ self bookmarks hasRelatedTo: self! !

!TGTABookmarkIt methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:48'!
relatedBookmarks
	^ self bookmarks relatedTo: self! !

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 13:06'!
removeBookmark: aBookmark
	self bookmarks 
		removeBookmark: aBookmark;
		save.! !

!TGTABookmarkIt methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 10:49'!
toggleGarbage: aGTABookmark 
	aGTABookmark toggleGarbage.
	self bookmarks save.! !

Trait named: #TGTSpotterCategoryView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterCategoryView methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:58'!
categoryLabelOccurrences
	| col |
	col := OrderedCollection new.
	self categoryLabels asBag 
		doWithOccurrences: [ :obj :occurrences | 
			col add: obj -> occurrences ].
	^ col! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/26/2015 11:31'!
categoryView
	| b ds points |
	b := RTGrapher new.
	points := self sessionsPerCategoryLabel sortedAs: [ :x :y | x size > y size ].
	points ifEmpty: [ ^ b view ].
	b extent: ((points size * 30) min: 800) @ 150.
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj categoryLabel asString, ', ', obj size asString, ' times' ].
	ds points: points.
	ds barShape 
			color: (Color green alpha: 0.3); 
			width: 10.
	ds histogramWithBarTitle: #categoryLabel.
	ds y: [ :obj | obj size ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:30'!
gtInspectorCategoryViewIn: composite
	<gtInspectorPresentationOrder: -2>
	composite roassal2
		title: 'Category';
		initializeView: [ self categoryView ]
		! !

!TGTSpotterCategoryView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/28/2015 15:15'!
selectedCategoriesView
	| b ds points |
	b := RTGrapher new.
	points := self sessionsPerSelectedCategoryLabel sortedAs: [ :x :y | x size > y size ].
	points ifEmpty: [ ^ b view ].
	b extent: ((points size * 30) min: 800) @ 150.
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj categoryLabel asString, ', ', obj size asString, ' times' ].
	ds points: points.
	ds barShape 
			color: (Color green alpha: 0.3); 
			width: 10.
	ds histogramWithBarTitle: #categoryLabel.
	ds y: [ :obj | obj size ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

Trait named: #TGTSpotterDurationView
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 16:09'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!TGTSpotterDurationView methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 10:56'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

Trait named: #TGTSpotterSessionsTable
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterSessionsTable methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/30/2015 11:03'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -2>  
	^ (composite table)
		title: 'Sessions';
		display: [ :anEvent | anEvent sessions ];
		column: 'Start' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each start ] width: 155;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each withPreviewSymbol ]
			width: 57;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		showOnly: 50! !

Trait named: #TGTSpotterUpdateEvents
	uses: {}
	category: 'GT-Spotter-EventRecorder-Analysis-Traits'!

!TGTSpotterUpdateEvents methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 4/9/2015 10:54'!
gtInspectorActionRefreshEvents
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ self updateEvents ];
		icon: Smalltalk ui icons glamorousRefresh;
		title: 'Update events'! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons showPreviewIcon! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 13:00'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Show Preview'.
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderShowPreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:55'!
isForTimelineView
	^ true! !

!GTSpotterRecorderOpenEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 13:00'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Open Spotter'.! !

RTHorizontalLineLayout subclass: #GTAHorizontalDivingLineLayout
	instanceVariableNames: 'diveInLevel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 16:35'!
diveElement: eachElement
	^ (self diveInLevel cull: eachElement cull: self)
 			* self diveStep! !

!GTAHorizontalDivingLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/14/2015 12:33'!
diveElements: elements
	elements do: [ :eachElement | eachElement translateBy: 0 @ (self diveElement: eachElement) ]! !

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 16:37'!
diveInLevel
	^ diveInLevel ifNil: [ diveInLevel := self newDiveInLevel ]! !

!GTAHorizontalDivingLineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/17/2015 11:48'!
diveStep
	^ 5! !

!GTAHorizontalDivingLineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/17/2015 10:11'!
doExecute: elements
	super doExecute: elements.
	self diveElements: elements! !

!GTAHorizontalDivingLineLayout methodsFor: 'initialize-release' stamp: 'JurajKubelka 4/17/2015 14:53'!
initialize
	super initialize.
	horizontalGap := 2.
	self alignCenter.! !

!GTAHorizontalDivingLineLayout methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 16:38'!
newDiveInLevel
	^ [ :element | #diveInLevel cull: element model ]! !

GTAHorizontalDivingLineLayout subclass: #GTAHorizontalRealTimelineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAHorizontalRealTimelineLayout methodsFor: 'hook' stamp: 'JurajKubelka 4/17/2015 15:54'!
doExecute: elements
	| offset previousElement right left min minTime maxTime duration max |
	min := elements detectMin: [ :each | each position x ].
	elements do: [ :each | each translateTo: (min position x) @ (each position y) ].
	minTime := (elements detectMin: [ :each | each model dateAndTimeWithFixedTimeZone ]) model dateAndTimeWithFixedTimeZone.
	maxTime := (elements detectMax: [ :each | each model dateAndTimeWithFixedTimeZone ]) model dateAndTimeWithFixedTimeZone.
	duration := maxTime  - minTime.
	duration = 0 seconds
		ifTrue: [ max := 500 ]
		ifFalse: [ max := duration seconds * 8 ].
	RTMetricNormalizer new
		elements: elements;
		normalizeX: [ :eachEvent | self xFor: eachEvent ] min: 0 max: max.
	self diveElements: elements.
	previousElement := elements first.
	offset := 0.
	elements allButFirstDo: [ :element |
		right := previousElement encompassingRectangle right.
		left := element encompassingRectangle left.
		right > left
			ifTrue: [ offset := (right - left) rounded + 3 ]
			"ifFalse: [ offset := 0 ]".
		element translateBy: (offset @ 0).
		previousElement := element.
	 ].! !

!GTAHorizontalRealTimelineLayout methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 12:34'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:15'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTAEventIcons diveInCategoryIcon ]
			ifTrue: [ GTAEventIcons diveInCategoryMissStepIcon ]! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:24'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:59'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream nextPutAll: 'Dive In Category for '.
	aStream 
		print: self duration;
		nextPutAll: ': '.
	self categoryTitle
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString | 
			aStream nextPutAll: aString ].
	self eventTypePrintOn: aStream.
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:00'!
hasKnownName
	^ self categoryTitle notNil! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:01'!
hasName
	"In that case it is category title"
	^ true! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:46'!
isCategoryDiveIn
	^ true! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:30'!
removeSelectedElementEvent
	^ self removeInfoKey: #selectedElementEvent! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:31'!
selectedCategoryLabel
	^ self selectedElementEvent selectedCategoryLabel! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:31'!
selectedElementEvent
	^ self infoAt: #selectedElementEvent! !

!GTSpotterRecorderDiveInCategoryEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:30'!
selectedElementEvent: anEvent
	^ self infoAt: #selectedElementEvent put: anEvent! !

OrderedCollection subclass: #GTAActivityBuilders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAActivityBuilders methodsFor: 'adding' stamp: 'JurajKubelka 4/15/2015 16:03'!
addEdges
	self do: #addEdges! !

!GTAActivityBuilders methodsFor: 'building' stamp: 'JurajKubelka 4/16/2015 15:20'!
build
	self do: #build.
	self layoutSessions! !

!GTAActivityBuilders methodsFor: 'testing' stamp: 'JurajKubelka 4/15/2015 16:02'!
isWithEdges
	^ self anyOne isWithEdges! !

!GTAActivityBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:00'!
layout
	^ self anyOne layout! !

!GTAActivityBuilders methodsFor: 'layout' stamp: 'JurajKubelka 4/16/2015 15:19'!
layoutElements
	self do: #layoutElements.
	self layoutSessions! !

!GTAActivityBuilders methodsFor: 'layout' stamp: 'JurajKubelka 4/16/2015 15:19'!
layoutSessions
	| previousBuilder |
	self
		withIndexDo: [ :builder :index | 
			builder layoutElements.
			index > 1
				ifTrue: [ TRConstraint move: builder elements belowAlignFromLeft: previousBuilder elements gap: 20 ].
			previousBuilder := builder ]! !

!GTAActivityBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 15:59'!
logicalLayout
	self do: #logicalLayout! !

!GTAActivityBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:01'!
realLayout
	self do: #realLayout! !

!GTAActivityBuilders methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 4/16/2015 15:17'!
removeAllElementsAndEdges
	self do: #removeAllElementsAndEdges! !

!GTAActivityBuilders methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 16:02'!
removeEdges
	self do: #removeEdges! !

!GTAActivityBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 14:14'!
shape
	^ self collect: #shape as: GTAShapeBuilders! !

!GTAActivityBuilders methodsFor: 'signalling' stamp: 'JurajKubelka 4/15/2015 16:07'!
signalUpdate
	self ifEmpty: [ ^ self ].
	self view signalUpdate! !

!GTAActivityBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:58'!
view
	^ self anyOne view! !

!GTAActivityBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:08'!
withEdges
	self do: #withEdges! !

!GTAActivityBuilders methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 16:02'!
withoutEdges
	self do: #withoutEdges! !

OrderedCollection subclass: #GTAAnnouncements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 6/5/2015 16:21'!
fromByteArray: aByteArray
	^ self with: (GTSpotterEventRecorder materialize: aByteArray)! !

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 11:38'!
fromDirectory: aFileReference
	"self fromDirectory: './gt/events/' asFileReference"
	^ self 
		withAll: (GTSpotterEventRecorder materializeObjectsFromDirectory: aFileReference)! !

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 11:38'!
fromLocalDirectory
	GTATool ensureLocalDirectory.
	^ self fromDirectory: './gt/events/' asFileReference! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:08'!
spotterDevelopers
	"self spotterDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				developers
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 18:07'!
spotterUsers
	"self spotterUsers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				users
					sessionsPerComputer
						sessionsWithNumberOfInputsGreaterThenOne! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:10'!
spotterUsersAndDevelopers
	"self spotterUsersAndDevelopers"
	^ self fromLocalDirectory 
			withoutEmptyComputerUUID
				withoutEventsBeforePharo4Release
					sessionsPerComputer
						"sessionsWithNumberOfInputsGreaterThenOne"! !

!GTAAnnouncements class methodsFor: 'helpers' stamp: 'JurajKubelka 6/5/2015 16:20'!
spotterUsersAndDevelopersFrom: aByteArray
	^ (self fromByteArray: aByteArray) sessionsPerComputer
! !

!GTAAnnouncements class methodsFor: 'instance creation' stamp: 'JurajKubelka 6/8/2015 17:15'!
spotterUsersAndDevelopersFromAllByteArrays: aCollection 
	^ (self withAll: (aCollection collect: [ :eachByteArray | 
				GTSpotterEventRecorder materialize: eachByteArray ])) sessionsPerComputer! !

!GTAAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 11:45'!
developerUUIDs
	^ GTAConfiguration developerUUIDs! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:30'!
developers
	^ self select: [ :each | self developerUUIDs includes: each computerUUID asString ]! !

!GTAAnnouncements methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 12:42'!
numberOfComputers
	^ self perComputer size! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/11/2015 16:11'!
perComputer
	^ (self groupedBy: [ :each | each computerUUID asString]) as: GTAAnnouncements! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 6/4/2015 14:09'!
sessions
	^ GTASessionBuilder fromEvents: (
			self flatCollect: #events as: OrderedCollection)! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/29/2015 17:00'!
sessionsPerComputer
	| group computers |
	group := self perComputer.
	computers := group collect: [ :eachComputer |
		eachComputer sortByTimestamp.
		eachComputer sessions.
	] as: GTAComputers.
	computers := computers removeAllSuchThat: #isEmpty.
	computers do: [ :eachComputer | 
		eachComputer computers: computers.
		eachComputer sortByDateAndTime ].
	computers sortByDevelopersAndNumberOfSessions.
	computers updateEvents.
	^ computers! !

!GTAAnnouncements methodsFor: 'sorting' stamp: 'JurajKubelka 5/29/2015 16:33'!
sortByTimestamp
	^ self sort: [ :a :b | a timestamp < b timestamp ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 18:31'!
users
	^ self select: [ :each | (self developerUUIDs includes: each computerUUID asString) not ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 12:42'!
withoutEmptyComputerUUID
	^ self select: [ :each | each computerUUID notNil and: [ (each computerUUID = 'nil') not ] ]! !

!GTAAnnouncements methodsFor: 'enumerating' stamp: 'JurajKubelka 5/20/2015 10:30'!
withoutEventsBeforePharo4Release
	^ self select: [ :eachAnnouncement |
			eachAnnouncement latestUpdate >= GTAConfiguration pharo4HighestUpdate ]! !

OrderedCollection subclass: #GTABookmarks
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTABookmarks class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/13/2015 18:17'!
from: aCollection computers: aCollection2 
	^ (self new: aCollection size + 10)
			from: aCollection computers: aCollection2;
			yourself! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 12:36'!
addComputer: aGTAComputer description: aString 
	| item |
	item := self add: (GTAComputerBookmark new item: aGTAComputer; description: aString; yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 12:36'!
addSession: aGTASession description: aString 
	| item |
	item := self add: (GTASessionBookmark new item: aGTASession; description: aString; yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'adding' stamp: 'JurajKubelka 5/19/2015 17:10'!
addSomeSessions: aCollection description: aString 
	| item |
	item := self add: (GTASomeSessionsBookmark new
				item: aCollection;
				description: aString;
				yourself).
	self announcer announce: GTAItemAdded.
	^ item! !

!GTABookmarks methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 13:07'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GTABookmarks methodsFor: 'initialization' stamp: 'JurajKubelka 5/20/2015 11:07'!
from: aCollection computers: aGTAComputers
	aCollection do: [ :eachBookmarkPath | | bookmark |
		bookmark := GTABookmark from: eachBookmarkPath computers: aGTAComputers.
		self add: bookmark.
	]! !

!GTABookmarks methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:59'!
hasRelatedTo: anObject 
	^ self anySatisfy: [ :eachBookmark | eachBookmark isRelatedTo: anObject ]! !

!GTABookmarks methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 11:04'!
relatedTo: anObject 
	^ (self select: [ :eachBookmark | eachBookmark isRelatedTo: anObject ]) as: OrderedCollection! !

!GTABookmarks methodsFor: 'removing' stamp: 'JurajKubelka 5/14/2015 13:04'!
removeBookmark: aBookmark
	| item |
	item := self remove: aBookmark.
	self announcer announce: GTAItemRemoved.
	^ item! !

!GTABookmarks methodsFor: 'storing' stamp: 'JurajKubelka 5/14/2015 12:51'!
save
	GTAConfiguration saveBookmarks: self.
	self announcer announce: GTASaved! !

OrderedCollection subclass: #GTACollection
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:07'!
duration
	^ self end - self start! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 17:26'!
end
	^ (self detectMax: #end) ifNil: [ 0 ] ifNotNil: [ :obj | obj end ]! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key
	^ self optionAt: key ifAbsent: [ nil ]! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key ifAbsent: absentBlock
	options ifNil: [ ^ absentBlock value ].
	^ options at: key ifAbsent: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:11'!
optionAt: key ifAbsentPut: absentBlock
	options ifNil: [ options := Dictionary new ].
	^ options at: key ifAbsentPut: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:03'!
optionAt: key put: value
	options ifNil: [ options := Dictionary new ].
	^ options at: key put: value! !

!GTACollection methodsFor: 'removing' stamp: 'JurajKubelka 5/27/2015 10:46'!
removeOptionKey: key 
	^ self removeOptionKey: key ifAbsent: [ "ignore" ]! !

!GTACollection methodsFor: 'removing' stamp: 'JurajKubelka 5/27/2015 10:46'!
removeOptionKey: key ifAbsent: absentBlock
	options ifNil: [ ^ absentBlock value].
	^ options removeKey: key ifAbsent: absentBlock! !

!GTACollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 17:26'!
start
	^ (self detectMin: #start) ifNil: [ 0 ] ifNotNil: [ :obj | obj start ]! !

GTACollection subclass: #GTAEventCollection
	uses: TGTABookmarkIt + TGTSpotterCategoryView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTAEventCollection class
	uses: TGTABookmarkIt classTrait + TGTSpotterCategoryView classTrait
	instanceVariableNames: ''!

!GTAEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/26/2015 15:38'!
categoryLabel
	^ self optionAt: #categoryLabel! !

!GTAEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/26/2015 15:38'!
categoryLabel: aString 
	^ self optionAt: #categoryLabel put: aString! !

!GTAEventCollection methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:33'!
computerUUID
	self ifEmpty: [ ^ 0 ].
	^ self any computerUUID! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:40'!
contextChanges
	^ self select: #isContextChanged! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:14'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:24'!
divesOut
	^ self select: #isDiveOut! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 11:55'!
finishedSearches
	^ self select: #isSearchFinished! !

!GTAEventCollection methodsFor: 'testing' stamp: 'JurajKubelka 4/9/2015 10:51'!
hasMissSteps
	^ self missSteps notEmpty! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/14/2015 17:44'!
humanReadablePrintString
	"Return a String with a human readable representation of me"
	^ String streamContents: [ :out | 
		self printHumanReadableOn: out ]! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:40'!
numberOfContextChanged
	^ self contextChanges size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 12:15'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesIn
	^ self divesIn size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:24'!
numberOfDivesOut
	^ self divesOut size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/30/2015 11:54'!
numberOfFinishedSearches
	^ self finishedSearches size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 4/9/2015 10:52'!
numberOfMissSteps
	^ self missSteps size! !

!GTAEventCollection methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 19:43'!
numberOfUserSelections
	^ self userSelections size! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
sessionPopupText
	^ String streamContents: [ :aStream |
			self sessionPopupTextOn: aStream
		 ]! !

!GTAEventCollection methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
sessionPopupTextOn: aStream
	aStream
		nextPutAll: 'Duration: ';
		print: self duration;
		cr;
		nextPutAll: 'Events: ';
		print: self size;
		cr;
		nextPutAll: 'Number of user input changes: ';
		print: self numberOfContextChanged;
		cr;
		nextPutAll: 'Number of different search strings: ';
		print: self numberOfDifferentSearchStrings;
		cr;
		nextPutAll: 'Number of finished searches: ';
		print: self numberOfFinishedSearches;
		cr;
		nextPutAll: 'Number of user item selections: ';
		print: self numberOfUserSelections;
		cr;
		nextPutAll: 'Dive in/out: ';
		print: self numberOfDivesIn;
		nextPut: $/;
		print: self numberOfDivesOut;
		cr;
		"using of #i, etc."
		nextPutAll: (self isWithPreview ifTrue: [ 'With Preview' ] ifFalse: [ 'Without Preview' ])! !

!GTAEventCollection methodsFor: 'enumerating' stamp: 'JurajKubelka 3/29/2015 19:44'!
userSelections
	^ self select: #isUserSelection! !

GTAEventCollection subclass: #GTASession
	uses: TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASession class
	uses: TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 6/4/2015 14:13'!
activityView
	| builder |
	builder := GTAActivityBuilder new.
	builder 
		configuration: GTADefaultTimelineConfiguration uniqueInstance;
		events: self;
		build.
	GTAActivityMenuBuilder new timelineBuilder: builder; build.
	builder view canvas focusOnCenterScaled.
	^ builder view.! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 6/4/2015 14:18'!
activityView3
	"obsolete"
	^ GTAObsoleteActivityBuilder viewOn: self! !

!GTASession methodsFor: 'enumerating - events' stamp: 'JurajKubelka 6/4/2015 17:30'!
anyEventSatisfy: aBlock
	^ self anySatisfy: aBlock! !

!GTASession methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 10:42'!
bookmarkIt
	self bookmarks
		addSession: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTASession methodsFor: 'api' stamp: 'JurajKubelka 5/28/2015 10:32'!
bookmarkIt: descriptionString
	self bookmarks
		addSession: self
		description: descriptionString;
		save! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:40'!
bookmarks
	^ self computer bookmarks ! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:47'!
categoryLabels
	^ self categorySelections collect: #categoryLabel as: OrderedCollection! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 17:45'!
categorySelections
	^ self select: #isCategorySelection! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 10:50'!
closeActionSymbol
	self ifEmpty: [ ^ #empty ].
	^ self last closeActionSymbol! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 4/20/2015 11:28'!
computer
	^ self optionAt: #computer! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 4/20/2015 11:28'!
computer: aGTSpotterComputer
	^ self optionAt: #computer put: aGTSpotterComputer! !

!GTASession methodsFor: 'comparing' stamp: 'JurajKubelka 4/9/2015 20:19'!
deepestDiveIn
	^ self max: #diveInLevel! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 14:21'!
divesIn
	^ self select: #isDiveIn! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:08'!
end
	self ifEmpty: [ ^ 0 ].
	^ self last dateAndTimeWithFixedTimeZone! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorActivityView3In: composite
	<gtInspectorPresentationOrder: -5>
	"obsolete"
	composite roassal2
		title: 'Activity 3';
		initializeView: [ self activityView3 ]
		! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorActivityViewIn: composite
	<gtInspectorPresentationOrder: -6>
	composite roassal2
		title: 'Activity';
		initializeView: [ self activityView ]
		! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 6/4/2015 14:19'!
gtInspectorEventsIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Events';
		display: [ :aSession | aSession ];
		column: 'Event' 
			evaluated: [ :each | each asEventAnalysisString ] width: 400;
		column: 'Time' 
			evaluated: [ :each | GTAPrintDateAndTime yyyyMmDdAndHhMmSs: each dateAndTimeWithFixedTimeZone ]
			width: 120;
		withSmalltalkSearch;
		helpMessage: 'Given your INPUT, it executes: self select: [:each | INPUT ]';
		showOnly: 200! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 3/31/2015 13:53'!
gtInspectorStrangeEventsIn: composite
	<gtInspectorPresentationOrder: 9>  
	^ (composite tree)
		title: 'Strange';
		display: [ :aSession | aSession select: #isStrange ];
		children: [ :eachChild |
			eachChild isString 
				ifTrue: [ #() ]
				ifFalse: [ eachChild strange ] ];
		format: [ :eachEvent | 
			eachEvent isString 
				ifTrue: [ eachEvent ]
				ifFalse: [ eachEvent asEventAnalysisString, 
								' with ', eachEvent strange size asString, ' strange observations.' ] ]! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 15:29'!
gtInspectorTreeEventsIn: composite
	<gtInspectorPresentationOrder: -8>  
	^ (composite tree)
		title: 'Tree';
		display: [ :aSession | aSession roots ];
		children: [ :eachChild |
			eachChild children ];
		format: [ :eachEvent | eachEvent asEventAnalysisString ]
		! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 16:29'!
hasDelayedExit
	^ self optionAt: #hasDelayedExit ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:53'!
hasSpecialKeywords
	^ self anySatisfy: [ :each | each isContextChanged and: [ each hasCurrentTextSpecials ] ]! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/29/2015 17:19'!
imageHashes
	^ (self collect: #imageHash as: OrderedCollection) removeDuplicates! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 17:44'!
isComplexSession
	^ self isFirstLevelDiveInSession not and: [ 
		self isDirectSession not and: [ 
			self isEmptySession not and: [ 
				self hasDelayedExit not ] ] ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 16:09'!
isDirectSession
	^ self optionAt: #isDirectSession ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 10:49'!
isEmptySession
	^ self optionAt: #isEmptySession ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 5/27/2015 17:06'!
isFirstLevelDiveInSession
	^ self optionAt: #isFirstLevelDiveInSession ifAbsent: [ false ]! !

!GTASession methodsFor: 'testing' stamp: 'JurajKubelka 3/29/2015 18:45'!
isWithPreview
	^ (self contains: #isShowPreview) and: [ 
			(self contains: #isHidePreview) not ]! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 12:02'!
missSteps
	| collection |
	collection := self select: #isMissStep.
	collection computer: self computer.
	^ collection! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:50'!
previewString
	^ self isWithPreview
		ifTrue: [ 'yes' ]
		ifFalse: [ 'no' ]! !

!GTASession methodsFor: 'printing' stamp: 'JurajKubelka 5/13/2015 16:07'!
printHumanReadableOn: aStream 
	self sessionPopupTextOn: aStream! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:29'!
removeHasDelayedExit
	^ self removeOptionKey: #hasDelayedExit! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:06'!
removeIsDirectSession
	^ self removeOptionKey: #isDirectSession! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 10:47'!
removeIsEmptySession
	^ self removeOptionKey: #isEmptySession! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 17:01'!
removeIsFirstLevelDiveInSession
	^ self removeOptionKey: #isFirstLevelDiveInSession! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 17:00'!
removeIsOneDiveInSession
	^ self removeOptionKey: #isOneDiveInSession! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 13:04'!
roots
	^ self select: #isRootEvent! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 13:10'!
searchStrings
	^ ((self select: #isContextChanged)
			flatCollect: #currentTextHashes as: Bag)! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/27/2015 10:56'!
select: aBlock
	| newCollection |
	newCollection := super select: aBlock.
	newCollection computer: self computer.
	^ newCollection! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/28/2015 14:52'!
selectedCategoryLabel
	^ self last selectedCategoryLabel! !

!GTASession methodsFor: 'enumerating - sessions' stamp: 'JurajKubelka 6/9/2015 13:55'!
sessions
	^ Array with: self! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/26/2015 15:40'!
sessionsPerCategoryLabel
	| labels col |
	labels := ((self select: #isCategorySelection) collect: #categoryLabel as: OrderedCollection) removeDuplicates.
	col := labels collect: [ :eachLabel | self categoryLabel: eachLabel; yourself ] as: GTASomeSessions.
	col computer: self computer.
	^ col! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:05'!
setDirectSession
	self optionAt: #isDirectSession put: true! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 16:28'!
setHasDelayedExit
	self optionAt: #hasDelayedExit put: true! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 10:48'!
setIsEmptySession
	self optionAt: #isEmptySession put: true! !

!GTASession methodsFor: 'initialization' stamp: 'JurajKubelka 5/27/2015 17:06'!
setIsFirstLevelDiveInSession
	self optionAt: #isFirstLevelDiveInSession put: true! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:57'!
specialKeywords
	^ self select: [ :each | each isContextChanged and: [ each hasCurrentTextSpecials ] ]! !

!GTASession methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 16:08'!
start
	self ifEmpty: [ ^ 0 ].
	^ self first dateAndTimeWithFixedTimeZone! !

!GTASession methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 16:04'!
timelineView2
	^ self activityView! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 12:33'!
unknownNames
	^ self select: #hasUnknownName! !

!GTASession methodsFor: 'update' stamp: 'JurajKubelka 6/4/2015 14:09'!
updateEvents
	^ GTASessionAnalysis updateOn: self! !

!GTASession methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:45'!
userQueryOrSelectionHashes
	^ self flatCollect: #userQueryOrSelectionHashes as: OrderedCollection ! !

GTAEventCollection subclass: #GTASomeSessions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASomeSessions subclass: #GTAComputer
	uses: TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTAComputer class
	uses: TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTAComputer methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 12:23'!
bookmarkIt
	self bookmarks
		addComputer: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 10:41'!
bookmarks
	^ self computers bookmarks! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/26/2015 11:48'!
computer
	^ self! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:52'!
computers
	^ self optionAt: #computers! !

!GTAComputer methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:52'!
computers: aCollection 
	^ self optionAt: #computers put: aCollection! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/31/2015 15:28'!
differentSearchStrings
	^ self searchStrings asSet! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 15:35'!
flatCollectEvents: aBlock 
	^ self flatCollect: [ :eachSession | eachSession select: aBlock ] as: OrderedCollection! !

!GTAComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/12/2015 00:27'!
hasSessionsWithSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'testing' stamp: 'JurajKubelka 4/11/2015 23:54'!
hasSpecialKeywords
	^ self anySatisfy: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self select: [ :each | each numberOfContextChanged > anInteger ]! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 16:22'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/11/2015 23:59'!
sessionsWithSpecialKeywords
	^ self select: #hasSpecialKeywords! !

!GTAComputer methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:43'!
updateEvents
	^ self do: #updateEvents! !

!GTAComputer methodsFor: 'enumerating' stamp: 'JurajKubelka 4/20/2015 14:44'!
userQueryOrSelectionHashes
	^ self flatCollect: #userQueryOrSelectionHashes as: OrderedCollection! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 6/4/2015 14:14'!
activityView
	| composer builders |
	composer := RTComposer new.
	composer view @ RTZoomableView.
	self ifEmpty: [ ^ composer view ].
	builders := GTAActivityBuilders new.
	1 to: (self size min: 100) do: [ :index | | builder |
		builder := GTAActivityBuilder new.
		builder 
			view: composer view;
			configuration: GTADefaultTimelineConfiguration uniqueInstance;
			events: (self at: index);
			build.
		composer group: index.
		index > 1 ifTrue: [ composer move: index belowAlignFromLeft: index - 1 ].
		builders add: builder.
	 ].
	GTAActivityMenuBuilder new timelineBuilder: builders; build.
	composer view canvas focusOnCenterScaled.
	^ composer view.! !

!GTASomeSessions methodsFor: 'enumerating - events' stamp: 'JurajKubelka 6/4/2015 17:32'!
anyEventSatisfy: aBlockClosure 
	^ self anySatisfy: [ :eachSession | eachSession anyEventSatisfy: aBlockClosure ]! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
avgNumberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesIn) / self size! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
avgNumberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ (self sum: #numberOfDivesOut) / self size! !

!GTASomeSessions methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 17:07'!
bookmarkIt
	self bookmarks
		addSomeSessions: self
		description: 'Added at ', DateAndTime now rounded asString;
		save! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
bookmarks
	^ self computer bookmarks! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 18:07'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
computer
	^ self optionAt: #computer! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:53'!
computer: aCollection 
	^ self optionAt: #computer put: aCollection! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 14:23'!
divesIn
	^ self flatCollect: #divesIn as: OrderedCollection! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:11'!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:10'!
gtInspectorActivityViewIn: composite
	<gtInspectorPresentationOrder: -6>
	composite roassal2
		title: 'Activity';
		initializeView: [ self activityView ]
		! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:11'!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: -1>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:12'!
gtInspectorSessionsIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Sessions';
		display: [ :aComputer | aComputer ];
		column: 'Start' 
			evaluated: [ :each | String streamContents: [ :aStream | | start |
											start := each start.
											start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [
													start asUTC printYMDOn: aStream.
													aStream nextPutAll: ', '.
													start asUTC printHMSOn: aStream ] ] ]
			width: 120;
		column: 'Duration' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration ] width: 67;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] width: 50;
		column: 'Preview' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each previewString ]
			width: 57;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 67;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Fin. Searches' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 83;
		column: 'Selections' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfUserSelections ]
			width: 70;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Close' 
			evaluated: [ :each | each closeActionSymbol ]
			width: 63;
		column: 'Image Hashes' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each imageHashes size ]
			width: 70;
		beMultiple;
		send: [ :result | GTAMultipleSelectionSendCommand selection: result in: self ];
		showOnly: 200! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/14/2015 18:08'!
gtInspectorTimelineViewIn: composite
	<gtInspectorPresentationOrder: -8>
	composite roassal2
		title: 'Timeline';
		initializeView: [ self timelineView ]
		! !

!GTASomeSessions methodsFor: 'testing' stamp: 'JurajKubelka 5/19/2015 15:04'!
isDeveloper
	^ GTAConfiguration isDeveloper: self computerUUID! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 15:06'!
missSteps
	^ self flatCollect: #missSteps as: GTASession! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfDifferentSearchStrings
	^ self differentSearchStrings size! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfDivesIn
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesIn	! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfDivesOut
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfDivesOut! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfEvents
	self ifEmpty: [ ^ 0 ].
	^ self sum: #size! !

!GTASomeSessions methodsFor: 'helpers' stamp: 'JurajKubelka 5/19/2015 15:05'!
numberOfPreviews
	^ self sessionsWithPreview size! !

!GTASomeSessions methodsFor: 'printing' stamp: 'JurajKubelka 5/26/2015 14:19'!
printHumanReadableOn: aStream
	| duration |
	aStream 
		nextPutAll: (self size pluralize: 'session');
		nextPutAll: ' from '; 
		print: self start asDate; 
		cr;
		nextPutAll: ' during '. 
	duration := self duration.
	self duration > 1 second ifTrue: [ duration := self duration truncateTo: 1 milliseconds ].
	self duration > 1 minute ifTrue: [ duration := self duration truncateTo: 1 second ].
	self duration > 1 hour ifTrue: [ duration := self duration truncateTo: 1 minute ].
	self duration > 1 day ifTrue: [ duration := self duration truncateTo: 1 hour ].
	duration printHumanReadableOn: aStream.
	aStream
		cr;
		print: self specialKeywords size; nextPutAll: ' special keywords'; cr;
		print: self divesIn size; nextPutAll: ' dives-in'; cr;
		print: self unknownNames size; nextPutAll: ' unknown items'
		! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 15:05'!
searchStrings
	^ self flatCollect: #searchStrings as: Bag! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 6/1/2015 11:37'!
sessionTypeString
	^ self optionAt: #sessionTypeString! !

!GTASomeSessions methodsFor: 'initialization' stamp: 'JurajKubelka 6/1/2015 11:36'!
sessionTypeString: aString 
	^ self optionAt: #sessionTypeString put: aString! !

!GTASomeSessions methodsFor: 'enumerating - sessions' stamp: 'JurajKubelka 6/9/2015 13:55'!
sessions
	^ self! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/26/2015 11:20'!
sessionsPerCategoryLabel
	| dictionary |
	dictionary := Dictionary new.
	self  
		select: [ :eachSession | eachSession anySatisfy: #isCategorySelection ]
		thenDo: [ :eachSession | 
			eachSession categoryLabels asSet do: [ :eachLabel |
				dictionary 
					at: eachLabel
					ifPresent: [ :aCollection | aCollection add: eachSession ]
					ifAbsent: [ dictionary 
										at: eachLabel 
										put: (GTASomeSessions new
													add: eachSession;
													categoryLabel: eachLabel;
													computer: self computer;
													yourself) ] ] ].
	^ dictionary associations 
		collect: #value
		as: GTASomeSessions! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/28/2015 15:23'!
sessionsPerSelectedCategoryLabel
	| dictionary col |
	dictionary := Dictionary new.
	self 
		do: [ :eachSession | | label |
			label := eachSession selectedCategoryLabel.
			dictionary 
				at: label
				ifPresent: [ :aCollection | aCollection add: eachSession ]
				ifAbsent: [ dictionary 
									at: label 
									put: (GTASomeSessions new
												add: eachSession;
												categoryLabel: label;
												computer: self computer;
												yourself) ] ].
	col := dictionary associations 
				collect: #value
				as: GTASomeComputers.
	col computers: self computers.
	^ col! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 15:05'!
sessionsWithPreview
	^ self select: #isWithPreview! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 6/1/2015 11:45'!
sizeInPercent
	^ (self size / self computers sessions size * 100)! !

!GTASomeSessions methodsFor: 'sorting' stamp: 'JurajKubelka 5/29/2015 16:36'!
sortByDateAndTime
	self sort: [ :a :b | a start < b start ]! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/18/2015 15:39'!
specialKeywords
	^ self flatCollect: #specialKeywords as: OrderedCollection! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/14/2015 17:47'!
spentTime
	self ifEmpty: [ ^ 0 seconds ].
	^ self sum: #duration! !

!GTASomeSessions methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/29/2015 16:42'!
timelineView
	| builder minTime dataSetBuilder set objects |
	builder := RTTimeline new.
	minTime := self start asUnixTime.
	self size > 15 
		ifTrue: [ 
			dataSetBuilder := GTARoughDataSetBuilder new
				gap: self duration / 108;
				setSessionComparator;
				newGroupBlock: [ GTASomeSessions new computer: self; yourself ];
				yourself.
			dataSetBuilder objects: self copy sortByDateAndTime; build.
			objects := dataSetBuilder groups collect: [ :eachGroup |
				eachGroup size = 1 ifTrue: [ eachGroup any ] ifFalse: [ eachGroup ] ] ]
		ifFalse: [ objects := self ].
	set := RTTimelineSet new.
	set 
		lineIdentifier: 1;
		objects: objects;
		start: [ :eachSession | eachSession start asUnixTime - minTime ];
		end: [ :eachSession | eachSession end asUnixTime - minTime ].
	set interaction popupText: #humanReadablePrintString.
	set shape color: (RTMultiLinearColorForIdentity new objects: objects).
	builder add: set.
	builder axisX 
		numberOfLabels: 5;
		labelRotation: -45;
		labelConversion: [ :unixTime | 
			GTADateAndTimeStringBuilder new
				dateAndTime: (DateAndTime fromUnixTime: unixTime + minTime);
				duration: self duration;
				numberOfLabels: 5;
				humanReadablePrintString ].
	builder timelineLabel: ''.
	builder build.
	GTAMenuTimelineBuilder new timelineBuilder: builder; build.
	^ builder ! !

!GTASomeSessions methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 12:35'!
unknownNames
	^ self flatCollect: #unknownNames as: OrderedCollection! !

!GTASomeSessions methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:03'!
userOrDeveloperString
	^ self isDeveloper
			ifTrue: [ 'dev' ]
			ifFalse: [ 'user' ]! !

GTACollection subclass: #GTASessions
	uses: TGTSpotterDurationView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASessions class
	uses: TGTSpotterDurationView classTrait
	instanceVariableNames: ''!

!GTASessions methodsFor: 'gt-inspector-extension' stamp: ''!
durationView
	| b ds |
	b := RTGrapher new.
	b extent: 500 @ 100.
	self ifEmpty: [ ^ b view ].
	ds := RTStackedDataSet new.
	ds interaction highlight.
	ds interaction popup text: [ :obj | obj sessionPopupText ].
	ds points: self.
	ds barShape 
			color: [ :obj | obj isWithPreview 
				ifTrue: [ Color green alpha: 0.3 ]
				ifFalse: [ Color blue alpha: 0.3 ] ]; 
			width: 10.
	ds y: [ :c | c duration asSeconds ].
	b add: ds.
	b axisX noTick; noLabel.
	b axisY.
	b build.
	^ b view.
	! !

!GTASessions methodsFor: 'gt-inspector-extension' stamp: ''!
gtInspectorDurationViewIn: composite
	<gtInspectorPresentationOrder: 5>
	composite roassal2
		title: 'Duration';
		initializeView: [ self durationView ]
		! !

!GTASessions methodsFor: 'helpers' stamp: 'JurajKubelka 3/29/2015 11:20'!
numberOfEvents
	^ self sum: #size! !

!GTASessions methodsFor: 'enumerating' stamp: 'JurajKubelka 3/30/2015 10:37'!
sessions
	^ self! !

GTACollection subclass: #GTASomeComputers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTASomeComputers subclass: #GTAComputers
	uses: TGTSpotterUpdateEvents
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Core'!

GTAComputers class
	uses: TGTSpotterUpdateEvents classTrait
	instanceVariableNames: ''!

!GTAComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 18:13'!
bookmarks
	^ self optionAt: #bookmarks ifAbsentPut: [ GTAConfiguration loadBookmarks: self ]! !

!GTAComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/19/2015 14:35'!
gtInspectorBookmarksIn: composite
	<gtInspectorPresentationOrder: 9>
	(composite table)
		title: 'Bookmarks';
		display: [ :aComputers | aComputers bookmarks ];
		column: 'Type'
			evaluated: [ :each | each typeName ]
			width: 57;
		column: 'Garbage'
			evaluated: [ :each | each garbageString ]
			width: 57;
		column: 'Description'
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each description asString ];
		act: [ :aPresentation :aComputers | aComputers saveBookmarks ]
			icon: Smalltalk ui icons glamorousSave
			entitled: 'Save bookmarks';
		selectionPopulate: #selection
			entitled: 'Open bookmark'
			with: [ :aTable | aTable rawSelection gtInspectorInterestingObject ];
		selectionAct: [ :list :bookmark | 
				self toggleGarbage: list rawSelection.
				list update ]
			entitled: 'Toggle garbage';
		selectionAct: [ :list :bookmark | 
				self removeBookmark: list rawSelection.
				list update ]
			entitled: 'Remove bookmark';
		updateOn: GTACollectionAnnouncement 
			from: [ :aComputers | aComputers bookmarks announcer ];
		send: [ :result | result ifNotNil: [ result item ] ];
		showOnly: 50 ! !

!GTAComputers methodsFor: 'bookmarks' stamp: 'JurajKubelka 5/19/2015 10:35'!
removeBookmark: aGTABookmark 
	self bookmarks 
		removeBookmark: aGTABookmark;
		save.! !

!GTAComputers methodsFor: 'bookmarks' stamp: 'JurajKubelka 5/13/2015 18:42'!
saveBookmarks
	self bookmarks ifNotEmpty: [ self bookmarks save ]! !

!GTAComputers methodsFor: 'bookmarks' stamp: 'JurajKubelka 5/19/2015 10:28'!
toggleGarbage: aGTASessionBookmark 
	aGTASessionBookmark toggleGarbage.
	self saveBookmarks.! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
categoryLabels
	^ self flatCollect: #categoryLabels as: OrderedCollection! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
computerUUIDs
	^ self collect: #computerUUID as: OrderedCollection! !

!GTASomeComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:51'!
computers
	^ self optionAt: #computers! !

!GTASomeComputers methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:51'!
computers: aCollection 
	^ self optionAt: #computers put: aCollection! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
computersAndOnlySessionsWithSpecialKeywords
	^ self 
		select: [ :computer | computer hasSessionsWithSpecialKeywords ]
		thenCollect: [ :computer | 
			computer sessionsWithSpecialKeywords	]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 14:23'!
divesIn
	^ self flatCollect: #divesIn as: OrderedCollection! !

!GTASomeComputers methodsFor: 'enumerating - events' stamp: 'JurajKubelka 5/13/2015 19:43'!
flatCollectEvents: aBlock 
	^ self flatCollect: [ :eachComputer | eachComputer flatCollectEvents: aBlock ] as: OrderedCollection! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/20/2015 10:42'!
gtInspectorComputersIn: composite
	<gtInspectorPresentationOrder: -10>  
	^ (composite table)
		title: 'Computers';
		display: [ :aComputer | aComputer ];
		column: 'Since' 
			evaluated: [ :each | String streamContents: [ :aStream | 
											each start = 0 
												ifTrue: [ aStream nextPutAll: 'unknown' ]
												ifFalse: [ each start asUTC printYMDOn: aStream ] ] ]
			width: 67;
		column: 'Days' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each duration asDuration asDays rounded ] 
			width: 40;
		column: 'Spent' 
			evaluated: [ :each | each spentTime ] 
			width: 63;
		column: 'User' 
			evaluated: [ :each | each userOrDeveloperString ] 
			width: 50;
		column: 'Sessions' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each size ] 
			width: 60;
		column: 'Events' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfEvents ] 
			width: 50;
		column: 'Previews' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfPreviews ] 
			width: 60;
		column: 'Inputs' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfContextChanged ]
			width: 47;
		column: 'Diff Inp.' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDifferentSearchStrings ]
			width: 53;
		column: 'Dives In' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesIn ]
			width: 53;
		column: 'Dives Out' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each numberOfDivesOut ]
			width: 63;
		column: 'Avg. D-In' 
			evaluated: [ :each | (each avgNumberOfDivesIn printShowingDecimalPlaces: 2)]
			width: 60;
		column: 'Avg. D-Out' 
			evaluated: [ :each | (each avgNumberOfDivesOut printShowingDecimalPlaces: 2) ]
			width: 67;
		column: 'MissSteps' 
			evaluated: [ :each | each numberOfMissSteps ]
			width: 60;
		beMultiple;
		send: [ :result | GTAMultipleSelectionSendCommand selection: result in: self as: GTASomeComputers ];
		showOnly: 100! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 6/9/2015 15:29'!
gtInspectorSessionClassificationIn: composite
	<gtInspectorPresentationOrder: -5>  
	^ (composite table)
		title: 'Classification';
		display: [ :aComputers | aComputers perSessionType ];
		column: 'Type' 
			evaluated: [ :each | each sessionTypeString ]
			width: 100;
		column: 'Count' 
			evaluated: [ :each | each size ] 
			width: 50
			tags: #()
			sortedBy: [ :aComputer1 :aComputer2 | aComputer1 size > aComputer2 size ];
		column: '%' 
			evaluated: [ :each | each sizeInPercent asFloat rounded ] 
			width: 30;
		column: 'Mean Duration' 
			evaluated: [ :each | self meanDurationFor: each ] 
			width: 97;
		column: 'Min Duration' 
			evaluated: [ :each | self minDurationFor: each ] 
			width: 97;
		column: 'Max Duration' 
			evaluated: [ :each | self maxDurationFor: each ] 
			width: 97;
		showOnly: 100! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 5/20/2015 15:20'!
gtInspectorTimelineViewIn: composite
	<gtInspectorPresentationOrder: -8>
	composite roassal2
		title: 'Timeline';
		initializeView: [ self timelineView ]
		! !

!GTASomeComputers methodsFor: 'enumerating - computer' stamp: 'JurajKubelka 6/9/2015 15:29'!
maxDurationFor: aComputer
	aComputer ifEmpty: [ ^ 0 seconds ].
	^ (aComputer max: #duration) roundTo: 1 second! !

!GTASomeComputers methodsFor: 'enumerating - computer' stamp: 'JurajKubelka 6/9/2015 15:27'!
meanDurationFor: aComputer
	aComputer ifEmpty: [ ^ 0 seconds ].
	^ ((aComputer collect: #duration as: OrderedCollection) sum / aComputer size) roundTo: 1 second! !

!GTASomeComputers methodsFor: 'enumerating - computer' stamp: 'JurajKubelka 6/9/2015 15:29'!
minDurationFor: aComputer
	aComputer ifEmpty: [ ^ 0 seconds ].
	^ (aComputer detectMin: #duration) duration roundTo: 1 second! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
missSteps
	^ self flatCollect: #missSteps as: GTASession! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfContextChanged
	self ifEmpty: [ ^ 0 ].
	^ self sum: #numberOfContextChanged ! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfEvents
	^ self sum: [ :each | each numberOfEvents ]! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfMissSteps
	^ self missSteps size! !

!GTASomeComputers methodsFor: 'helpers' stamp: 'JurajKubelka 5/13/2015 19:43'!
numberOfSessions
	^ self sum: [ :each | each size ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 6/1/2015 13:52'!
perSessionType
	| results |
	results := GTACollection new.
	results add: (((self sessions select: #isEmptySession) as: GTAComputer) computers: self; sessionTypeString: 'Empty'; yourself).
	results add: (((self sessions select: #isDirectSession) as: GTAComputer) computers: self; sessionTypeString: 'Direct'; yourself).
	results add: (((self sessions select: #isFirstLevelDiveInSession) as: GTAComputer) computers: self; sessionTypeString: 'First Level Dive-In'; yourself).
	results add: (((self sessions select: #hasDelayedExit) as: GTAComputer) computers: self; sessionTypeString: 'Delayed Exit'; yourself).
	results add: (((self sessions select: #isComplexSession) as: GTAComputer) computers: self; sessionTypeString: 'Complex'; yourself).
	^ results! !

!GTASomeComputers methodsFor: 'enumerating - events' stamp: 'JurajKubelka 6/1/2015 15:12'!
selectComputersWithEvents: aBlock
	^ self select: [ :eachComputer | eachComputer anySatisfy: [ :eachSession | eachSession anySatisfy: aBlock ] ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 6/1/2015 15:06'!
selectComputersWithSessions: aBlock
	^ self select: [ :eachComputer | eachComputer select: aBlock ]! !

!GTASomeComputers methodsFor: 'enumerating - events' stamp: 'JurajKubelka 6/1/2015 15:28'!
selectSessionsPerComputerWithEvents: aBlock
	| someComputers |
	someComputers := (self 
		collect: [ :eachComputer | | newComputer |
			newComputer := eachComputer select: [ :eachSession | eachSession anySatisfy: aBlock ].
			(newComputer as: GTASomeSessions) computer: eachComputer computer; yourself ]
		as: GTASomeComputers)
		select: #notEmpty.
	someComputers computers: self computers.
	^ someComputers! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessions
	^ self flatCollect: #yourself as: GTASessions! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessionsWithNumberOfInputsGreaterThen: anInteger
	^ self collect: [ :each | each copy sessionsWithNumberOfInputsGreaterThen: anInteger ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
sessionsWithNumberOfInputsGreaterThenOne
	^ self sessionsWithNumberOfInputsGreaterThen: 1! !

!GTASomeComputers methodsFor: 'sorting' stamp: 'JurajKubelka 5/29/2015 15:37'!
sortByDevelopersAndDuration
	self sort: [ :a :b | | duration |
		duration := a duration > b duration.
		(a isDeveloper and: [ duration ]) or: [ 
			(b isDeveloper not and: [ duration ]) or: [ 
				a isDeveloper and: [ b isDeveloper not and: [ duration not ] ] ] ] ]! !

!GTASomeComputers methodsFor: 'sorting' stamp: 'JurajKubelka 5/29/2015 17:00'!
sortByDevelopersAndNumberOfSessions
	self sort: [ :a :b | | bigger |
		bigger := a size > b size.
		(a isDeveloper and: [ bigger ]) or: [ 
			(b isDeveloper not and: [ bigger ]) or: [ 
				a isDeveloper and: [ b isDeveloper not and: [ bigger not ] ] ] ] ]! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/13/2015 19:43'!
specialKeywords
	^ self flatCollect: #specialKeywords as: OrderedCollection! !

!GTASomeComputers methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 6/4/2015 14:34'!
timelineView
	^ GTATimelineBuilder new computers: self; build; menu; view.! !

!GTASomeComputers methodsFor: 'enumerating' stamp: 'JurajKubelka 5/19/2015 12:35'!
unknownNames
	^ self flatCollect: #unknownNames as: OrderedCollection! !

!GTASomeComputers methodsFor: 'update' stamp: 'JurajKubelka 5/13/2015 19:43'!
updateEvents
	^ self do: #updateEvents! !

OrderedCollection subclass: #GTAGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:27'!
duration
	^ self end - self start! !

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:01'!
end
	^ self last end! !

!GTAGroup methodsFor: 'printing' stamp: 'JurajKubelka 5/14/2015 17:10'!
humanReadablePrintString
	"Return a String with a human readable representation of me"
	^ String streamContents: [ :out | 
		self printHumanReadableOn: out ]! !

!GTAGroup methodsFor: 'printing' stamp: 'JurajKubelka 5/18/2015 11:28'!
printHumanReadableOn: aStream
	| duration |
	aStream 
		nextPutAll: (self size pluralize: 'event');
		nextPutAll: ' from '; 
		print: self start asDate; 
		cr;
		nextPutAll: ' during '. 
	duration := self duration.
	self duration > 1 second ifTrue: [ duration := self duration truncateTo: 1 milliseconds ].
	self duration > 1 minute ifTrue: [ duration := self duration truncateTo: 1 second ].
	self duration > 1 hour ifTrue: [ duration := self duration truncateTo: 1 minute ].
	self duration > 1 day ifTrue: [ duration := self duration truncateTo: 1 hour ].
	duration printHumanReadableOn: aStream! !

!GTAGroup methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 10:00'!
start
	^ self first start! !

OrderedCollection subclass: #GTAGroups
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

OrderedCollection subclass: #GTAShapeBuilders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	self do: #flexibleResultShapes! !

!GTAShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/15/2015 16:12'!
oblique
	self do: #oblique! !

!GTAShapeBuilders methodsFor: 'shapes' stamp: 'JurajKubelka 4/15/2015 16:04'!
orthogonal
	self do: #orthogonal! !

!GTAShapeBuilders methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:08'!
shape
	self ifEmpty: [ ^ nil ].
	^ self anyOne shape! !

RTBuilder subclass: #GTAActivityBuilder
	instanceVariableNames: 'events elements eventAnalyzer eventFilter analyze edges edgeShapeBuilder withEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAActivityBuilder class methodsFor: 'api' stamp: 'JurajKubelka 4/13/2015 17:39'!
viewOn: objects
	| instance |
	instance := self new.
	instance
		events: objects;
		withEdges.
	instance interaction
		popupText: #asEventAnalysisString;
		draggable.
	^ instance
		build;
		view! !

!GTAActivityBuilder methodsFor: 'adding' stamp: 'JurajKubelka 4/14/2015 14:49'!
addEdges
	self edges ifNotEmpty: [ ^ self ].
	self buildEdges.! !

!GTAActivityBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/13/2015 16:41'!
analyze
	analyze := true! !

!GTAActivityBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 16:44'!
analyzeEvents
	self eventAnalyzer analyze: self events! !

!GTAActivityBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 16:43'!
analyzeEventsIfRequested
	analyze ifTrue: [ self analyzeEvents ]! !

!GTAActivityBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/14/2015 14:49'!
buildEdges
	| size |
	size := self elements size.
	size < 2
		ifTrue: [ ^ #() ].
	self elements
		withIndexDo: [ :element :index | 
			index < size
				ifTrue: [ self edgeFrom: element to: (self elements at: index + 1) ] ].
	^ self edges! !

!GTAActivityBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/14/2015 14:49'!
buildEdgesIfRequested
	withEdges
		ifFalse: [ ^ #() ].
	^ self buildEdges! !

!GTAActivityBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:09'!
buildElements
	| visibleEvents |
	visibleEvents := self visibleEvents.
	elements := self elementsWithInteractionOn: visibleEvents.
! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:52'!
configuration: aGTADefaultTimelineConfiguration 
	aGTADefaultTimelineConfiguration configure: self! !

!GTAActivityBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/13/2015 16:55'!
createShapeBuilder
	^ super createShapeBuilder event; yourself! !

!GTAActivityBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/13/2015 16:47'!
createView
	^ super createView @ RTDraggableView @ RTZoomableView.! !

!GTAActivityBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/14/2015 14:39'!
edgeFrom: source to: target 
	"source and target are elements"
	| newEdge |
	newEdge := self edgeShapeBuilder edgeFrom: source to: target.
	view add: newEdge.
	edges add: newEdge.
	^ newEdge! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 17:31'!
edgeShapeBuilder
	^ edgeShapeBuilder ifNil: [ edgeShapeBuilder := self newEdgeShapeBuilder ]! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 14:40'!
edges
	^ edges! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 15:29'!
elements
	elements ifNil: [ self buildElements ].
	^ elements! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:50'!
eventAnalyzer
	^ eventAnalyzer ifNil: [ eventAnalyzer := self newEventAnalyzer ]! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 15:10'!
eventFilter
	^ eventFilter ifNil: [ eventFilter := self newEventFilter ]! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:50'!
events
	^ events! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:48'!
events: aCollection 
	events := aCollection! !

!GTAActivityBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 4/14/2015 14:39'!
initialize
	super initialize.
	edges := OrderedCollection new.
	analyze := false.
	withEdges := false.! !

!GTAActivityBuilder methodsFor: 'testing' stamp: 'JurajKubelka 4/15/2015 15:05'!
isWithEdges
	^ withEdges ! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 15:16'!
layout
	^ layoutBuilder ifNil: [ layoutBuilder := self newLayoutBuilder ]! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 09:10'!
layout: aLayout
	^ layoutBuilder := aLayout! !

!GTAActivityBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:14'!
layoutElements
	self layoutElements: self elements! !

!GTAActivityBuilder methodsFor: 'private' stamp: 'JurajKubelka 4/13/2015 15:15'!
layoutElements: aCollection 
	self layout on: aCollection ! !

!GTAActivityBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/14/2015 14:29'!
logicalLayout
	^ self layout: GTAHorizontalDivingLineLayout new! !

!GTAActivityBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:01'!
newEdgeShapeBuilder
	^ self createShapeBuilder
		line;
		horizontalAttachPoint; 
		width: 1;
		yourself! !

!GTAActivityBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 6/4/2015 14:09'!
newEventAnalyzer
	^ GTASessionAnalysis new! !

!GTAActivityBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/13/2015 15:10'!
newEventFilter
	^ [ :session | session select: #isForTimelineView ]! !

!GTAActivityBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 6/2/2015 10:10'!
newLayoutBuilder
	^ GTAHorizontalDivingLineLayout new center; gapSize: 0; yourself! !

!GTAActivityBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/15/2015 15:13'!
realLayout
	^ self layout: GTAHorizontalRealTimelineLayout new! !

!GTAActivityBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/16/2015 15:16'!
removeAllElementsAndEdges
	self
		removeEdges;
		removeElements! !

!GTAActivityBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/14/2015 21:36'!
removeEdges
	self edges ifEmpty: [ ^ self ].
	"view removeEdges: self edges."
	self edges do: #remove.
	edges := OrderedCollection new.! !

!GTAActivityBuilder methodsFor: 'removing' stamp: 'JurajKubelka 4/14/2015 21:36'!
removeElements
	elements ifNil: [ ^ self ].
	self elements ifEmpty: [ ^ self ].
	self elements do: #remove.
	elements := nil! !

!GTAActivityBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 4/16/2015 15:16'!
renderIn: aView
	self removeAllElementsAndEdges.
	self analyzeEventsIfRequested.
	aView addAll: self elements.
	self buildEdgesIfRequested.
	self layoutElements.! !

!GTAActivityBuilder methodsFor: 'signalling' stamp: 'JurajKubelka 4/14/2015 14:36'!
signalUpdate
	view signalUpdate ! !

!GTAActivityBuilder methodsFor: 'layout' stamp: 'JurajKubelka 4/14/2015 14:57'!
smoothLayoutTranslator
	self layout translator: (RTSmoothLayoutTranslator new nbCycles: 1).! !

!GTAActivityBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 4/13/2015 15:10'!
visibleEvents
	^ self eventFilter cull: self events cull: self! !

!GTAActivityBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/13/2015 17:09'!
withEdges
	withEdges := true! !

!GTAActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:55'!
withEdges: aBoolean 
	withEdges := aBoolean! !

!GTAActivityBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/14/2015 15:17'!
withoutEdges
	withEdges := false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons noIcon! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:47'!
asEventAnalysisString
	^ String streamContents: [ :stream |
			self eventAnalysisPrintOn: stream ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:38'!
children
	^ self infoAt: #sameLevelEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:17'!
cleanDiveInEvent: aDiveInEvent 
	^ self removeInfoAt: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:01'!
dateAndTimeWithFixedTimeZone
	| dateAndTime announcementTimestamp session dates |
	self infoAt: #dateAndTimeWithFixedTimeZone ifPresent: [ :value | ^ value ] ifAbsent: [ "ignore" ].
	dateAndTime := self dateAndTime.
	dateAndTime ifNil: [ ^ nil ].
	announcementTimestamp := self announcementTimestamp.
	announcementTimestamp ifNil: [ 
		^ dateAndTime translateTo: 0 ].
	dateAndTime asDate yyyymmdd = announcementTimestamp asDate yyyymmdd ifTrue: [ 
		^ self 
			infoAt: #dateAndTimeWithFixedTimeZone 
			put: (dateAndTime translateTo: announcementTimestamp offset) ].
	session := self session.
	session ifNil: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	dates := (session collect: #announcementTimestamp as: Set)
		select: [ :eachTimestamp | eachTimestamp asDate yyyymmdd = dateAndTime asDate yyyymmdd ].
	dates ifEmpty: [ 
		^ dateAndTime translateTo: announcementTimestamp offset ].
	^ self 
		infoAt: #dateAndTimeWithFixedTimeZone 
		put: (dateAndTime translateTo: dates any offset)! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:56'!
delayFromPreviousEvent
	self previousEvent ifNil: [ ^ 0 seconds ].
	^ self dateAndTimeWithFixedTimeZone - self previousEvent dateAndTimeWithFixedTimeZone! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:13'!
diveInEvent: aDiveInEvent 
	^ self infoAt: #diveInEvent put: aDiveInEvent.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:15'!
diveInLevel
	^ self parentEvent 
		ifNotNil: [ :obj | obj diveInLevel + 1 ]
		ifNil: [ 1 ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 23:35'!
elementNamePrintOn: aStream
	self elementName 
		ifNil: [ aStream nextPutAll: 'unknown element' ];
		ifNotNil: [ aStream nextPutAll: 'an element' ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/30/2015 16:44'!
eventAnalysisPrintOn: aStream
	self printOn: aStream! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:50'!
eventTypePrintOn: aStream
	self eventType
		ifNotNil: [ :aSymbol |
			aStream
				cr;
				print: aSymbol;
				nextPutAll: ' event' ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/11/2015 22:50'!
followingDifferentTime
	^ self infoAt: #followingDifferentTime ifAbsent: [ self dateAndTimeWithFixedTimeZone ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:44'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: -1>  
	^ (composite table)
		title: 'Info';
		display: [ :anEvent | anEvent gtInspectorItems sort: [ :a :b | a key < b key ] ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ]
			sortedBy: [ :a :b | a key < b key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		beMultiple;
		send: [ :selection | 
			(selection notNil and: [ selection size = 1 ]) 
				ifTrue: [ selection anyOne value ] 
				ifFalse: [ selection collect: #value ] ];
		showOnly: 50! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:35'!
hasElementName
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:24'!
hasKnownName
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:24'!
hasName
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:32'!
hasUnknownName
	^ self hasName and: [ self hasKnownName not ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:07'!
isActOn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:46'!
isCategoryDiveIn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:49'!
isElementDiveIn
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/8/2015 16:11'!
isMissStep
	^ self infoAt: #isMissStep ifPresent: [ :obj | true ] ifAbsent: [ false ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:08'!
isRootEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | false ] ifAbsent: [ true ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:14'!
isSearchFinishedClass
	^ false! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 10:37'!
isSpotterEvent
	^ true! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:30'!
isStrange
	^ self infoAt: #strange ifPresent: [ :aCol | aCol notEmpty ] ifAbsent: [ false ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:44'!
markAsStrange: aString
	| stranges |
	stranges := self infoAt: #strange ifAbsentPut: [ OrderedCollection new ].
	stranges add: aString.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:36'!
myPositionAmongSameTimeEvents
	^ self infoAt: #myPositionAmongSameTimeEvents ifAbsent: [ 1 ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/11/2015 17:58'!
offset: aDuration 
	"Private: For test case purpose only."
	timestamp := timestamp + aDuration! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 20:13'!
parentEvent
	^ self infoAt: #diveInEvent ifPresent: [ :obj | obj ] ifAbsent: [ nil ]! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:56'!
previousEvent 
	^ self infoAt: #previousEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:53'!
previousEvent: anEvent 
	^ self infoAt: #previousEvent put: anEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 13:02'!
printDelayFromPreviousEventOn: aStream
	self previousEvent ifNil: [ ^ self ].
	aStream 
		cr;
		nextPutAll: 'triggered after ';
		print: self delayFromPreviousEvent.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition
	^ self infoAt: #relativeXPosition! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:47'!
relativeXPosition: aDateAndTime 
	^ self infoAt: #relativeXPosition put: aDateAndTime! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:20'!
removeDiveInEvent
	^ self removeInfoKey: #diveInEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:26'!
removeIsMissStep
	^ self removeInfoKey: #isMissStep! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:52'!
removePreviousEvent
	^ self removeInfoKey: #previousEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:22'!
removeSameLevelEvents
	^ self removeInfoKey: #sameLevelEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:26'!
removeSameTimeEvents
	self removeInfoKey: #sameTimeEvents.
	self removeInfoKey: #myPositionAmongSameTimeEvents.
	self removeInfoKey: #followingDifferentTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedCategoryEvent
	^ self removeInfoKey: #selectedCategoryEvent! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:25'!
removeSelectedElementEvents
	^ self removeInfoKey: #selectedElementEvents! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 13:59'!
removeSession
	^ self removeInfoKey: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:24'!
removeStrange
	^ self removeInfoKey: #strange! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:18'!
sameTimeEvents
	^ self infoAt: #sameTimeEvents ifAbsent: [ #() ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:16'!
sameTimeEvents: aCollection index: anInteger nextDateAndTime: aDateAndTime 
	self infoAt: #sameTimeEvents put: aCollection.
	self infoAt: #myPositionAmongSameTimeEvents put: anInteger.
	self infoAt: #followingDifferentTime put: aDateAndTime.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:02'!
session
	^ self infoAt: #session! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 14:00'!
session: aSessionCollection 
	^ self infoAt: #session put: aSessionCollection.! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:43'!
setMissStep
	^ self infoAt: #isMissStep put: true! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 13:50'!
strange
	^ self infoAt: #strange ifAbsent: [ #() ].! !

!GTSpotterRecorderEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:41'!
userQueryOrSelectionHashes
	"It returns array of hashes that represent user input (query) or user selections."
	^ #()! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:48'!
currentQueryHashes
	^ self stringHashesFor: self query! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 13:36'!
currentQuerySizes
	^ self stringSizesFor: self query! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/1/2015 15:29'!
currentQuerySpecials
	^ self stringSpecialsFor: self query! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 13:00'!
eventAnalysisPrintOn: aStream
	| categories | 
	categories := self notEmptyCategories.
	aStream
		nextPutAll: 'SearchFinished: ';
		nextPutAll: (query ifNil: [ 'no query' ] ifNotNil: [ 'with query' ]);
		nextPutAll: ', ';
		print: categories size;
		nextPutAll: ' categories, ';
		print: (self items ifEmpty: [ 0 ] ifNotEmpty: [ :col | col sum ]);
		nextPutAll: ' findings'.
	categories ifNotEmpty: [ | index |
		index := 1.
		aStream cr.
		categories 
			do: [ :category |
				index \\ 6 = 0 ifTrue: [ aStream cr ].
				aStream 
					nextPutAll: category key;
					nextPutAll: ' (';
					print: category value;
					nextPut: $).
				index := index + 1.
				 ] 
			separatedBy: [ aStream nextPutAll: ', ' ] ].
	self printDelayFromPreviousEventOn: aStream.
! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:15'!
hasKnownName
	^ self query notNil and: [ self processors notNil ]! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:14'!
hasName
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 15:27'!
isForTimelineView
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:13'!
isSearchFinishedClass
	^ true! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/31/2015 11:40'!
notEmptyCategories
	| notEmptyCategories |
	notEmptyCategories := OrderedCollection new.
	self processors ifNil: [ ^ notEmptyCategories ].
	self processors pairsDo: [ :processor :items |
		items > 0 ifTrue: [ notEmptyCategories add: (processor -> items) ]
	].
	^ notEmptyCategories! !

!GTSpotterRecorderSearchFinishedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:49'!
userQueryOrSelectionHashes
	^ self currentQueryHashes! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons exitIcon! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:59'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Close Spotter'.
	self selectedCategoryLabel 
		ifNotNil: [ 
			aStream
				nextPutAll: ' on category ';
				nextPutAll: self selectedCategoryLabel ]
		ifNil: [ aStream nextPutAll: ' without results' ].
	self eventTypePrintOn: aStream.
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 10:28'!
removeSelectedElementEvent
	^ self removeInfoKey: #selectedElementEvent! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 12:51'!
selectedCategoryLabel
	^ self selectedElementEvent 
		ifNil: [ nil ]
		ifNotNil: [ :obj | obj selectedCategoryLabel ]! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 10:42'!
selectedElementEvent
	^ self infoAt: #selectedElementEvent! !

!GTSpotterRecorderExitAnnouncementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 10:29'!
selectedElementEvent: anEvent
	^ self infoAt: #selectedElementEvent put: anEvent! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons diveOutIcon! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:59'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Dive Out: '.
	self elementNamePrintOn: aStream.
	self printDelayFromPreviousEventOn: aStream.
! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:19'!
hasKnownName
	^ self elementName notNil! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:19'!
hasName
	^ true! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveOutEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

Announcement subclass: #GTACollectionAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTAItemAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTAItemRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTACollectionAnnouncement subclass: #GTASaved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!TRShape methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 23:06'!
allVisibleColor: aColor
	self color = Color transparent 
			ifFalse: [ self color: aColor ]! !

!TRCompositeShape methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 23:07'!
allVisibleColor: aColor
	self shapes do: [ :aShape | aShape allVisibleColor: aColor ]! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:11'!
event
	self shape: GTAActivitySymbolBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:11'!
flexibleResultShapes
	self shape: GTAFlexibleResultSymbolBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:11'!
oblique
	self shape: GTAActivitySymbolBuilder new! !

!RTShapeBuilder methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:11'!
orthogonal
	self shape: GTAOrthogonalSymbolBuilder new! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons selectedCandidateChangedIcon! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:50'!
categoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 13:00'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Selection of '.
	self elementNamePrintOn: aStream.
	self selectedCategoryLabel ifNotNil: [ :aLabelString |
		aStream
			cr
			nextPutAll: 'in category ';
			nextPutAll: aLabelString ].
	self eventTypePrintOn: aStream.
	self printDelayFromPreviousEventOn: aStream.
! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 15:40'!
existsUserSelectionsOfTheSameElement
	| index |
	index := self session identityIndexOf: self.
	^ self session anySatisfy: [ :each | 
			((each isUserSelectionClass and: [ 
				each elementName = self elementName ]) 
					and: [ (each == self) not ]) 
						and: [ (self session identityIndexOf: each) < index ] ] ! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:23'!
hasKnownName
	^ self elementName notNil! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:18'!
hasName
	^ true! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isUserSelection! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/8/2015 11:33'!
isInTheSameCategoryAsPreviousSelection
	^ self previousSelection isNil or: [ 
			self selectedCategoryLabel = self previousSelection selectedCategoryLabel ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/8/2015 12:00'!
isUserSelection
	^ true "(self isInTheSameCategoryAsPreviousSelection not and: [ self eventType notNil ]) or: [ 
		(self eventType notNil) and: [ (self eventType = #unknown) not ] ]"! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:38'!
previousSelection
	^ self infoAt: #previousSelection ifAbsent: [ nil ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:37'!
previousSelection: aGTSpotterRecorderSelectedCandidateChangedEvent 
	self infoAt: #previousSelection put: aGTSpotterRecorderSelectedCandidateChangedEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 12:38'!
removePreviousSelection
	^ self removeInfoKey: #previousSelection! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:06'!
selectedCategoryEvent
	^ self infoAt: #selectedCategoryEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:48'!
selectedCategoryEvent: anEvent
	self infoAt: #selectedCategoryEvent put: anEvent! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:07'!
selectedCategoryLabel
	^ self selectedCategoryEvent ifNotNil: [ :catEvent | catEvent categoryLabel ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderSelectedCandidateChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/12/2015 16:06'!
userSelectionsOfTheSameElement
	| index |
	index := self session identityIndexOf: self.
	^ self session select: [ :each | 
			((each isUserSelectionClass and: [ 
				each elementName = self elementName ]) 
					and: [ (each == self) not ]) 
						and: [ (self session identityIndexOf: each) < index ] ] ! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons actOnIcon! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:59'!
eventAnalysisPrintOn: aStream
	aStream 
		nextPutAll: 'Act on category ';
		nextPutAll: self selectedCategoryLabel.
	self eventTypePrintOn: aStream.
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:06'!
hasKnownName
	"It is a hash"
	^ self elementName notNil! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:05'!
hasName
	"It is a hash"
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:07'!
isActOn
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:53'!
isForTimelineView
	^ true! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 10:28'!
removeSelectedElementEvent
	^ self removeInfoKey: #selectedElementEvent! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 10:38'!
selectedCategoryLabel
	^ self selectedElementEvent selectedCategoryLabel! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 10:38'!
selectedElementEvent
	^ self infoAt: #selectedElementEvent! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/28/2015 10:29'!
selectedElementEvent: anEvent
	^ self infoAt: #selectedElementEvent put: anEvent! !

!GTSpotterRecorderActOnEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 12:24'!
addSameLevelEvent: anEvent 
	| events |
	events := self infoAt: #sameLevelEvents ifAbsentPut: [ OrderedCollection new ].
	events add: anEvent! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ self isMissStep 
			ifFalse: [ GTAEventIcons diveInElementIcon ]
			ifTrue: [ GTAEventIcons diveInElementMissStepIcon ]! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/10/2015 17:25'!
duration
	self children ifEmpty: [ ^ 0 seconds ].
	^ (self children last dateAndTime) - self dateAndTime ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:59'!
eventAnalysisPrintOn: aStream
	self isMissStep ifTrue: [ aStream nextPutAll: 'MissStep ' ].
	aStream 
		nextPutAll: 'Dive In Element of category ';
		nextPutAll: self selectedCategoryLabel;
		cr;
		nextPutAll: 'for ';
		print: self duration.
	self eventTypePrintOn: aStream.
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasDiveIn
	^ self children contains: #isDiveIn ! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:03'!
hasKnownName
	"In that case a hash"
	^ self elementName notNil! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:03'!
hasName
	"In that case a hash"
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 11:11'!
hasQuery
	^ self children contains: #isContextChanged! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/20/2015 15:49'!
isElementDiveIn
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:30'!
removeSelectedElementEvent
	^ self removeInfoKey: #selectedElementEvent! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:31'!
selectedCategoryLabel
	^ self selectedElementEvent selectedCategoryLabel! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:31'!
selectedElementEvent
	^ self infoAt: #selectedElementEvent! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/29/2015 09:30'!
selectedElementEvent: anEvent
	^ self infoAt: #selectedElementEvent put: anEvent! !

!GTSpotterRecorderDiveInElementEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:53'!
userQueryOrSelectionHashes
	^ self elementName 
			ifNil: [ #() ]
			ifNotNil: [ :value | Array with: value ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:51'!
elementSelectionEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:59'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Category: '.
	self categoryLabel
		ifNil: [ aStream nextPutAll: 'unknown category' ]
		ifNotNil: [ :aString |
			aStream 
				nextPutAll: aString;
				nextPutAll: ' with ';
				print: self elementCountOrZero;
				nextPutAll: ' spotted and ';
				print: self selectedElementEvents size;
				nextPutAll: ' selected elements' ].
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:09'!
hasKnownName
	"It is a category name"
	^ self categoryLabel notNil! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/19/2015 12:08'!
hasName
	"It is a category name"
	^ true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 11:40'!
markAsStrange
	^ self infoAt: #strange put: true! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 15:42'!
selectedElementEvent: anEvent
	| elements |
	elements := self infoAt: #selectedElementEvents ifAbsentPut: [ OrderedCollection new ].
	elements add: anEvent! !

!GTSpotterRecorderCategorySelectedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 3/31/2015 16:02'!
selectedElementEvents
	^ self infoAt: #selectedElementEvents ifAbsent: [ #() ]! !

TestCase subclass: #GTAAbstractIconBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTAAbstractIconBuilderTest class methodsFor: 'testing' stamp: 'JurajKubelka 5/31/2015 11:38'!
isAbstract
	^ self name = #GTAAbstractIconBuilderTest! !

!GTAAbstractIconBuilderTest methodsFor: 'initialization' stamp: 'JurajKubelka 5/31/2015 11:35'!
initializeBuilder
	self subclassResponsibility! !

!GTAAbstractIconBuilderTest methodsFor: 'instance creation' stamp: 'JurajKubelka 5/31/2015 12:03'!
newElementForEvent: anEventObject
	^ (builder shapeFor: anEventObject) element! !

!GTAAbstractIconBuilderTest methodsFor: 'instance creation' stamp: 'JurajKubelka 5/31/2015 12:03'!
newElementForEventClass: aClass
	^ self newElementForEvent: aClass new! !

!GTAAbstractIconBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 5/31/2015 11:35'!
setUp
	super setUp.
	self initializeBuilder.
	! !

!GTAAbstractIconBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/31/2015 11:37'!
testShapeFor
	| shape view |
	view := RTView new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		shape := builder shapeFor: eachClass new.
		shape ifNotNil: [
			view add: shape element ]
	].
	RTHorizontalLineLayout on: view elements.
	view! !

GTAAbstractIconBuilderTest subclass: #GTAFlexibleResultIconBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTAFlexibleResultIconBuilderTest methodsFor: 'initialization' stamp: 'JurajKubelka 6/4/2015 14:11'!
initializeBuilder	
	builder := GTAFlexibleResultSymbolBuilder new! !

GTAAbstractIconBuilderTest subclass: #GTAIconBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTAIconBuilderTest commentStamp: '<historical>' prior: 0!
A GTATimelineIconBuilderTest is a test class for testing the behavior of GTATimelineIconBuilder!

!GTAIconBuilderTest methodsFor: 'initialization' stamp: 'JurajKubelka 6/4/2015 14:11'!
initializeBuilder
	builder := GTAActivitySymbolBuilder new.! !

GTAAbstractIconBuilderTest subclass: #GTAOrthogonalIconBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTAOrthogonalIconBuilderTest methodsFor: 'initialization' stamp: 'JurajKubelka 6/4/2015 14:11'!
initializeBuilder	
	builder := GTAOrthogonalSymbolBuilder new! !

!GTAOrthogonalIconBuilderTest methodsFor: 'instance creation' stamp: 'JurajKubelka 6/8/2015 17:20'!
lineWithDownSelectionsFrom: aGTAComputers
	| selection2 session1 selection1 selection3 selection4 |
	selection1 := GTSpotterRecorderSelectedCandidateChangedEvent new
		infoAt: #eventType put: #keyPressedArrowDown;
		infoAt: #elementName put: 1;
		yourself.
	selection2 := GTSpotterRecorderSelectedCandidateChangedEvent new
		infoAt: #eventType put: #keyPressedArrowDown;
		infoAt: #elementName put: 1;
		yourself.
	session1 := GTASession with: selection1 with: selection2.
	selection1 previousSelection: selection1.
	selection2 previousSelection: selection1.
	selection1 session: session1.
	selection2 session: session1.
	selection3 := aGTAComputers first fifth at: 25.
	selection4 := aGTAComputers first second at: 51.
	^ RTGroup 
		with: (self newElementForEvent: selection1)
		with: (self newElementForEvent: selection2)
		with: (self newElementForEvent: selection3)
		with: (self newElementForEvent: selection4)
! !

!GTAOrthogonalIconBuilderTest methodsFor: 'instance creation' stamp: 'JurajKubelka 6/8/2015 17:33'!
lineWithMouseSelectionsFrom: aGTAComputers
	| selection1 selection2 selection3 selection4 |
	selection1 := aGTAComputers first second at: 33.
	selection2 := aGTAComputers first second at: 34.
	selection3 := aGTAComputers first second at: 39.
	selection4 := aGTAComputers first second at: 41.
	^ RTGroup 
		with: (self newElementForEvent: selection1)
		with: (self newElementForEvent: selection2)
		with: (self newElementForEvent: selection3)
		with: (self newElementForEvent: selection4)
! !

!GTAOrthogonalIconBuilderTest methodsFor: 'instance creation' stamp: 'JurajKubelka 5/31/2015 12:46'!
lineWithQueries
	^ RTGroup
		with:
			(self
				newElementForEvent:
					(GTSpotterRecorderContextChangedEvent new
						currentTextInfoFromString: 'query';
						yourself))
		with:
			(self
				newElementForEvent:
					(GTSpotterRecorderContextChangedEvent new
						currentTextInfoFromString: 'query2 longer-query';
						yourself))
		with:
			(self
				newElementForEvent:
					(GTSpotterRecorderContextChangedEvent new
						currentTextInfoFromString: 'query33 #c';
						yourself))! !

!GTAOrthogonalIconBuilderTest methodsFor: 'instance creation' stamp: 'JurajKubelka 6/8/2015 17:30'!
lineWithUnknownSelectionsFrom: aGTAComputers
	| selection1 element |
	selection1 := aGTAComputers first first at: 4.
	element := self newElementForEvent: selection1.
	element trachelShape strokePaint: Color black.
	^ RTGroup with: element! !

!GTAOrthogonalIconBuilderTest methodsFor: 'instance creation' stamp: 'JurajKubelka 6/8/2015 17:19'!
lineWithUpSelectionsFrom: aGTAComputers
	| selection2 session1 selection1 selection3 selection4 |
	selection1 := GTSpotterRecorderSelectedCandidateChangedEvent new
		infoAt: #eventType put: #keyPressedArrowUp;
		infoAt: #elementName put: 1;
		yourself.
	selection2 := GTSpotterRecorderSelectedCandidateChangedEvent new
		infoAt: #eventType put: #keyPressedArrowUp;
		infoAt: #elementName put: 1;
		yourself.
	session1 := GTASession with: selection1 with: selection2.
	selection1 previousSelection: selection1.
	selection2 previousSelection: selection1.
	selection1 session: session1.
	selection2 session: session1.
	selection3 := aGTAComputers first sixth at: 9.
	selection4 := aGTAComputers first second at: 47.
	^ RTGroup 
		with: (self newElementForEvent: selection1)
		with: (self newElementForEvent: selection2)
		with: (self newElementForEvent: selection3)
		with: (self newElementForEvent: selection4)
! !

!GTAOrthogonalIconBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 6/8/2015 17:33'!
testShapesForVissoft2015Paper
	| view line1 line2 line3 line4 line5 line6 computers line7 line8 line9 |
	view := RTView new.
	computers := GTASessionExamples allRecordedExamples.
	line1 := RTGroup
		with: (self newElementForEventClass: GTSpotterRecorderActOnEvent)
		with: (self newElementForEventClass: GTSpotterRecorderExitAnnouncementEvent).
	line2 := RTGroup
		with: (self newElementForEventClass: GTSpotterRecorderShowPreviewEvent)
		with: (self newElementForEventClass: GTSpotterRecorderHidePreviewEvent).
	line3 := RTGroup
		with: (self newElementForEventClass: GTSpotterRecorderDiveInElementEvent)
		with: (self newElementForEventClass: GTSpotterRecorderDiveInCategoryEvent)
		with: (self newElementForEventClass: GTSpotterRecorderDiveOutEvent).
	line4 := self lineWithQueries.
	line5 := RTGroup with: (self newElementForEventClass: GTSpotterRecorderSearchFinishedEvent).
	line6 := self lineWithUnknownSelectionsFrom: computers.
	line7 := self lineWithUpSelectionsFrom: computers.
	line8 := self lineWithDownSelectionsFrom: computers.
	line9 := self lineWithMouseSelectionsFrom: computers.
	view
		addAll: line1;
		addAll: line2;
		addAll: line3;
		addAll: line4;
		addAll: line5;
		addAll: line6;
		addAll: line7;
		addAll: line8;
		addAll: line9.
	RTHorizontalLineLayout
		on: line1;
		on: line2;
		on: line3;
		on: line4;
		on: line5;
		on: line6;
		on: line7;
		on: line8;
		on: line9.
	RTVerticalLineLayout
		on:
			(RTGroup new
				add: line1;
				add: line2;
				add: line3;
				add: line4;
				add: line5;
				add: line6;
				add: line7;
				add: line8;
				add: line9;
				yourself).
	view elements @ RTDraggable.
	view elements do: [ :eachElement | eachElement trachelShape allVisibleColor: Color black ].
	view inspect! !

TestCase subclass: #GTAActivityBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTAActivityBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/13/2015 14:42'!
session1
	^ GTASessionExamples session1! !

!GTAActivityBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 6/4/2015 14:13'!
setUp
	super setUp.
	builder := GTAActivityBuilder new.! !

!GTAActivityBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 16:11'!
testBuild
	| events |
	events := GTASession new.
	GTSpotterRecorderEvent allSubclassesDo: [ :eachClass |
		events add: eachClass new.
	].
	builder events: events.
	builder build.
	builder view.! !

!GTAActivityBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 4/13/2015 17:43'!
testBuildSession1
	| events |
	events := self session1.
	builder
		events: events;
		analyze;
		withEdges.
	builder interaction 
		popupText: #asEventAnalysisString;
		draggable.
	builder build.
	"builder view inspect."! !

TestCase subclass: #GTARoughDataSetBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTARoughDataSetBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:20'!
dateAndTimes
	^ OrderedCollection new
		add: (DateAndTime year: 2015 month: 01 day: 02);
		add: (DateAndTime year: 2015 month: 01 day: 03);
		add: (DateAndTime year: 2015 month: 01 day: 05);
		add: (DateAndTime year: 2015 month: 01 day: 14);
		add: (DateAndTime year: 2015 month: 02 day: 07);
		add: (DateAndTime year: 2015 month: 02 day: 10);
		add: (DateAndTime year: 2015 month: 02 day: 15);
		add: (DateAndTime year: 2015 month: 03 day: 30);
		yourself! !

!GTARoughDataSetBuilderTest methodsFor: 'private' stamp: 'JurajKubelka 5/11/2015 17:30'!
session: aCollection offset: aDuration 
	aCollection do: [ :eachEvent |
		eachEvent offset: aDuration
	 ].
	^ aCollection! !

!GTARoughDataSetBuilderTest methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:29'!
sessions
	^ OrderedCollection new
		add: (self session: GTASessionExamples session1 offset: -30 days);
		add: (self session: GTASessionExamples session1 offset: -28 days);
		add: (self session: GTASessionExamples session1 offset: -15 days);
		add: (self session: GTASessionExamples session1 offset: -5 days);
		add: (self session: GTASessionExamples session1 offset: -1 days);
		yourself! !

!GTARoughDataSetBuilderTest methodsFor: 'running' stamp: 'JurajKubelka 5/11/2015 16:47'!
setUp
	super setUp.
	builder := GTARoughDataSetBuilder new.! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 18:14'!
testBuild
	| objects |
	objects := #(0 1 2 3   13 15 17   23   29 30).
	builder
		objects: objects;
		gap: 5;
		build.
	self assert: builder numberOfGroups equals: 4.
	self assert: builder groups first size equals: 4.
	self assert: builder groups second size equals: 3.
	self assert: builder groups third size equals: 1.
	self assert: builder groups fourth size equals: 2.
	self assert: builder groups first asArray equals: #(0 1 2 3).
	self assert: builder groups second asArray equals: #(13 15 17).
	self assert: builder groups third asArray equals: #(23).
	self assert: builder groups fourth asArray equals: #(29 30).! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/11/2015 18:14'!
testBuildDateAndTimes
	| objects |
	objects := self dateAndTimes.
	builder
		objects: objects;
		gap: 2 weeks;
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 4.
	self assert: builder groups second size equals: 3.
	self assert: builder groups third size equals: 1.
! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/14/2015 17:49'!
testBuildSessions
	| objects |
	objects := self sessions.
	builder
		objects: objects;
		gap: 1 week;
		setSessionComparator;
		groupClass: GTASomeSessions;
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 2.
	self assert: builder groups second size equals: 1.
	self assert: builder groups third size equals: 2.
	self assert: (builder groups allSatisfy: [ :eachGroup | eachGroup class = GTASomeSessions ]).
! !

!GTARoughDataSetBuilderTest methodsFor: 'tests' stamp: 'JurajKubelka 5/14/2015 17:59'!
testBuildSessions2
	| objects |
	objects := self sessions.
	builder
		objects: objects;
		gap: 1 week;
		setSessionComparator;
		newGroupBlock: [ GTASomeSessions new ];
		build.
	self assert: builder numberOfGroups equals: 3.
	self assert: builder groups first size equals: 2.
	self assert: builder groups second size equals: 1.
	self assert: builder groups third size equals: 2.
	self assert: (builder groups allSatisfy: [ :eachGroup | eachGroup class = GTASomeSessions ]).
! !

TestCase subclass: #GTSpotterPrintDateAndTimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterPrintDateAndTimeTest commentStamp: '<historical>' prior: 0!
A GTSpotterPrintDateAndTimeTest is a test class for testing the behavior of GTSpotterPrintDateAndTime!

!GTSpotterPrintDateAndTimeTest methodsFor: 'tests' stamp: 'JurajKubelka 6/4/2015 14:19'!
testUCTPlus1
	| dateAndTime string |
	dateAndTime := '2015-03-27T14:59:05.524852+01:00' asDateAndTime.
	string := GTAPrintDateAndTime yyyyMmDdAndHhMmSs: dateAndTime.
	self assert: string equals: '2015-03-27, 13:59:05'.! !

TestCase subclass: #GTSpotterSessionAnalysisTest
	instanceVariableNames: 'analysis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTSpotterSessionAnalysisTest commentStamp: '<historical>' prior: 0!
A GTSpotterDiveInLevelCommandTest is a test class for testing the behavior of GTSpotterDiveInLevelCommand!

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session1
	^ GTASessionExamples session1! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session2
	^ GTASessionExamples session2! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:50'!
session3
	^ GTASessionExamples session3! !

!GTSpotterSessionAnalysisTest methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 13:55'!
session4
	^ GTASessionExamples session4! !

!GTSpotterSessionAnalysisTest methodsFor: 'running' stamp: 'JurajKubelka 6/4/2015 14:09'!
setUp
	super setUp.
	analysis := GTASessionAnalysis new.
	! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/12/2015 13:58'!
testCategoriesSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: (session at: 4) categoryEvent equals: (session at: 5).
	self assert: (session at: 5) elementSelectionEvents size equals: 3.
	self assert: (session at: 5) elementSelectionEvents first equals: (session at: 4).
	self assert: (session at: 5) elementSelectionEvents second equals: (session at: 7).
	self assert: (session at: 5) elementSelectionEvents third equals: (session at: 8).
	self assert: (session at: 9) categoryEvent equals: (session at: 10).
	self assert: (session at: 10) elementSelectionEvents size equals: 1.
	self assert: (session at: 10) elementSelectionEvents first equals: (session at: 9).
! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/12/2015 14:14'!
testCategoriesSession4
	| session |
	analysis session: self session4.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 20.
	self assert: (session at: 4) categoryEvent equals: (session at: 5).
	self assert: (session at: 7) categoryEvent equals: (session at: 5).
	self assert: (session at: 8) categoryEvent equals: (session at: 9).
	self assert: (session at: 12) categoryEvent equals: (session at: 9).
	self assert: (session at: 13) categoryEvent equals: (session at: 14).
	self assert: (session at: 16) categoryEvent equals: (session at: 14).
	self assert: (session at: 17) categoryEvent equals: (session at: 14).
	self assert: (session at: 18) categoryEvent equals: (session at: 14).
	self assert: (session at: 19) categoryEvent equals: (session at: 14).

	self assert: (session at: 5) elementSelectionEvents size equals: 2.
	self assert: (session at: 9) elementSelectionEvents size equals: 2.
	self assert: (session at: 14) elementSelectionEvents size equals: 5.

	self assert: (session at: 5) elementSelectionEvents first equals: (session at: 4).
	self assert: (session at: 5) elementSelectionEvents second equals: (session at: 7).

	self assert: (session at: 9) elementSelectionEvents first equals: (session at: 8).
	self assert: (session at: 9) elementSelectionEvents second equals: (session at: 12).

	self assert: (session at: 14) elementSelectionEvents first equals: (session at: 13).
	self assert: (session at: 14) elementSelectionEvents second equals: (session at: 16).
	self assert: (session at: 14) elementSelectionEvents third equals: (session at: 17).
	self assert: (session at: 14) elementSelectionEvents fourth equals: (session at: 18).
	self assert: (session at: 14) elementSelectionEvents fifth equals: (session at: 19).
! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:28'!
testMissStepsSession1
	| session |
	analysis session: self session1.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 27.
	self assert: session numberOfMissSteps equals: 1.
	self assert: (session at: 6) isMissStep.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:29'!
testMissStepsSession2
	| session |
	analysis session: self session2.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 11.
	self assert: session numberOfMissSteps equals: 0.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 4/9/2015 11:04'!
testMissStepsSession3
	| session |
	analysis session: self session3.
	analysis execute.
	session := analysis session.
	self assert: session size equals: 20.
	self assert: (session at: 9) isMissStep.
	self deny: (session at: 16) isMissStep.
	self assert: session numberOfMissSteps equals: 1.! !

!GTSpotterSessionAnalysisTest methodsFor: 'tests' stamp: 'JurajKubelka 3/31/2015 13:41'!
testRootsSession1
	| roots |
	analysis session: self session1.
	analysis execute.
	roots := analysis session roots.
	self assert: roots size equals: 11.
	self assert: (roots at: 6) children size equals: 4.
	self assert: (roots at: 1) children size equals: 0.
	self assert: (roots at: 7) children size equals: 8.
	self assert: ((roots at: 7) children at: 4) children size equals: 4.
! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons contextChangedIcon! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 5/31/2015 12:18'!
currentTextInfoFromString: aString 
	currentTextInfo := self textInfoFrom: aString! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 12:59'!
eventAnalysisPrintOn: aStream
	aStream nextPutAll: 'Query: '.
	self currentTextSizes 
			ifEmpty: [ aStream nextPutAll: 'no input' ]
			ifNotEmpty: [ :aCollection | 
					aStream
						print: aCollection size;
						nextPutAll: (aCollection size = 1 
											ifTrue: [ ' word of size ' ] 
											ifFalse: [ ' words, each of size: ' ]).
				aCollection 
					do: [ :eachSize | aStream print: eachSize ] 
					separatedBy: [ aStream space ].
				self hasCurrentTextSpecials ifTrue: [ 
					aStream nextPutAll: ', with #keyword' ] ].
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ self isContextChanged! !

!GTSpotterRecorderContextChangedEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/19/2015 16:41'!
userQueryOrSelectionHashes
	^ self currentTextHashes ! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/4/2015 14:18'!
analysisIcon
	^ GTAEventIcons hidePreviewIcon! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 6/2/2015 13:00'!
eventAnalysisPrintOn: aStream
	aStream
		nextPutAll: 'Hide Preview'.
	self printDelayFromPreviousEventOn: aStream.! !

!GTSpotterRecorderHidePreviewEvent methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/9/2015 19:54'!
isForTimelineView
	^ true! !

Object subclass: #GTAActivityMenuBuilder
	instanceVariableNames: 'timelineBuilder menuBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 16:11'!
addEdges
	timelineBuilder withEdges; addEdges; signalUpdate.
	self configuration withEdges: timelineBuilder isWithEdges.! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/31/2015 13:31'!
allBlack
	timelineBuilder view elements do: [ :el | 
		el trachelShape allVisibleColor: Color black ]! !

!GTAActivityMenuBuilder methodsFor: 'building' stamp: 'JurajKubelka 4/14/2015 14:32'!
build
	self renderIn: timelineBuilder view.! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 5/28/2015 12:39'!
colorCloseEventsPerCategory
	| elements labels normalizer |
	elements := timelineBuilder view elements select: [ :el | el model isCloseSpotter ].
	labels := ((elements collect: [ :e | e model selectedCategoryLabel ]) as: Bag) sortedCounts collect: #value.
	normalizer := RTMultiLinearColorForIdentity new.
	normalizer objects: labels.
	elements do: [ :element | | label |
		label := element model selectedCategoryLabel.
		element trachelShape allVisibleColor: (normalizer rtValue: label) ].
	timelineBuilder view signalUpdate! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 15:07'!
colorMostOftenQueriesAndItemsInComputer
	| els bag hashes counts normalizer computers |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	computers := els collect: [ :e | e model session computer ] as: Set.
	bag := (computers flatCollect: [ :e | e userQueryOrSelectionHashes collect: #hash ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:38'!
colorMostOftenQueriesAndItemsInView
	| els bag hashes counts normalizer |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	bag := (els flatCollect: [ :e | e model userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:49'!
colorSameQueriesAndItemsInComputer
	| els bag hashes counts normalizer computers |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	computers := els collect: [ :e | e model session computer ] as: Set.
	bag := (computers flatCollect: [ :e | e userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTMultiLinearColorForIdentity new.
	normalizer objects: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/20/2015 14:38'!
colorSameQueriesAndItemsInView
	| els bag hashes counts normalizer |
	els := timelineBuilder view elements select: [ :el | 
					el model isSpotterEvent and: [ el model userQueryOrSelectionHashes notEmpty ] ].
	bag := (els flatCollect: [ :e | e model userQueryOrSelectionHashes ]) as: Bag.
	counts := bag sortedCounts.
	hashes := (counts collect: #value) reverse.
	normalizer := RTMultiLinearColorForIdentity new.
	normalizer objects: hashes.
	els do: [ :element | | maxHash |
	maxHash := element model userQueryOrSelectionHashes detectMax: [ :each | bag valuesAndCounts at: each ].
	element trachelShape allVisibleColor: (normalizer rtValue: maxHash) ].
	timelineBuilder view signalUpdate! !

!GTAActivityMenuBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:03'!
configuration
	^ GTADefaultTimelineConfiguration uniqueInstance! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/19/2015 14:03'!
flexibleResultShapes
	timelineBuilder shape flexibleResultShapes.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAActivityMenuBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 4/14/2015 14:32'!
initialize
	super initialize.
	menuBuilder := RTMenuBuilder new.! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:01'!
logicalTimeline
	timelineBuilder
			logicalLayout;
			layoutElements;
			signalUpdate.
	self configuration 
			layout: timelineBuilder layout! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/16/2015 15:16'!
obliqueShapes
	timelineBuilder shape oblique.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/16/2015 15:16'!
orthogonalShapes
	timelineBuilder shape orthogonal.
	timelineBuilder 
		removeAllElementsAndEdges;
	 	build;
		signalUpdate.
	self configuration shape: timelineBuilder shape shape! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:01'!
realTimeline
	timelineBuilder
			realLayout;
			layoutElements;
			signalUpdate.
	self configuration 
		layout: timelineBuilder layout! !

!GTAActivityMenuBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 4/15/2015 15:04'!
removeEdges
	timelineBuilder withoutEdges; removeEdges; signalUpdate.
	self configuration withEdges: timelineBuilder isWithEdges.! !

!GTAActivityMenuBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 5/31/2015 13:30'!
renderIn: aView
	menuBuilder view: aView.
	menuBuilder menu: 'Layout' submenu: 'Logical Timeline' callback: [ self logicalTimeline ].
	menuBuilder menu: 'Layout' submenu: 'Real Timeline' callback: [ self realTimeline ].
	menuBuilder menu: 'Edge' submenu: 'Remove Edges' callback: [ self removeEdges ].
	menuBuilder menu: 'Edge' submenu: 'Add Edges' callback: [ self addEdges ].
	menuBuilder menu: 'Shape' submenu: 'Orthogonal Shapes' callback: [ self orthogonalShapes ].
	menuBuilder menu: 'Shape' submenu: 'Flexible Result Shapes' callback: [ self flexibleResultShapes ].
	menuBuilder menu: 'Color' submenu: 'All Black' callback: [ self allBlack ].
	menuBuilder menu: 'Color' submenu: 'Same Queries and Items in View' callback: [ self colorSameQueriesAndItemsInView ].
	menuBuilder menu: 'Color' submenu: 'Most Often Queries and Items in View' callback: [ self colorMostOftenQueriesAndItemsInView ].
	menuBuilder menu: 'Color' submenu: 'Same Queries and Items in Computer' callback: [ self colorSameQueriesAndItemsInComputer ].
	menuBuilder menu: 'Color' submenu: 'Most Often Queries and Items in Computer' callback: [ self colorMostOftenQueriesAndItemsInComputer ].
	menuBuilder menu: 'Color' submenu: 'ActOn and Exit Events per Category' callback: [ self colorCloseEventsPerCategory ].
! !

!GTAActivityMenuBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/14/2015 14:31'!
timelineBuilder: aGTATimelineBuilder 
	timelineBuilder := aGTATimelineBuilder! !

Object subclass: #GTAActivitySymbolBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity-Symbols'!

!GTAActivitySymbolBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHalfHeight
	^ 5! !

!GTAActivitySymbolBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultHeight
	^ 10! !

!GTAActivitySymbolBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:19'!
defaultMinHeight
	^ 2! !

!GTAActivitySymbolBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultMinWidth
	^ 1! !

!GTAActivitySymbolBuilder methodsFor: 'configuration' stamp: 'JurajKubelka 4/12/2015 10:20'!
defaultWidth
	^ 10! !

!GTAActivitySymbolBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/13/2015 17:00'!
elementOn: aModel 
	^ (self shapeFor: aModel) elementOn: aModel! !

!GTAActivitySymbolBuilder methodsFor: 'public' stamp: 'JurajKubelka 4/13/2015 16:58'!
elementsOn: models
	^ models collect: [ :eachModel | (self elementOn: eachModel) ] as: RTGroup! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/19/2015 13:35'!
newContextChangedForOneWordEvent: aGTSpotterEvent
	| shape sizes |
	shape := RTBox new height: self defaultHeight; width: self defaultMinWidth; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	(sizes notNil and: [ sizes notEmpty ]) ifTrue: [ shape width: sizes sum ].
	aGTSpotterEvent hasCurrentTextSpecials ifTrue: [ shape height: self defaultHalfHeight ]. 
	^ shape! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/19/2015 13:35'!
newContextChangedForSeveralWordsEvent: aGTSpotterEvent
	| composition sizes keywords shapes |
	composition := RTCompositeShape new horizontal; yourself.
	sizes := aGTSpotterEvent currentTextSizes.	
	keywords := aGTSpotterEvent currentTextSpecials.
	shapes := OrderedCollection new.
	sizes with: keywords do: [ :size :keyword |
		shapes add: (self newShapeForWordOfSize: size keyword: keyword) ].
	shapes 
		do: [ :shape | composition add: shape ]
		separatedBy: [ 
			composition add: (RTBox new height: 1; width: 1; yourself) ].
	^ composition! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 11:40'!
newCorrectDiveInElementEvent: aGTSpotterEvent
	^ RTBox new
		height: 2;
		width: 5;
		yourself! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/14/2015 11:45'!
newMissStepDiveInElementEvent: aGTSpotterEvent 
	| s1 s3 s2 c |
	c := RTCompositeShape new.
	s1 := RTBox new
				height: 2;
				width: 2;
				yourself.
	s2 := RTBox new
				height: 2;
				width: 1;
				color: Color transparent;
				yourself.
	s3 := RTBox new
				height: 2;
				width: 2;
				yourself.
	c add: s1; add: s2; add: s3; horizontal.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:33'!
newSearchFinishedForOneCategoryEvent: aGTSpotterEvent
	| size sizes shapeAndSize |
	sizes := aGTSpotterEvent items.
	(sizes notNil and: [ sizes notEmpty ]) 
		ifTrue: [ size := sizes sum ]
		ifFalse: [ size := 1 ].
	shapeAndSize := self newShapeForQueryOfSize: size.
	^ shapeAndSize key! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:32'!
newSearchFinishedForSeveralCategoriesEvent: aGTSpotterEvent
	| composition categoriesAndItems offset |
	composition := RTCompositeShape new.
	categoriesAndItems := aGTSpotterEvent notEmptyCategories.
	offset := 0.
	categoriesAndItems 
		do: [ :categoryAndItems | | shapeAndSize size |
			size := categoryAndItems value.
			shapeAndSize := self newShapeForQueryOfSize: size.
			composition add: shapeAndSize key translateBy: offset @ 0.
			offset := offset + shapeAndSize value ]
		separatedBy: [ | connector |
			connector := RTCompositeShape new.
			connector 
				add: (RTBox new height: 1; width: 1; yourself);
				add: (RTBox new height: 1; width: 1; yourself)
					translateBy: 0 @ 6.
			composition 
				add: connector
				translateBy: offset @ 0.
				offset := offset + 2 ].
	^ composition! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/20/2015 14:31'!
newShapeForQueryOfSize: wordSize
	| s1 s3 c size |
	size := wordSize // 10.
	size < 2 ifTrue: [ size := 2 ].
	size > 100 ifTrue: [ size := 100 ].
	c := RTCompositeShape new.
	s1 := RTBox new height: 4; width: size; yourself.
	s3 := RTBox new height: 4; width: size; yourself.	
	c 
		add: s1;
		add: s3 translateBy: 0 @ 6.
	^ c -> size! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:41'!
newShapeForSelectionEventKeyArrowDown: aGTSpotterEvent 
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownDifferentCategory: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:48'!
newShapeForSelectionEventKeyArrowDownDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownDifferentCategoryUnique: aGTSpotterEvent  ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:58'!
newShapeForSelectionEventKeyArrowDownDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s2 translateBy: 0 @ 7; 
		add: s1 translateBy: 0 @ 12.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:36'!
newShapeForSelectionEventKeyArrowDownDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s1 translateBy: 0 @ 7; 
		add: s2 translateBy: 0 @ 12.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:36'!
newShapeForSelectionEventKeyArrowDownSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowDownSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowDownSameCategoryUnique: aGTSpotterEvent  ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:08'!
newShapeForSelectionEventKeyArrowDownSameCategoryRepetition: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:11'!
newShapeForSelectionEventKeyArrowDownSameCategoryUnique: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:41'!
newShapeForSelectionEventKeyArrowUp: aGTSpotterEvent
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpDifferentCategory: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:53'!
newShapeForSelectionEventKeyArrowUpDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpDifferentCategoryUnique: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:01'!
newShapeForSelectionEventKeyArrowUpDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1;
		add: s2 translateBy: 0 @ 5; 
		add: s3 translateBy: 0 @ 13.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:03'!
newShapeForSelectionEventKeyArrowUpDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s3 := RTBox new width: 10; height: 10; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1;
		add: s2 translateBy: 0 @ 5; 
		add: s3 translateBy: 0 @ 13.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:52'!
newShapeForSelectionEventKeyArrowUpSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventKeyArrowUpSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventKeyArrowUpSameCategoryUnique: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:30'!
newShapeForSelectionEventKeyArrowUpSameCategoryRepetition: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 9; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; vertical.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 15:03'!
newShapeForSelectionEventKeyArrowUpSameCategoryUnique: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0 };
				yourself.
	s2 := RTBox new width: 10; height: 6; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; vertical.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 13:43'!
newShapeForSelectionEventSingleClick: aGTSpotterEvent 
	^ aGTSpotterEvent isInTheSameCategoryAsPreviousSelection
		ifTrue: [ self newShapeForSelectionEventSingleClickSameCategory: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickDifferentCategory: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:59'!
newShapeForSelectionEventSingleClickDifferentCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventSingleClickDifferentCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickDifferentCategoryUnique: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:50'!
newShapeForSelectionEventSingleClickDifferentCategoryRepetition: aGTSpotterEvent 
	| s1 s2 s3 s4 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ 5. 2 @ 5. 5 @ 0 };
				yourself.
	s3 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	s4 := RTPolygon new 
				vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0 };
				yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s4 translateBy: 0 @ 5; 
		add: s1 translateBy: 0 @ 10;
		add: s2 translateBy: 0 @ 15.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/17/2015 14:47'!
newShapeForSelectionEventSingleClickDifferentCategoryUnique: aGTSpotterEvent 
	| s1 s2 s3 s4 c |
	s1 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s2 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ 5. 5 @ 0 };
				yourself.
	s3 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ -5. 5 @ 0 };
				yourself.
	s4 := RTPolygon new 
				vertices: { -5 @ 0. 0 @ -5. 5 @ 0 };
				yourself.
	c := RTCompositeShape new.
	c 
		add: s3;
		add: s4 translateBy: 0 @ 5; 
		add: s1 translateBy: 0 @ 10;
		add: s2 translateBy: 0 @ 15.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:56'!
newShapeForSelectionEventSingleClickSameCategory: aGTSpotterEvent 
	^ aGTSpotterEvent existsUserSelectionsOfTheSameElement
		ifTrue: [ self newShapeForSelectionEventSingleClickSameCategoryRepetition: aGTSpotterEvent ]
		ifFalse: [ self newShapeForSelectionEventSingleClickSameCategoryUnique: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:55'!
newShapeForSelectionEventSingleClickSameCategoryRepetition: aGTSpotterEvent 
	^ RTPolygon new 
			vertices: { -5 @ 0. -2 @ -5. 2 @ -5. 5 @ 0. 2 @ 5. -2 @ 5 };
			yourself! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 15:33'!
newShapeForSelectionEventSingleClickSameCategoryUnique: aGTSpotterEvent 
	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			yourself! !

!GTAActivitySymbolBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 4/12/2015 10:21'!
newShapeForWordOfSize: wordSize keyword: aBoolean
	^ RTBox new 
			height: (aBoolean ifTrue: [ self defaultHalfHeight ] ifFalse: [ self defaultHeight ]); 
			width: wordSize; 
			yourself.! !

!GTAActivitySymbolBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 16:49'!
shapeFor: aGTSpotterEvent 
	^ aGTSpotterEvent accept: self! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitActOnEvent: aGTSpotterEvent 
	^ RTPolygon new vertices: { -5 @ -5. 5 @ 0. -5 @ 5 }; yourself! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:52'!
visitCategorySelectedEvent: aGTSpotterRecorderCategorySelectedEvent 
	^ nil! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:35'!
visitContextChangedEvent: aGTSpotterEvent 
	^ aGTSpotterEvent currentTextSizes size < 2
		ifTrue: [ self newContextChangedForOneWordEvent: aGTSpotterEvent ]
		ifFalse: [ self newContextChangedForSeveralWordsEvent: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 14:23'!
visitDiveInCategoryEvent: aGTSpotterEvent 
	| s1 s2 s3 c |
	s1 := RTBox new height: 2; width: 5; yourself.
	s2 := RTBox new height: 2; width: 5; color: Color transparent; yourself.
	s3 := RTBox new height: 2; width: 5; yourself.
	c := RTCompositeShape new.
	c add: s1; add: s2; add: s3; vertical.
	^ c! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/14/2015 11:40'!
visitDiveInElementEvent: aGTSpotterEvent 
	^ aGTSpotterEvent isMissStep 
		ifTrue: [ self newMissStepDiveInElementEvent: aGTSpotterEvent ]
		ifFalse: [ self newCorrectDiveInElementEvent: aGTSpotterEvent ]! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 14:24'!
visitDiveOutEvent: aGTSpotterEvent 
	^ RTBox new
		height: 2;
		width: 5;
		yourself! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitExitEvent: aGTSpotterEvent 
	^ RTPolygon new 
		vertices: { 
			-4 @ -5. 0 @ -1. 4 @ -5. 5 @ -4. 1 @ 0. 
			5 @ 4. 4 @ 5. 0 @ 1. -4 @ 5. -5 @ 4. -1 @ 0. -5 @ -4 };
		yourself! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 01:38'!
visitHidePreviewEvent: aGTSpotterEvent 
	^ RTArc new 
			innerRadius: 4;
			externalRadius: 5;
			outerAngle: 0 innerAngle: 360! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/11/2015 16:53'!
visitOpenEvent: aGTSpotterRecorderOpenEvent 
	^ nil! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:34'!
visitSearchFinishedEvent: aGTSpotterEvent 
	^ RTPolygon new
			vertices: { -5 @ 0. -3 @ 0. -1 @ 4. 1 @ -3. 3 @ 0. 5 @ 0. 
							5 @ -1. 3 @ -1. 1 @ -4. -1 @ 3. -3 @ -1. -5 @ -1 };
			yourself! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 13:42'!
visitSelectedCandidateChangedEvent: aGTSpotterEvent 
	| type |
	type := aGTSpotterEvent eventType. 
	type = #keyPressedArrowUp ifTrue: [ 
		^ self newShapeForSelectionEventKeyArrowUp: aGTSpotterEvent ].

	type = #keyPressedArrowDown ifTrue: [ 
		^ self newShapeForSelectionEventKeyArrowDown: aGTSpotterEvent ].

	type = #singleClick ifTrue: [ 
		^ self newShapeForSelectionEventSingleClick: aGTSpotterEvent ].

	^ RTPolygon new 
			vertices: { -5 @ 0 . 0 @ -5 . 5 @ 0. 0 @ 5 };
			color: Color transparent;
			borderColor: RTPolygon new defaultColor;
			yourself! !

!GTAActivitySymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/12/2015 00:21'!
visitShowPreviewEvent: aGTSpotterEvent 
	^ RTEllipse new size: 10; yourself! !

GTAActivitySymbolBuilder subclass: #GTAOrthogonalSymbolBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity-Symbols'!

GTAOrthogonalSymbolBuilder subclass: #GTAFlexibleResultSymbolBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity-Symbols'!

!GTAFlexibleResultSymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/19/2015 13:58'!
visitSearchFinishedEvent: aGTSpotterEvent 
	^ aGTSpotterEvent notEmptyCategories size < 2
		ifTrue: [ self newSearchFinishedForOneCategoryEvent: aGTSpotterEvent ]
		ifFalse: [ self newSearchFinishedForSeveralCategoriesEvent: aGTSpotterEvent ]! !

!GTAOrthogonalSymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 12:24'!
visitDiveInCategoryEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -3 @ -2. 1 @ -2. 1 @ 4. 3 @ 4. 3 @ 5. 0 @ 5. 0 @ 1. 
								-3 @ 1. -3 @ 0. 0 @ 0. 0 @ -1. -3 @ -1 };
				yourself.
	s2 := RTBox new width: 6; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAOrthogonalSymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 12:26'!
visitDiveInElementEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -2 @ -1. 1 @ -1. 1 @ 4. 3 @ 4. 3 @ 5. 0 @ 5. 0 @ 0. -2 @ 0 };
				yourself.
	s2 := RTBox new width: 5; height: 4; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c add: s2; add: s1; vertical.
	^ c! !

!GTAOrthogonalSymbolBuilder methodsFor: 'visitor' stamp: 'JurajKubelka 4/17/2015 14:39'!
visitDiveOutEvent: aGTSpotterEvent 
	| s1 s2 c |
	s1 := RTPolygon new 
				vertices: { -2 @ 1. 1 @ 1. 1 @ -4. 3 @ -4. 3 @ -5. 0 @ -5. 0 @ 0. -2 @ 0 };
				yourself.
	s2 := RTBox new width: 5; height: 5; color: Color transparent; yourself.
	c := RTCompositeShape new.
	c 
		add: s1; 
		add: s2 translateBy: 0 @ 7.
	^ c! !

Object subclass: #GTACommand
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTACommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:13'!
analysisOrder
	^ 100! !

!GTACommand class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: aGTSpotterSession 
	^ self new context: aGTSpotterSession; yourself! !

!GTACommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:12'!
clean
	self subclassResponsibility! !

!GTACommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context
	^ context! !

!GTACommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:30'!
context: anObject
	context := anObject! !

!GTACommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 11:31'!
execute
	self subclassResponsibility! !

!GTACommand methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:32'!
session
	^ self context session! !

GTACommand subclass: #GTADelayedExitCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTADelayedExitCommand methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/27/2015 16:27'!
clean
	self session removeHasDelayedExit! !

!GTADelayedExitCommand methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/27/2015 16:41'!
execute
	| close nextToLast |
	self session last isCloseSpotter ifFalse: [ ^ self ].
	close := self session last dateAndTimeWithFixedTimeZone.
	nextToLast := self session nextToLast dateAndTimeWithFixedTimeZone.
	close - nextToLast < 1 minute ifTrue: [ ^ self ].
	self session setHasDelayedExit! !

GTACommand subclass: #GTADirectSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTADirectSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 5/27/2015 16:04'!
analysisOrder
	^ GTAEmptySessionCommand analysisOrder + 1! !

!GTADirectSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 16:07'!
clean
	self session removeIsDirectSession.! !

!GTADirectSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 16:32'!
execute
	self session hasDelayedExit ifTrue: [ ^ self ].
	self session isEmptySession ifTrue: [ ^ self ].
	self session numberOfDivesIn = 0 ifFalse: [ ^ self ].
	self session setDirectSession.! !

GTACommand subclass: #GTADiveInLevelCommand
	instanceVariableNames: 'dives'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTADiveInLevelCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 1! !

!GTADiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:23'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeDiveInEvent;
			removeSameLevelEvents ]! !

!GTADiveInLevelCommand methodsFor: 'execute' stamp: 'JurajKubelka 3/31/2015 12:00'!
execute
	self session do: [ :eachEvent |
		eachEvent isDiveIn ifTrue: [ self updateDiveIn: eachEvent ].
		eachEvent isDiveOut ifTrue: [ self updateDiveOut: eachEvent ].
		eachEvent isDive ifFalse: [ self updateEvent: eachEvent ].
	]! !

!GTADiveInLevelCommand methodsFor: 'initialization' stamp: 'JurajKubelka 3/31/2015 12:06'!
initialize
	super initialize.
	dives := OrderedCollection new! !

!GTADiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:58'!
updateDiveIn: anEvent
	self updateEvent: anEvent.
	dives add: anEvent.
! !

!GTADiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 13:11'!
updateDiveOut: anEvent
	dives ifEmpty: [ ^ anEvent markAsStrange: 'Dive-Out before Dive-In.' ].
	self updateEvent: anEvent.
	dives removeLast ! !

!GTADiveInLevelCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 12:11'!
updateEvent: anEvent
	dives ifEmpty: [ ^ self ].
	anEvent diveInEvent: dives last.
	dives last addSameLevelEvent: anEvent.
! !

GTACommand subclass: #GTAElementWithCategoryCommand
	instanceVariableNames: 'selection category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAElementWithCategoryCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:10'!
analysisOrder
	^ 1! !

!GTAElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:25'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeStrange;
			removeSelectedCategoryEvent;
			removeSelectedElementEvents ]! !

!GTAElementWithCategoryCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 14:10'!
execute
	self session do: [ :eachEvent |
		eachEvent isUserSelectionClass ifTrue: [ self updateSelection: eachEvent ].
		eachEvent isCategorySelection ifTrue: [ self updateCategory: eachEvent ].
	].
	self updateSelection: nil.! !

!GTAElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:44'!
updateCategory: anEvent
	selection ifNil: [ ^ anEvent markAsStrange: 'Category selection before element selection.' ].
	selection selectedCategoryEvent: anEvent.
	anEvent selectedElementEvent: selection.
	selection := nil.
	category := anEvent.! !

!GTAElementWithCategoryCommand methodsFor: 'update' stamp: 'JurajKubelka 3/31/2015 15:43'!
updateSelection: anEvent
	selection ifNotNil: [ 
		category 
			ifNil: [ selection markAsStrange: 'There is no category selection before.' ]
			ifNotNil: [ :aCategory | 
				selection selectedCategoryEvent: aCategory.
				aCategory selectedElementEvent: selection.  ]
		 ].
	selection := anEvent.! !

GTACommand subclass: #GTAEmptySessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAEmptySessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 5/27/2015 16:27'!
analysisOrder
	^ GTADelayedExitCommand analysisOrder + 1! !

!GTAEmptySessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 10:40'!
clean
	self session removeIsEmptySession! !

!GTAEmptySessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 16:32'!
execute
	| displayed |
	self session hasDelayedExit ifTrue: [ ^ self ].
	self session ifEmpty: [ ^ self setEmpty ].
	self session last isActOn ifTrue: [ ^ self ].
	displayed := (self session select: #isForTimelineView).
	displayed size > 3 ifTrue: [ ^ self ].
	self setEmpty.! !

!GTAEmptySessionCommand methodsFor: 'api' stamp: 'JurajKubelka 5/27/2015 10:47'!
setEmpty
	self session setIsEmptySession! !

GTACommand subclass: #GTAFirstLevelDiveInSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAFirstLevelDiveInSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 5/27/2015 16:55'!
analysisOrder
	^ GTADirectSessionCommand analysisOrder + 1! !

!GTAFirstLevelDiveInSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 17:01'!
clean
	self session removeIsFirstLevelDiveInSession! !

!GTAFirstLevelDiveInSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/27/2015 17:39'!
execute
	self session hasDelayedExit ifTrue: [ ^ self ].
	self session isEmptySession ifTrue: [ ^ self ].
	self session isDirectSession ifTrue: [ ^ self ].
	self session deepestDiveIn = 2 ifFalse: [ ^ self ].
	self session setIsFirstLevelDiveInSession.! !

GTACommand subclass: #GTALinkCloseWithSelectionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTALinkCloseWithSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/28/2015 10:32'!
clean
	| close |
	close := self session last.
	close isCloseSpotter ifFalse: [ ^ self ].
	close removeSelectedElementEvent.! !

!GTALinkCloseWithSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/28/2015 10:34'!
execute
	| close |
	close := self session last.
	close isCloseSpotter ifFalse: [ ^ self session bookmarkIt: 'The last event should be ActOn or Exit.' ].
	self session reverseDo: [ :eachEvent |
		eachEvent isUserSelectionClass ifTrue: [
			close selectedElementEvent: eachEvent.
			^ self ] ].! !

GTACommand subclass: #GTALinkDiveInWithSelectionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTALinkDiveInWithSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/29/2015 09:32'!
clean
	self session do: [ :eachEvent |
		eachEvent isDiveIn ifTrue: [ eachEvent removeSelectedElementEvent ] ]! !

!GTALinkDiveInWithSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 5/29/2015 09:29'!
execute
	| lastSelection |
	self session do: [ :eachEvent |
		eachEvent isUserSelectionClass ifTrue: [ lastSelection := eachEvent ].
		eachEvent isDiveIn ifTrue: [ 
			self assert: [ lastSelection notNil ]. 
			eachEvent selectedElementEvent: lastSelection ] ]! !

GTACommand subclass: #GTALinkToSessionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTALinkToSessionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:09'!
analysisOrder
	^ 1! !

!GTALinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
clean
	self session do: [ :eachEvent |
		eachEvent removeSession ]! !

!GTALinkToSessionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 13:59'!
execute
	self session do: [ :eachEvent |
		eachEvent session: self session ]! !

GTACommand subclass: #GTAMissStepsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAMissStepsCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/8/2015 16:14'!
analysisOrder
	^ 50! !

!GTAMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 11:26'!
clean
	self session do: [ :eachEvent |
		eachEvent
			removeIsMissStep ]! !

!GTAMissStepsCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/8/2015 16:53'!
execute
	| divesIn |
	divesIn := self session select: #isDiveIn.
	divesIn withIndexDo: [ :aDiveIn :index |
		(index + 1) <= divesIn size ifTrue: [ 
			((aDiveIn hasQuery or: [ aDiveIn hasDiveIn ]) not and:
				[ aDiveIn duration < 3 seconds ]) ifTrue: [ 
				aDiveIn setMissStep.
			]
		]
	]! !

GTACommand subclass: #GTAPreviousEventCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAPreviousEventCommand methodsFor: 'execute' stamp: 'JurajKubelka 6/2/2015 12:51'!
clean
	self session do: [ :eachEvent | eachEvent removePreviousEvent ]! !

!GTAPreviousEventCommand methodsFor: 'execute' stamp: 'JurajKubelka 6/2/2015 12:51'!
execute
	| previousEvent |
	self session size < 2 ifTrue: [ ^ self ].
	previousEvent := self session first.
	self session allButFirstDo: [ :eachEvent |
		eachEvent previousEvent: previousEvent. 
		previousEvent := eachEvent ]! !

GTACommand subclass: #GTAPreviousSelectionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTAPreviousSelectionCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/12/2015 12:25'!
analysisOrder
	^ (GTSpotterElementWithCategoryCommand analysisOrder max:
			GTSpotterDiveInLevelCommand analysisOrder) + 1! !

!GTAPreviousSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 12:40'!
clean
	self session do: [ :each | 
		each isUserSelectionClass ifTrue: [ each removePreviousSelection ] ]! !

!GTAPreviousSelectionCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/12/2015 12:34'!
execute
	| selections diveInLevels |
	selections := self session select: #isUserSelectionClass.
	selections size < 2 ifTrue: [ ^ self ].
	diveInLevels := Dictionary new.
	selections withIndexDo: [ :selection :index | | lastSelection |
		lastSelection := diveInLevels at: selection diveInLevel ifAbsent: [ nil ].
		lastSelection ifNotNil: [ selection previousSelection: lastSelection ].
		diveInLevels at: selection diveInLevel put: selection ]! !

GTACommand subclass: #GTASameTimestampCommand
	instanceVariableNames: 'timestamp events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTASameTimestampCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:08'!
analysisOrder
	^ GTSpotterLinkToSessionCommand analysisOrder + 1! !

!GTASameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:09'!
addEvent: aSpotterEvent 
	events ifNil: [ events := OrderedCollection new ].
	events addLast: aSpotterEvent! !

!GTASameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/9/2015 19:25'!
clean
	self session do: [ :event | event removeSameTimeEvents ]! !

!GTASameTimestampCommand methodsFor: 'adding' stamp: 'JurajKubelka 4/9/2015 19:27'!
consolidateEvents: aDateAndTime 
	events ifNil: [ ^ self ].
	events withIndexDo: [ :event :index |
		event sameTimeEvents: events index: index nextDateAndTime: aDateAndTime ].
	events := nil.! !

!GTASameTimestampCommand methodsFor: 'execute' stamp: 'JurajKubelka 4/11/2015 22:50'!
execute
	| eventTimestamp |
	self session do: [ :eachEvent | 
		eventTimestamp := eachEvent dateAndTimeWithFixedTimeZone.
		timestamp 
			ifNil: [ 
				timestamp := eventTimestamp.
				self addEvent: eachEvent. ]
			ifNotNil: [ 
				timestamp = eventTimestamp 
					ifTrue: [ self addEvent: eachEvent ] 
					ifFalse: [ self consolidateEvents: eventTimestamp.
						timestamp := eventTimestamp.
						self addEvent: eachEvent. ] ]
		 ].
	self consolidateEvents: eventTimestamp! !

Object subclass: #GTAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Utilities'!

!GTAConfiguration class methodsFor: 'private' stamp: 'JurajKubelka 6/5/2015 15:54'!
byteArray: aByteArray storeOn: aStream
	| chars |
	chars := 0.
	(String streamContents: [ :s | 
		aByteArray storeOn: s ]) do: [ :char | 
			(char isSeparator and: [ (chars > 80) ]) 
				ifTrue: [ chars := 0. aStream cr; tab ]
				ifFalse: [ chars := chars + 1. aStream nextPut: char ] ]! !

!GTAConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 10:11'!
developerUUIDs
	"
	GTSpotterEventRecorderSettings ensureComputerID.
	GTSpotterEventRecorderSettings uniqueInstance computerUUID.
	"
	^ #( 	'58d42da6-c993-4ad1-8624-5fd628793610' 
			'8c7d33b4-1025-42b3-8dc4-4a2bb32c5a42'
			'4483f704-6909-45d7-9367-869a5850c3e8'
			'52fe7c39-9c98-4fa7-a883-a8b2cabe84db'
			'69202c73-b32f-4968-aaf1-0666d421ea57'
			'0cd69f50-ad08-8c47-84ec-329e2210a2f2'
			'29d8c44d-c6da-4026-bf49-c3b0c25625db'
		)! !

!GTAConfiguration class methodsFor: 'testing' stamp: 'JurajKubelka 5/13/2015 11:01'!
isDeveloper: anUUID
	^ self developerUUIDs includes: anUUID asString! !

!GTAConfiguration class methodsFor: 'api' stamp: 'JurajKubelka 5/20/2015 10:51'!
loadBookmarks: aGTAComputers
	| paths |
	paths := FLMaterializer materializeFromByteArray: self savedBookmarks.
	^ GTABookmarks from: paths computers: aGTAComputers! !

!GTAConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 10:45'!
pharo4HighestUpdate
	"Release date: 2015-04-16
	See: http://forum.world.st/ANN-Pharo-4-0-is-released-td4819876.html
	We referes to 40610 that was released on 2015-04-23."
	^ 40610! !

!GTAConfiguration class methodsFor: 'api' stamp: 'JurajKubelka 6/5/2015 15:54'!
saveBookmarks: aGTABookmarks
	| paths methodSource |
	paths := aGTABookmarks collect: [ :each | each path ] as: Array.
	paths := FLSerializer serializeToByteArray: paths.
 	methodSource := String streamContents: [ :aStream |
		aStream
			nextPutAll: 'savedBookmarks'; cr; 
			tab; nextPutAll: '"Automatically created by class method #saveBookmarks."'; cr;
			tab; nextPutAll: '^ '.
		self byteArray: paths storeOn: aStream.
	 ].
	self class compile: methodSource classified: 'stored bookmarks'.! !

!GTAConfiguration class methodsFor: 'stored bookmarks' stamp: 'JurajKubelka 6/5/2015 15:55'!
savedBookmarks
	"Automatically created by class method #saveBookmarks."
	^ #[70 85 69 76 0 194 0 0 0 6 83 0 0 0 0 0 0 0 7 20 70 76 71 108 111 98 97 108 67 108
	97 115 115 67 108 117 115 116 101 114 0 0 0 9 5 70 97 108 115 101 4 84 114 117 101
	10 66 121 116 101 83 116 114 105 110 103 15 85 110 100 101 102 105 110 101 100 79
	98 106 101 99 116 18 71 84 65 83 101 115 115 105 111 110 66 111 111 107 109 97 114
	107 19 71 84 65 67 111 109 112 117 116 101 114 66 111 111 107 109 97 114 107 23 71
	84 65 83 111 109 101 83 101 115 115 105 111 110 115 66 111 111 107 109 97 114 107
	5 65 114 114 97 121 11 68 97 116 101 65 110 100 84 105 109 101 22 70 76 72 111 111
	107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 0 1 0 1 22 70
	76 72 111 111 107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0
	0 0 144 0 3 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102
	49 45 48 54 54 54 100 52 50 49 101 97 53 55 56 107 41 32 67 111 109 112 108 101 120
	32 115 101 115 115 105 111 110 46 32 71 108 111 98 97 108 32 118 97 114 105 97 98
	108 101 115 44 32 80 114 97 103 109 97 115 32 47 32 83 101 110 100 101 114 115 46
	36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99
	51 98 48 99 50 53 54 50 53 100 98 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52
	50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 30 72 105 115 116
	111 114 121 32 97 110 100 32 99 97 108 99 117 108 97 116 111 114 32 114 101 115 117
	108 116 115 40 73 116 32 117 115 101 115 32 100 105 118 101 115 45 105 110 32 97 110
	100 32 115 101 118 101 114 97 108 32 99 97 116 101 103 111 114 105 101 115 46 35 102
	41 32 79 110 101 32 108 101 118 101 108 32 100 105 118 101 45 105 110 46 32 73 109
	112 108 101 109 101 110 116 111 114 115 46 36 56 99 55 100 51 51 98 52 45 49 48 50
	53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 15 68 105
	114 101 99 116 32 115 101 115 115 105 111 110 46 36 54 57 50 48 50 99 55 51 45 98
	51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55
	21 103 41 32 79 110 101 32 108 101 118 101 108 32 100 105 118 101 45 105 110 46 36
	56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50
	98 98 51 50 99 53 97 52 50 95 82 101 109 111 118 101 32 116 104 105 115 32 107 105
	110 100 32 111 102 32 115 101 115 115 105 111 110 115 44 32 98 101 99 97 117 115 101
	32 117 115 101 114 32 111 110 108 121 32 111 112 101 110 115 32 97 110 100 32 99 108
	111 115 101 115 32 83 112 111 116 116 101 114 46 13 78 111 32 114 101 97 115 111 110
	32 116 111 32 107 101 101 112 32 105 116 46 36 100 98 52 101 55 99 97 100 45 99 53
	97 100 45 52 49 55 97 45 57 53 54 98 45 54 102 56 57 52 97 48 100 101 55 99 50 36
	50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51
	98 48 99 50 53 54 50 53 100 98 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50
	98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 39 84 104 101 32 108
	97 115 116 32 101 118 101 110 116 32 115 104 111 117 108 100 32 98 101 32 65 99 116
	79 110 32 111 114 32 69 120 105 116 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50
	48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52
	50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56
	100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98
	51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55
	36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99
	51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52
	57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50
	99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49
	101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99
	52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 56 99 55 100 51 51 98 52 45 49 48 50
	53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 50 57
	100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48
	99 50 53 54 50 53 100 98 36 99 41 32 68 105 114 101 99 116 32 115 101 115 115 105
	111 110 58 32 114 101 109 111 116 101 32 119 111 114 107 115 112 97 99 101 46 36 50
	57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98
	48 99 50 53 54 50 53 100 98 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48
	50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 56 99 55 100 51 51
	98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53
	97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49
	45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50
	48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52
	50 49 101 97 53 55 34 65 100 100 101 100 32 97 116 32 50 48 49 53 45 48 53 45 49 57
	84 49 55 58 48 56 58 50 52 45 48 51 58 48 48 36 56 99 55 100 51 51 98 52 45 49 48
	50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 18 108
	41 32 100 101 108 97 121 101 100 32 101 120 97 109 112 108 101 36 54 57 50 48 50 99
	55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101
	97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49
	45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53
	45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50
	48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52
	50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97
	97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 50 55 53 99 54 51 54 100 45
	51 99 53 100 45 52 51 49 48 45 57 48 49 57 45 101 54 56 102 55 49 56 99 49 57 55 100
	36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54
	54 54 100 52 50 49 101 97 53 55 18 101 41 32 68 105 114 101 99 116 32 115 101 115
	115 105 111 110 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97
	97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 17 100 41 32 100 105 114 101 99
	116 32 115 101 115 115 105 111 110 24 67 111 109 112 108 101 120 32 115 101 97 114
	99 104 32 119 105 116 104 32 69 120 105 116 36 56 99 55 100 51 51 98 52 45 49 48 50
	53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 50 104 41
	32 79 110 101 32 108 101 118 101 108 32 100 105 118 101 45 105 110 32 119 105 116
	104 32 109 105 115 115 45 115 116 101 112 46 32 73 109 112 108 101 109 101 110 116
	111 114 115 46 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102
	52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 53 99 101 51 57 50 50 50 45 101 50
	101 57 45 52 52 49 97 45 98 56 55 55 45 100 51 99 97 56 52 98 101 53 100 55 53 36
	50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51
	98 48 99 50 53 54 50 53 100 98 36 101 49 49 49 100 55 49 102 45 50 102 98 99 45 52
	102 50 98 45 97 100 99 97 45 55 48 55 53 100 55 57 101 101 55 101 48 36 54 57 50 48
	50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50
	49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97
	102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 50 57 100 56 99 52 52 100 45 99
	54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36
	56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50
	98 98 51 50 99 53 97 52 50 55 65 32 108 111 116 32 111 102 32 99 97 116 101 103 111
	114 105 101 115 32 97 114 101 32 98 114 111 119 115 101 100 46 13 73 110 116 101 114
	101 115 116 105 110 103 32 117 115 101 32 99 97 115 101 115 46 18 79 110 101 32 108
	101 118 101 108 32 100 105 118 101 45 105 110 46 36 54 57 50 48 50 99 55 51 45 98
	51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55
	36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54
	54 54 100 52 50 49 101 97 53 55 55 69 120 97 109 112 108 101 32 111 102 32 112 97
	115 116 105 110 103 32 85 82 76 32 119 105 116 104 32 114 101 109 111 116 101 32 80
	108 97 121 103 114 111 117 110 100 32 99 111 110 116 101 110 116 115 46 36 54 57 50
	48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52
	50 49 101 97 53 55 18 83 105 109 112 108 101 32 40 116 111 112 32 108 101 118 101
	108 41 46 105 41 32 67 111 109 112 108 101 120 32 115 101 115 115 105 111 110 46 32
	72 105 115 116 111 114 121 32 47 32 73 110 115 116 97 110 99 101 32 109 101 116 104
	111 100 115 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102
	49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50
	102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54
	57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54
	100 52 50 49 101 97 53 55 25 67 111 109 112 108 101 120 32 115 101 115 115 105 111
	110 46 32 83 101 110 100 101 114 115 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55
	100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51
	50 99 53 97 52 50 34 69 109 112 116 121 32 115 101 115 115 105 111 110 32 119 105
	116 104 32 111 110 101 45 119 111 114 100 32 113 117 101 114 121 46 36 50 55 53 99
	54 51 54 100 45 51 99 53 100 45 52 51 49 48 45 57 48 49 57 45 101 54 56 102 55 49
	56 99 49 57 55 100 6 68 105 114 101 99 116 36 56 99 55 100 51 51 98 52 45 49 48 50
	53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57
	50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100
	52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45
	97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45
	98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53
	55 49 73 32 117 115 101 32 116 104 114 101 101 32 115 101 115 115 105 111 110 115
	32 111 102 32 105 116 32 102 111 114 32 116 104 101 32 86 105 115 115 111 102 116
	32 112 97 112 101 114 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56
	45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 15 68 105 114 101 99 116
	32 115 101 115 115 105 111 110 46 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52
	50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 39 84 104 101 32 108
	97 115 116 32 101 118 101 110 116 32 115 104 111 117 108 100 32 98 101 32 65 99 116
	79 110 32 111 114 32 69 120 105 116 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55
	100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51
	50 99 53 97 52 50 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98
	102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98
	51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55
	36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54
	54 54 100 52 50 49 101 97 53 55 39 84 104 101 32 108 97 115 116 32 101 118 101 110
	116 32 115 104 111 117 108 100 32 98 101 32 65 99 116 79 110 32 111 114 32 69 120
	105 116 46 30 97 41 32 69 109 112 116 121 32 115 101 115 115 105 111 110 32 119 105
	116 104 32 112 114 101 118 105 101 119 46 63 106 41 32 67 111 109 112 108 101 120
	32 115 101 115 115 105 111 110 46 32 73 109 112 108 101 109 101 110 116 111 114 115
	46 32 73 116 32 99 111 117 108 100 32 98 101 32 117 110 115 97 116 105 115 102 105
	101 100 32 117 115 101 114 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57
	54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 27 79 110 101 32 108
	101 118 101 108 32 100 105 118 101 45 105 110 46 32 67 108 97 115 115 101 115 46 36
	56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50
	98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54
	56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55
	51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101
	97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49
	45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50
	48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52
	50 49 101 97 53 55 18 83 105 109 112 108 101 32 40 116 111 112 32 108 101 118 101
	108 41 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57
	45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50
	48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52
	50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56
	100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 54 57 50 48 50 99 55 51 45 98
	51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55
	34 65 100 100 101 100 32 97 116 32 50 48 49 53 45 48 53 45 50 55 84 49 55 58 48 51
	58 51 56 45 48 51 58 48 48 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54
	56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55
	51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101
	97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49
	45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 6 68 105 114
	101 99 116 36 56 99 55 100 51 51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99
	52 45 52 97 50 98 98 51 50 99 53 97 52 50 36 56 99 97 102 101 48 97 50 45 99 51 53
	101 45 52 51 99 56 45 97 57 52 53 45 51 102 98 51 50 51 102 51 98 102 98 56 36 54
	57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54
	100 52 50 49 101 97 53 55 36 98 48 55 55 56 57 54 97 45 97 102 57 97 45 52 51 54 52
	45 98 53 57 97 45 56 102 97 98 48 57 52 102 56 102 57 56 36 49 51 99 97 97 97 55 99
	45 101 99 102 102 45 57 52 52 56 45 57 102 53 51 45 101 99 100 55 101 55 53 100 102
	54 49 55 75 87 101 32 115 104 111 117 108 100 32 114 101 109 111 118 101 32 115 101
	115 115 105 111 110 115 32 119 105 116 104 32 117 110 107 110 111 119 110 32 101 108
	101 109 101 110 116 115 32 105 110 32 100 105 118 101 45 105 110 44 32 105 110 32
	97 99 116 45 111 110 44 32 101 116 99 46 51 82 101 109 111 118 101 32 115 117 99 104
	32 115 101 115 115 105 111 110 115 46 32 73 116 32 105 115 32 111 110 108 121 32 111
	112 101 110 101 100 32 97 110 100 32 99 108 111 115 101 100 46 36 50 57 100 56 99
	52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53 54
	50 53 100 98 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102
	52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 56 99 55 100 51 51 98 52 45 49 48
	50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 34 67
	111 109 112 108 101 120 32 115 101 115 115 105 111 110 46 32 67 104 97 105 110 32
	111 102 32 115 101 110 100 101 114 115 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102
	45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 94 73 116
	32 105 115 32 97 32 115 105 109 112 108 101 115 116 32 101 120 97 109 112 108 101
	32 111 102 32 117 115 105 110 103 32 115 112 111 116 116 101 114 58 32 73 116 32 114
	101 117 115 101 32 116 104 101 32 102 105 114 115 116 32 105 116 101 109 32 105 110
	32 99 97 116 101 103 111 114 121 32 99 97 108 108 101 100 32 72 105 115 116 111 114
	121 46 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45
	48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45
	52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 54 57 50 48
	50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50
	49 101 97 53 55 36 50 57 100 56 99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98
	102 52 57 45 99 51 98 48 99 50 53 54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98
	51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55
	41 82 101 109 111 118 101 32 105 116 44 32 116 104 101 114 101 32 97 114 101 32 111
	110 108 121 32 112 114 101 118 105 101 119 32 111 110 47 111 102 102 46 36 54 57 50
	48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52
	50 49 101 97 53 55 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97
	97 102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 25 67 111 109 112 108 101 120 32
	115 101 97 114 99 104 32 119 105 116 104 32 65 99 116 79 110 36 54 57 50 48 50 99
	55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54 54 100 52 50 49 101
	97 53 55 36 53 48 57 100 52 101 101 54 45 99 54 98 51 45 52 52 56 100 45 97 100 51
	100 45 56 51 100 102 49 56 57 49 57 48 98 102 27 98 41 32 101 109 112 116 121 32 115
	101 115 115 105 111 110 32 119 105 116 104 32 113 117 101 114 121 36 50 57 100 56
	99 52 52 100 45 99 54 100 97 45 52 48 50 54 45 98 102 52 57 45 99 51 98 48 99 50 53
	54 50 53 100 98 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97
	102 49 45 48 54 54 54 100 52 50 49 101 97 53 55 36 56 99 55 100 51 51 98 52 45 49
	48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99 53 97 52 50 36
	54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102 49 45 48 54 54
	54 100 52 50 49 101 97 53 55 32 68 105 114 101 99 116 32 115 101 115 115 105 111 110
	46 32 67 108 97 115 115 32 115 101 108 101 99 116 105 111 110 46 36 56 99 55 100 51
	51 98 52 45 49 48 50 53 45 52 50 98 51 45 56 100 99 52 45 52 97 50 98 98 51 50 99
	53 97 52 50 36 54 57 50 48 50 99 55 51 45 98 51 50 102 45 52 57 54 56 45 97 97 102
	49 45 48 54 54 54 100 52 50 49 101 97 53 55 22 70 76 72 111 111 107 80 114 105 109
	105 116 105 118 101 67 108 117 115 116 101 114 0 0 1 190 0 9 0 37 126 91 35 78 189
	248 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 87 198 120 1 10 13 255 213 208 0 0
	0 0 0 37 126 60 58 57 155 240 0 134 176 0 28 32 0 0 0 0 0 37 126 91 35 68 128 224
	1 10 13 255 213 208 0 0 0 0 0 37 126 60 4 109 186 96 0 134 49 0 28 32 0 0 0 0 0 37
	126 91 35 73 247 80 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 76 147 72 1 10 13 255
	213 208 0 0 0 0 0 37 126 91 35 71 36 168 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35
	65 221 24 1 10 13 255 213 208 0 0 0 0 0 37 126 61 22 145 205 48 0 183 1 0 28 32 0
	0 0 0 0 37 126 91 35 96 113 56 1 10 13 255 213 208 0 0 0 0 0 37 126 74 58 84 224 104
	0 129 100 0 28 32 0 0 0 0 0 37 126 68 43 227 160 80 0 209 225 255 213 208 0 0 0 0
	0 37 126 59 22 52 138 48 0 193 128 0 28 32 0 0 0 0 0 37 126 59 41 158 154 32 0 192
	243 0 28 32 0 0 0 0 0 37 126 91 35 79 51 40 1 10 13 255 213 208 0 0 0 0 0 37 126 91
	35 88 63 144 1 10 13 255 213 208 0 0 0 0 0 37 126 60 33 99 167 56 0 239 128 0 28 32
	0 0 0 0 0 37 126 91 35 68 246 16 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 71 153
	216 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 74 108 128 1 10 13 255 213 208 0 0
	0 0 0 37 126 59 14 224 206 176 0 179 56 0 28 32 0 0 0 0 0 37 126 91 35 66 82 72 1
	10 13 255 213 208 0 0 0 0 0 37 126 69 17 68 34 176 1 3 75 255 213 208 0 0 0 0 0 37
	126 62 12 23 234 176 0 213 27 0 28 32 0 0 0 0 0 37 126 59 33 72 165 40 0 205 65 0
	28 32 0 0 0 0 0 37 126 59 41 165 170 184 0 216 26 0 28 32 0 0 0 0 0 37 126 59 43 216
	105 56 0 170 191 0 28 32 0 0 0 0 0 37 126 59 4 4 50 192 0 144 9 0 28 32 0 0 0 0 0
	37 126 83 6 165 47 232 1 6 224 255 213 208 0 0 0 0 0 37 126 69 54 221 175 80 0 197
	125 255 213 208 0 0 0 0 0 37 126 59 52 233 15 40 0 144 2 0 28 32 0 0 0 0 0 37 126
	91 35 77 8 120 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 63 154 248 1 10 13 255 213
	208 0 0 0 0 0 37 126 91 35 66 199 120 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 69
	103 88 1 10 13 255 213 208 0 0 0 0 0 37 126 83 4 166 102 48 1 7 24 255 213 208 0 0
	0 0 0 37 126 91 35 96 230 104 1 10 13 255 213 208 0 0 0 0 0 37 126 73 24 166 104 216
	0 159 40 0 28 32 0 0 0 0 0 37 126 62 54 40 214 112 0 188 244 0 28 32 0 0 0 0 0 37
	126 60 8 106 181 120 0 179 232 0 28 32 0 0 0 0 0 37 126 91 35 72 15 8 1 10 13 255
	213 208 0 0 0 0 0 37 126 69 45 63 25 112 0 209 21 255 213 208 0 0 0 0 0 37 126 59
	38 70 227 160 0 144 158 0 28 32 0 0 0 0 0 37 126 29 0 0 0 0 1 27 146 0 28 32 0 0 0
	0 0 37 126 59 14 235 105 136 0 161 158 0 28 32 0 0 0 0 0 37 126 91 35 88 184 168 1
	10 13 255 213 208 0 0 0 0 0 37 126 69 49 186 178 152 1 3 22 255 213 208 0 0 0 0 0
	37 126 91 35 74 225 176 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 77 125 168 1 10
	13 255 213 208 0 0 0 0 0 37 126 91 35 64 35 176 1 10 13 255 213 208 0 0 0 0 0 37 126
	91 35 67 60 168 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 69 220 136 1 10 13 255
	213 208 0 0 0 0 0 37 126 91 35 94 176 0 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35
	97 91 152 1 10 13 255 213 208 0 0 0 0 0 37 126 69 11 197 156 96 0 216 215 255 213
	208 0 0 0 0 0 37 126 68 41 58 31 120 1 47 28 255 213 208 0 0 0 0 0 37 126 59 45 255
	115 160 0 135 101 0 28 32 0 0 0 0 0 37 126 91 35 86 255 64 1 10 13 255 213 208 0 0
	0 0 0 37 126 59 13 46 45 16 0 134 188 0 28 32 0 0 0 0 0 37 126 67 49 130 174 192 1
	0 169 255 185 176 0 0 0 0 0 37 126 62 22 3 92 88 1 43 15 0 28 32 0 0 0 0 0 37 126
	91 35 75 82 248 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 77 242 216 1 10 13 255
	213 208 0 0 0 0 0 37 126 91 35 72 132 56 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35
	65 14 16 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 67 177 216 1 10 13 255 213 208
	0 0 0 0 0 37 126 69 48 113 43 56 1 46 1 255 213 208 0 0 0 0 0 37 126 91 35 95 41 24
	1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 97 208 200 1 10 13 255 213 208 0 0 0 0
	0 37 126 68 52 235 163 80 0 198 79 255 213 208 0 0 0 0 0 37 126 68 3 200 94 88 0 96
	23 255 213 208 0 0 0 0 0 37 126 82 13 92 93 72 1 26 26 255 213 208 0 0 0 0 0 37 126
	68 32 8 151 144 0 209 109 255 213 208 0 0 0 0 0 37 126 61 30 17 75 208 0 137 160 0
	28 32 0 0 0 0 0 37 126 68 35 27 11 152 1 10 26 255 213 208 0 0 0 0 0 37 126 83 33
	42 87 88 1 23 168 255 213 208 0 0 0 0 0 37 126 61 28 245 229 8 0 137 144 0 28 32 0
	0 0 0 0 37 126 91 35 75 200 40 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 78 104 8
	1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 73 16 216 1 10 13 255 213 208 0 0 0 0 0
	37 126 91 35 70 81 184 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 65 131 64 1 10 13
	255 213 208 0 0 0 0 0 37 126 84 44 172 67 152 0 181 57 255 213 208 0 0 0 0 0 37 126
	91 35 98 69 248 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 95 158 72 1 10 13 255 213
	208 0 0 0 0 0 37 126 84 0 241 26 168 0 180 169 255 213 208 0 0 0 0 0 37 126 63 8 156
	225 56 0 219 144 0 28 32 0 0 0 0 0 37 126 91 35 68 39 8 1 10 13 255 213 208 0 0 0
	0 0 37 126 91 35 70 198 232 1 10 13 255 213 208 0 0 0 0 0 37 126 63 44 37 154 240
	0 224 64 0 28 32 0 0 0 0 0 37 126 91 35 76 61 88 1 10 13 255 213 208 0 0 0 0 0 37
	126 69 41 103 66 40 0 189 221 255 213 208 0 0 0 0 0 37 126 91 35 73 145 192 1 10 13
	255 213 208 0 0 0 0 0 37 126 79 44 211 243 192 0 157 23 0 28 32 0 0 0 0 0 37 126 91
	35 96 23 96 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 98 191 16 1 10 13 255 213 208
	0 0 0 0 0 37 126 75 36 51 151 232 0 174 219 0 28 32 0 0 0 0 0 37 126 61 56 72 28 144
	0 193 85 0 28 32 0 0 0 0 0 37 126 62 15 4 158 168 1 38 105 0 28 32 0 0 0 0 0 37 126
	74 16 94 78 192 1 27 194 255 213 208 0 0 0 0 0 37 126 91 35 78 221 56 1 10 13 255
	213 208 0 0 0 0 0 37 126 91 35 87 229 184 1 10 13 255 213 208 0 0 0 0 0 37 126 60
	8 187 4 16 0 181 65 0 28 32 0 0 0 0 0 37 126 91 35 68 160 32 1 10 13 255 213 208 0
	0 0 0 0 37 126 69 9 84 82 40 0 158 116 0 28 32 0 0 0 0 0 37 126 74 44 86 138 72 0
	118 21 0 28 32 0 0 0 0 0 37 126 91 35 74 22 144 1 10 13 255 213 208 0 0 0 0 0 37 126
	91 35 71 64 0 1 10 13 255 213 208 0 0 0 0 0 37 126 59 49 29 214 88 0 204 16 0 28 32
	0 0 0 0 0 37 126 59 48 237 88 72 0 203 22 0 28 32 0 0 0 0 0 37 126 91 35 65 252 88
	1 10 13 255 213 208 0 0 0 0 0 37 126 59 21 243 114 32 0 134 230 0 28 32 0 0 0 0 0
	37 126 91 35 96 140 144 1 10 13 255 213 208 0 0 0 0 0 37 126 59 50 131 179 160 0 130
	249 0 28 32 0 0 0 0 0 37 126 60 40 98 163 104 0 239 204 0 28 32 0 0 0 0 0 37 126 83
	51 159 139 176 1 23 223 255 213 208 0 0 0 0 0 37 126 82 51 85 5 144 0 197 174 255
	213 208 0 0 0 0 0 37 126 88 53 93 45 184 0 226 42 255 213 208 0 0 0 0 0 37 126 60
	33 199 35 248 0 210 39 0 28 32 0 0 0 0 0 37 126 62 9 199 235 232 1 51 166 0 28 32
	0 0 0 0 0 37 126 82 7 152 35 56 0 197 226 255 213 208 0 0 0 0 0 37 126 91 35 88 94
	208 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 79 78 128 1 10 13 255 213 208 0 0 0
	0 0 37 126 62 5 88 194 88 1 27 52 0 28 32 0 0 0 0 0 37 126 91 35 76 178 136 1 10 13
	255 213 208 0 0 0 0 0 37 126 88 10 193 200 192 0 248 48 255 213 208 0 0 0 0 0 37 126
	62 15 156 184 40 1 27 28 0 28 32 0 0 0 0 0 37 126 78 34 153 84 144 1 21 136 0 28 32
	0 0 0 0 0 37 126 70 39 205 194 32 0 176 217 255 213 208 0 0 0 0 0 37 126 62 53 174
	8 240 1 41 153 0 28 32 0 0 0 0 0 37 126 62 28 99 214 104 0 210 247 0 28 32 0 0 0 0
	0 37 126 62 39 147 202 72 0 210 197 0 28 32 0 0 0 0 0 37 126 91 35 71 181 48 1 10
	13 255 213 208 0 0 0 0 0 37 126 60 45 211 192 32 0 118 59 0 28 32 0 0 0 0 0 37 126
	91 35 69 17 104 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 66 113 136 1 10 13 255
	213 208 0 0 0 0 0 37 126 91 35 61 135 184 1 10 13 255 213 208 0 0 0 0 0 37 126 91
	35 59 22 184 1 10 13 255 213 208 0 0 0 0 0 37 126 69 38 108 241 208 0 182 121 255
	213 208 0 0 0 0 0 37 126 60 11 122 223 144 0 181 101 0 28 32 0 0 0 0 0 37 126 60 0
	8 198 24 0 179 255 0 28 32 0 0 0 0 0 37 126 59 51 78 133 128 0 144 143 0 28 32 0 0
	0 0 0 37 126 69 3 72 104 136 1 6 21 255 213 208 0 0 0 0 0 37 126 91 35 74 139 192
	1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 77 39 184 1 10 13 255 213 208 0 0 0 0 0
	37 126 59 52 121 93 104 0 186 97 0 28 32 0 0 0 0 0 37 126 59 34 58 193 160 0 144 128
	0 28 32 0 0 0 0 0 37 126 83 15 1 63 96 1 6 121 255 213 208 0 0 0 0 0 37 126 60 14
	207 125 24 0 167 184 0 28 32 0 0 0 0 0 37 126 68 2 201 171 56 0 198 40 0 28 32 0 0
	0 0 0 37 126 91 35 97 1 192 1 10 13 255 213 208 0 0 0 0 0 37 126 63 50 240 209 56
	0 117 216 0 28 32 0 0 0 0 0 37 126 91 35 69 130 176 1 10 13 255 213 208 0 0 0 0 0
	37 126 91 35 66 230 184 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 63 190 32 1 10
	13 255 213 208 0 0 0 0 0 37 126 62 30 99 48 168 1 53 191 0 28 32 0 0 0 0 0 37 126
	69 39 175 73 88 1 4 91 255 213 208 0 0 0 0 0 37 126 69 19 206 1 224 0 221 171 255
	213 208 0 0 0 0 0 37 126 69 57 209 229 40 0 203 141 255 213 208 0 0 0 0 0 37 126 68
	18 77 225 240 1 51 66 255 213 208 0 0 0 0 0 37 126 13 0 0 0 0 0 180 215 0 14 16 0
	0 0 0 0 37 126 81 48 217 16 224 0 244 55 255 213 208 0 0 0 0 0 37 126 91 35 88 215
	232 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 72 42 96 1 10 13 255 213 208 0 0 0
	0 0 37 126 91 35 74 253 8 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 77 153 0 1 10
	13 255 213 208 0 0 0 0 0 37 126 63 38 173 219 0 0 160 31 0 28 32 0 0 0 0 0 37 126
	59 18 220 98 104 0 142 140 0 28 32 0 0 0 0 0 37 126 69 24 248 120 168 0 206 94 255
	213 208 0 0 0 0 0 37 126 91 35 69 247 224 1 10 13 255 213 208 0 0 0 0 0 37 126 91
	35 94 207 64 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 97 118 240 1 10 13 255 213
	208 0 0 0 0 0 37 126 63 55 70 252 88 0 219 253 0 28 32 0 0 0 0 0 37 126 91 35 67 91
	232 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 64 70 216 1 10 13 255 213 208 0 0 0
	0 0 37 126 59 4 138 51 112 0 129 215 0 28 32 0 0 0 0 0 37 126 69 21 48 127 224 0 189
	109 255 213 208 0 0 0 0 0 37 126 68 4 230 34 152 0 198 213 255 213 208 0 0 0 0 0 37
	126 60 36 114 59 16 0 130 164 0 28 32 0 0 0 0 0 37 126 59 23 219 193 240 0 192 200
	0 28 32 0 0 0 0 0 37 126 69 5 9 35 136 0 220 223 255 213 208 0 0 0 0 0 37 126 59 40
	219 156 40 0 144 245 0 28 32 0 0 0 0 0 37 126 68 40 177 21 112 1 18 146 255 213 208
	0 0 0 0 0 37 126 91 35 72 163 120 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 75 114
	56 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 78 14 48 1 10 13 255 213 208 0 0 0 0
	0 37 126 15 0 0 0 0 0 230 37 0 14 16 0 0 0 0 0 37 126 91 35 65 45 80 1 10 13 255 213
	208 0 0 0 0 0 37 126 91 35 67 209 24 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 95
	68 112 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 97 240 8 1 10 13 255 213 208 0 0
	0 0 0 37 126 60 20 253 51 16 0 181 7 0 28 32 0 0 0 0 0 37 126 59 6 109 98 192 0 125
	90 0 28 32 0 0 0 0 0 37 126 59 27 190 52 16 0 171 106 0 28 32 0 0 0 0 0 37 126 59
	38 234 1 112 0 137 14 0 28 32 0 0 0 0 0 37 126 69 20 189 9 72 0 192 204 255 213 208
	0 0 0 0 0 37 126 69 24 175 238 88 0 218 31 255 213 208 0 0 0 0 0 37 126 91 35 73 48
	24 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 75 231 104 1 10 13 255 213 208 0 0 0
	0 0 37 126 91 35 78 131 96 1 10 13 255 213 208 0 0 0 0 0 37 126 69 20 164 206 40 0
	212 74 255 213 208 0 0 0 0 0 37 126 91 35 70 112 248 1 10 13 255 213 208 0 0 0 0 0
	37 126 91 35 65 162 128 1 10 13 255 213 208 0 0 0 0 0 37 126 69 20 25 79 56 0 182
	64 255 213 208 0 0 0 0 0 37 126 91 35 95 189 136 1 10 13 255 213 208 0 0 0 0 0 37
	126 91 35 98 101 56 1 10 13 255 213 208 0 0 0 0 0 37 126 68 50 56 86 168 0 201 107
	255 213 208 0 0 0 0 0 37 126 59 10 27 1 112 0 142 202 0 28 32 0 0 0 0 0 37 126 60
	50 110 161 24 0 117 171 0 28 32 0 0 0 0 0 37 126 62 43 219 44 64 1 41 5 0 28 32 0
	0 0 0 0 37 126 68 4 12 116 8 0 197 131 255 213 208 0 0 0 0 0 37 126 59 39 18 195 8
	0 126 247 0 28 32 0 0 0 0 0 37 126 72 19 213 92 176 0 248 173 0 28 32 0 0 0 0 0 37
	126 91 35 68 70 72 1 10 13 255 213 208 0 0 0 0 0 37 126 60 48 28 158 176 1 14 193
	0 28 32 0 0 0 0 0 37 126 91 35 73 188 184 1 10 13 255 213 208 0 0 0 0 0 37 126 47
	18 37 5 0 0 190 225 0 28 32 0 0 0 0 0 37 126 91 35 76 92 152 1 10 13 255 213 208 0
	0 0 0 0 37 126 60 34 72 125 64 0 207 75 0 28 32 0 0 0 0 0 37 126 84 30 59 85 136 0
	181 183 255 213 208 0 0 0 0 0 37 126 60 14 188 43 200 0 181 83 0 28 32 0 0 0 0 0 37
	126 91 35 70 230 40 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 96 50 184 1 10 13 255
	213 208 0 0 0 0 0 37 126 59 19 99 93 24 0 184 63 0 28 32 0 0 0 0 0 37 126 59 37 58
	66 24 0 135 77 0 28 32 0 0 0 0 0 37 126 59 24 53 216 112 0 127 232 0 28 32 0 0 0 0
	0 37 126 79 57 120 13 40 0 214 126 0 28 32 0 0 0 0 0 37 126 82 46 66 100 88 0 197
	123 255 213 208 0 0 0 0 0 37 126 59 57 13 237 48 0 127 139 0 28 32 0 0 0 0 0 37 126
	62 38 121 132 144 0 114 50 0 28 32 0 0 0 0 0 37 126 75 12 95 1 232 1 27 176 255 213
	208 0 0 0 0 0 37 126 59 30 102 93 40 0 135 28 0 28 32 0 0 0 0 0 37 126 91 35 85 89
	96 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 88 4 248 1 10 13 255 213 208 0 0 0 0
	0 37 126 91 35 78 248 144 1 10 13 255 213 208 0 0 0 0 0 37 126 61 12 154 226 8 0 181
	180 0 28 32 0 0 0 0 0 37 126 91 35 71 95 64 1 10 13 255 213 208 0 0 0 0 0 37 126 91
	35 74 49 232 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 98 222 80 1 10 13 255 213
	208 0 0 0 0 0 37 126 91 35 68 187 120 1 10 13 255 213 208 0 0 0 0 0 37 126 60 18 165
	127 160 0 129 194 0 28 32 0 0 0 0 0 37 126 59 24 226 155 0 0 142 85 0 28 32 0 0 0
	0 0 37 126 91 35 66 23 176 1 10 13 255 213 208 0 0 0 0 0 37 126 59 42 215 26 32 0
	129 208 0 28 32 0 0 0 0 0 37 126 91 35 96 167 232 1 10 13 255 213 208 0 0 0 0 0 37
	126 59 17 139 139 240 0 130 231 0 28 32 0 0 0 0 0 37 126 63 31 82 44 88 0 223 179
	0 28 32 0 0 0 0 0 37 126 59 34 57 62 232 0 126 210 0 28 32 0 0 0 0 0 37 126 83 55
	83 236 216 1 25 111 255 213 208 0 0 0 0 0 37 126 69 25 179 61 40 0 188 231 255 213
	208 0 0 0 0 0 37 126 60 58 252 220 80 1 30 54 0 28 32 0 0 0 0 0 37 126 91 35 76 205
	224 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 88 126 16 1 10 13 255 213 208 0 0 0
	0 0 37 126 59 43 245 192 240 0 192 189 0 28 32 0 0 0 0 0 37 126 62 12 245 82 96 0
	113 163 0 28 32 0 0 0 0 0 37 126 91 35 71 212 112 1 10 13 255 213 208 0 0 0 0 0 37
	126 60 43 102 82 48 0 134 4 0 28 32 0 0 0 0 0 37 126 91 35 69 44 192 1 10 13 255 213
	208 0 0 0 0 0 37 126 62 3 173 143 16 0 211 85 0 28 32 0 0 0 0 0 37 126 91 35 66 140
	224 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 63 76 216 1 10 13 255 213 208 0 0 0
	0 0 37 126 60 35 58 13 24 0 180 193 0 28 32 0 0 0 0 0 37 126 59 15 164 22 224 0 135
	163 0 28 32 0 0 0 0 0 37 126 84 23 172 222 8 0 180 101 255 213 208 0 0 0 0 0 37 126
	91 35 74 167 24 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 77 67 16 1 10 13 255 213
	208 0 0 0 0 0 37 126 70 55 96 151 8 0 176 131 255 213 208 0 0 0 0 0 37 126 59 58 90
	211 216 0 192 205 0 28 32 0 0 0 0 0 37 126 59 33 195 59 248 0 164 172 0 28 32 0 0
	0 0 0 37 126 69 20 45 92 8 0 204 245 255 213 208 0 0 0 0 0 37 126 62 45 28 59 168
	0 209 100 0 28 32 0 0 0 0 0 37 126 91 35 97 33 0 1 10 13 255 213 208 0 0 0 0 0 37
	126 62 25 194 53 48 0 215 241 0 28 32 0 0 0 0 0 37 126 91 35 69 158 8 1 10 13 255
	213 208 0 0 0 0 0 37 126 91 35 67 2 16 1 10 13 255 213 208 0 0 0 0 0 37 126 59 9 190
	98 128 0 135 242 0 28 32 0 0 0 0 0 37 126 63 42 16 79 128 0 160 6 0 28 32 0 0 0 0
	0 37 126 91 35 63 221 96 1 10 13 255 213 208 0 0 0 0 0 37 126 83 2 217 129 232 1 6
	71 255 213 208 0 0 0 0 0 37 126 68 17 101 168 184 1 55 157 255 213 208 0 0 0 0 0 37
	126 63 21 240 42 72 0 159 123 0 28 32 0 0 0 0 0 37 126 59 41 215 183 56 0 142 170
	0 28 32 0 0 0 0 0 37 126 91 35 88 243 64 1 10 13 255 213 208 0 0 0 0 0 37 126 59 34
	218 233 160 1 49 1 0 28 32 0 0 0 0 0 37 126 68 56 188 8 88 1 18 224 255 213 208 0
	0 0 0 0 37 126 74 20 208 160 232 0 141 232 0 28 32 0 0 0 0 0 37 126 62 53 51 227 104
	1 40 253 0 28 32 0 0 0 0 0 37 126 91 35 77 184 64 1 10 13 255 213 208 0 0 0 0 0 37
	126 91 35 75 28 72 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 72 73 160 1 10 13 255
	213 208 0 0 0 0 0 37 126 62 12 227 233 88 1 26 22 0 28 32 0 0 0 0 0 37 126 82 20 64
	91 80 0 198 124 255 213 208 0 0 0 0 0 37 126 91 35 97 150 48 1 10 13 255 213 208 0
	0 0 0 0 37 126 91 35 94 238 128 1 10 13 255 213 208 0 0 0 0 0 37 126 82 40 23 58 184
	0 197 51 255 213 208 0 0 0 0 0 37 126 60 41 93 5 16 0 245 181 0 28 32 0 0 0 0 0 37
	126 59 51 234 213 32 0 146 132 0 28 32 0 0 0 0 0 37 126 59 9 217 124 0 0 145 43 0
	28 32 0 0 0 0 0 37 126 91 35 67 119 64 1 10 13 255 213 208 0 0 0 0 0 37 126 59 9 113
	115 48 0 143 254 0 28 32 0 0 0 0 0 37 126 59 7 17 235 216 0 184 56 0 28 32 0 0 0 0
	0 37 126 68 26 232 250 32 1 37 78 255 213 208 0 0 0 0 0 37 126 91 35 64 195 216 1
	10 13 255 213 208 0 0 0 0 0 37 126 72 43 26 10 216 0 247 225 0 28 32 0 0 0 0 0 37
	126 70 17 226 129 168 0 245 96 255 213 208 0 0 0 0 0 37 126 69 39 24 213 184 0 224
	60 255 213 208 0 0 0 0 0 37 126 63 17 77 74 112 0 220 209 0 28 32 0 0 0 0 0 37 126
	62 1 181 225 168 0 113 223 0 28 32 0 0 0 0 0 37 126 79 26 21 39 144 0 166 8 0 28 32
	0 0 0 0 0 37 126 70 56 87 172 240 0 177 31 255 213 208 0 0 0 0 0 37 126 63 41 98 143
	8 0 220 123 0 28 32 0 0 0 0 0 37 126 62 20 90 95 120 1 53 77 0 28 32 0 0 0 0 0 37
	126 91 35 78 45 112 1 10 13 255 213 208 0 0 0 0 0 37 126 62 3 246 64 112 1 25 9 0
	28 32 0 0 0 0 0 37 126 91 35 95 99 176 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35
	98 11 96 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 75 141 144 1 10 13 255 213 208
	0 0 0 0 0 37 126 91 35 72 194 184 1 10 13 255 213 208 0 0 0 0 0 37 126 68 52 244 113
	56 0 201 215 255 213 208 0 0 0 0 0 37 126 91 35 70 23 32 1 10 13 255 213 208 0 0 0
	0 0 37 126 59 29 10 79 152 0 138 179 0 28 32 0 0 0 0 0 37 126 59 43 158 89 240 0 142
	76 0 28 32 0 0 0 0 0 37 126 91 35 65 72 168 1 10 13 255 213 208 0 0 0 0 0 37 126 59
	48 142 224 176 0 125 254 0 28 32 0 0 0 0 0 37 126 62 21 198 13 8 0 209 142 0 28 32
	0 0 0 0 0 37 126 84 3 36 140 216 0 178 25 255 213 208 0 0 0 0 0 37 126 91 35 67 236
	112 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 70 140 80 1 10 13 255 213 208 0 0 0
	0 0 37 126 91 35 73 79 88 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 76 2 192 1 10
	13 255 213 208 0 0 0 0 0 37 126 91 35 78 162 160 1 10 13 255 213 208 0 0 0 0 0 37
	126 60 38 154 0 248 1 30 51 0 28 32 0 0 0 0 0 37 126 60 16 51 164 224 0 180 184 0
	28 32 0 0 0 0 0 37 126 91 35 65 193 192 1 10 13 255 213 208 0 0 0 0 0 37 126 61 56
	15 171 88 0 137 83 0 28 32 0 0 0 0 0 37 126 91 35 95 216 224 1 10 13 255 213 208 0
	0 0 0 0 37 126 91 35 98 132 120 1 10 13 255 213 208 0 0 0 0 0 37 126 75 28 188 254
	160 0 171 156 0 28 32 0 0 0 0 0 37 126 13 0 0 0 0 0 180 180 0 14 16 0 0 0 0 0 37 126
	91 35 68 97 160 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 71 5 104 1 10 13 255 213
	208 0 0 0 0 0 37 126 91 35 73 219 248 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 76
	119 240 1 10 13 255 213 208 0 0 0 0 0 37 126 59 36 85 111 248 0 128 29 0 28 32 0 0
	0 0 0 37 126 91 35 96 81 248 1 10 13 255 213 208 0 0 0 0 0 37 126 79 2 10 12 136 0
	181 42 0 28 32 0 0 0 0 0 37 126 62 52 221 196 136 0 189 108 0 28 32 0 0 0 0 0 37 126
	62 14 50 78 208 0 215 49 0 28 32 0 0 0 0 0 37 126 59 51 108 160 136 0 129 167 0 28
	32 0 0 0 0 0 37 126 82 57 140 209 144 0 197 134 255 213 208 0 0 0 0 0 37 126 58 29
	46 113 152 0 234 51 0 28 32 0 0 0 0 0 37 126 68 43 3 59 0 1 54 36 255 213 208 0 0
	0 0 0 37 126 91 35 88 32 80 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 79 23 208 1
	10 13 255 213 208 0 0 0 0 0 37 126 60 50 25 245 80 0 242 16 0 28 32 0 0 0 0 0 37 126
	91 35 71 122 152 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 74 81 40 1 10 13 255 213
	208 0 0 0 0 0 37 126 60 32 199 251 168 0 239 98 0 28 32 0 0 0 0 0 37 126 59 17 83
	7 48 0 225 216 0 28 32 0 0 0 0 0 37 126 91 35 68 218 184 1 10 13 255 213 208 0 0 0
	0 0 37 126 91 35 66 54 240 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 76 233 56 1
	10 13 255 213 208 0 0 0 0 0 37 126 59 43 182 145 40 0 182 128 0 28 32 0 0 0 0 0 37
	126 69 8 21 230 136 1 34 94 255 213 208 0 0 0 0 0 37 126 91 35 88 157 80 1 10 13 255
	213 208 0 0 0 0 0 37 126 79 36 40 100 184 0 164 47 0 28 32 0 0 0 0 0 37 126 91 35
	71 239 200 1 10 13 255 213 208 0 0 0 0 0 37 126 69 28 206 13 208 0 248 4 255 213 208
	0 0 0 0 0 37 126 91 35 96 199 40 1 10 13 255 213 208 0 0 0 0 0 37 126 62 59 107 116
	208 0 113 219 0 28 32 0 0 0 0 0 37 126 83 57 75 76 32 1 5 228 255 213 208 0 0 0 0
	0 37 126 62 22 40 139 224 1 25 2 0 28 32 0 0 0 0 0 37 126 62 44 42 156 48 0 212 110
	0 28 32 0 0 0 0 0 37 126 91 35 69 76 0 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35
	66 172 32 1 10 13 255 213 208 0 0 0 0 0 37 126 62 41 215 179 80 1 25 222 0 28 32 0
	0 0 0 0 37 126 91 35 63 119 208 1 10 13 255 213 208 0 0 0 0 0 37 126 64 57 221 102
	120 0 201 42 0 28 32 0 0 0 0 0 37 126 59 18 232 206 24 0 140 147 0 28 32 0 0 0 0 0
	37 126 91 35 74 198 88 1 10 13 255 213 208 0 0 0 0 0 37 126 68 32 63 220 0 1 37 62
	255 213 208 0 0 0 0 0 37 126 91 35 77 98 80 1 10 13 255 213 208 0 0 0 0 0 37 126 62
	47 46 176 136 0 209 104 0 28 32 0 0 0 0 0 37 126 91 35 67 33 80 1 10 13 255 213 208
	0 0 0 0 0 37 126 60 20 137 227 136 0 168 3 0 28 32 0 0 0 0 0 37 126 91 35 94 125 56
	1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 97 64 64 1 10 13 255 213 208 0 0 0 0 0
	37 126 62 9 171 161 184 0 209 227 0 28 32 0 0 0 0 0 37 126 91 35 69 189 72 1 10 13
	255 213 208 0 0 0 0 0 37 126 91 35 64 0 136 1 10 13 255 213 208 0 0 0 0 0 37 126 75
	57 28 57 88 1 12 30 0 28 32 0 0 0 0 0 37 126 62 37 240 157 176 1 36 230 0 28 32 0
	0 0 0 0 37 126 68 3 189 191 152 1 37 99 255 213 208 0 0 0 0 0 37 126 62 59 125 153
	88 1 32 234 0 28 32 0 0 0 0 0 37 126 91 35 89 18 128 1 10 13 255 213 208 0 0 0 0 0
	37 126 88 8 16 6 160 0 223 110 255 213 208 0 0 0 0 0 37 126 91 35 72 104 224 1 10
	13 255 213 208 0 0 0 0 0 37 126 91 35 75 55 160 1 10 13 255 213 208 0 0 0 0 0 37 126
	91 35 77 211 152 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 87 159 104 1 10 13 255
	213 208 0 0 0 0 0 37 126 91 35 64 238 208 1 10 13 255 213 208 0 0 0 0 0 37 126 62
	58 66 117 144 0 213 154 0 28 32 0 0 0 0 0 37 126 78 44 110 2 24 1 25 144 0 28 32 0
	0 0 0 0 37 126 91 35 95 9 216 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 97 177 136
	1 10 13 255 213 208 0 0 0 0 0 37 126 87 16 78 116 40 1 13 194 255 213 208 0 0 0 0
	0 37 126 59 18 72 232 128 0 205 105 0 28 32 0 0 0 0 0 37 126 91 35 67 150 128 1 10
	13 255 213 208 0 0 0 0 0 37 126 59 30 178 141 16 0 140 142 0 28 32 0 0 0 0 0 37 126
	82 52 18 55 40 0 197 203 255 213 208 0 0 0 0 0 37 126 62 37 222 171 240 1 53 59 0
	28 32 0 0 0 0 0 37 126 62 36 132 115 32 0 189 7 0 28 32 0 0 0 0 0 37 126 91 35 70
	50 120 1 10 13 255 213 208 0 0 0 0 0 37 126 83 27 174 77 192 1 24 181 255 213 208
	0 0 0 0 0 37 126 63 55 154 189 192 0 220 225 0 28 32 0 0 0 0 0 37 126 91 35 78 72
	200 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 75 172 208 1 10 13 255 213 208 0 0
	0 0 0 37 126 91 35 72 237 176 1 10 13 255 213 208 0 0 0 0 0 37 126 63 44 60 161 120
	0 220 222 0 28 32 0 0 0 0 0 37 126 60 54 92 35 64 0 241 252 0 28 32 0 0 0 0 0 37 126
	91 35 95 130 240 1 10 13 255 213 208 0 0 0 0 0 37 126 69 51 144 34 96 0 205 101 255
	213 208 0 0 0 0 0 37 126 91 35 98 42 160 1 10 13 255 213 208 0 0 0 0 0 37 126 59 28
	233 8 16 0 143 96 0 28 32 0 0 0 0 0 37 126 91 35 65 103 232 1 10 13 255 213 208 0
	0 0 0 0 37 126 57 52 14 153 96 0 227 130 255 157 144 0 0 0 0 0 37 126 73 26 80 52
	192 1 58 124 0 28 32 0 0 0 0 0 37 126 59 47 154 87 32 0 137 10 0 28 32 0 0 0 0 0 37
	126 80 52 27 71 120 0 224 120 0 28 32 0 0 0 0 0 37 126 83 22 47 39 72 1 25 25 255
	213 208 0 0 0 0 0 37 126 82 57 244 249 160 0 197 236 255 213 208 0 0 0 0 0 37 126
	60 15 46 164 120 0 210 35 0 28 32 0 0 0 0 0 37 126 60 2 172 99 32 0 209 25 0 28 32
	0 0 0 0 0 37 126 91 35 68 11 176 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 70 171
	144 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 73 114 128 1 10 13 255 213 208 0 0
	0 0 0 37 126 91 35 76 34 0 1 10 13 255 213 208 0 0 0 0 0 37 126 83 41 227 99 128 1
	6 50 255 213 208 0 0 0 0 0 37 126 69 4 1 68 192 0 223 114 255 213 208 0 0 0 0 0 37
	126 91 35 98 159 208 1 10 13 255 213 208 0 0 0 0 0 37 126 91 35 95 248 32 1 10 13
	255 213 208 0 0 0 0 0 37 126 83 37 93 4 136 0 190 219 255 213 208 0 0 0 0 0 37 126
	59 59 33 131 32 0 146 142 0 28 32 0 0 0 0 0 37 126 59 48 51 32 104 0 131 7 0 28 32
	0 0 0 0 0 37 126 11 0 0 0 0 1 19 6 0 14 16 0 0 0 0 22 70 76 72 111 111 107 80 114
	105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 0 1 0 2 22 70 76 72 111
	111 107 80 114 105 109 105 116 105 118 101 67 108 117 115 116 101 114 0 0 0 1 0 4
	23 70 76 86 97 114 105 97 98 108 101 79 98 106 101 99 116 67 108 117 115 116 101 114
	0 0 0 232 0 8 0 0 0 0 5 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0
	0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0
	0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0
	6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6
	0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0
	0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0
	0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0
	6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6
	0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0
	0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0
	0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0
	6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6
	0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0
	0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0
	0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0
	6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6
	0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0
	0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 42 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0
	0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0
	6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6
	0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 5 0 0 0 156 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6
	0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 43 0 0 0 6 0 0 0 6 0 0 0 6 0
	0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 6 0 0 0 5 0 6 0 124 0
	16 1 80 0 10 0 5 0 59 1 209 2 90 0 251 0 10 0 5 0 11 1 206 2 90 2 8 0 10 0 5 0 48
	1 237 0 133 1 163 0 10 0 5 0 97 1 238 0 141 0 202 2 89 0 5 0 109 2 35 2 90 1 230 0
	10 0 5 0 97 1 60 0 141 0 178 2 89 0 5 0 97 1 86 0 135 1 56 0 10 0 5 0 20 1 254 2 90
	0 175 0 10 0 5 0 88 1 153 2 90 1 69 0 10 0 5 0 79 1 162 2 90 1 233 0 10 0 5 0 153
	1 149 2 90 1 144 0 10 0 5 0 43 1 31 2 90 0 161 0 10 0 5 0 116 1 48 2 90 1 63 0 10
	0 5 0 136 0 252 0 76 0 241 0 10 0 5 0 149 0 200 2 90 1 226 0 10 0 5 0 26 1 204 2 90
	1 138 0 10 0 5 0 98 1 92 2 90 1 37 0 10 0 5 0 11 2 62 2 90 0 201 0 10 0 5 0 82 1 110
	2 90 2 29 0 10 0 5 0 42 0 254 2 90 0 155 0 10 0 5 0 142 1 195 2 90 1 43 0 10 0 5 0
	88 1 79 2 90 1 219 0 10 0 5 0 54 1 175 2 90 0 163 0 10 0 5 0 153 1 76 2 90 2 12 0
	10 0 5 0 146 0 226 0 102 0 238 0 10 0 5 0 63 2 34 0 101 1 194 0 10 0 5 0 43 1 30 2
	90 1 24 0 10 0 5 0 116 2 28 2 90 1 189 0 10 0 5 0 119 1 81 2 90 2 77 0 10 0 5 0 98
	1 223 2 90 1 36 0 10 0 5 0 11 2 58 2 90 1 62 0 10 0 5 0 82 0 225 2 90 0 208 0 10 0
	5 0 42 1 186 2 90 1 0 0 10 0 5 0 108 1 114 2 90 1 164 0 10 0 5 0 88 1 167 2 90 2 56
	0 10 0 5 0 127 0 215 0 12 1 119 0 10 0 5 0 33 2 54 2 90 1 132 0 10 0 5 0 54 2 71 2
	90 1 10 0 10 0 5 0 153 0 247 2 90 0 192 0 10 0 5 0 40 1 208 0 85 1 127 0 10 0 5 0
	43 1 158 2 90 1 151 0 10 0 5 0 77 0 195 2 90 2 40 0 10 0 5 0 119 1 197 2 90 0 243
	0 10 0 5 0 98 1 147 2 90 1 160 0 10 0 5 0 11 1 146 2 90 1 182 0 10 0 5 0 82 1 77 2
	90 1 70 0 10 0 5 0 107 2 72 0 147 2 49 0 10 0 5 0 42 1 109 2 90 1 134 0 10 0 5 0 112
	1 245 0 122 1 249 0 10 0 5 0 134 1 231 2 90 2 23 0 10 0 5 0 81 0 169 2 90 0 236 0
	10 0 5 0 54 1 94 2 90 1 142 0 10 0 5 0 93 0 185 2 90 1 50 0 10 0 5 0 78 1 154 2 90
	2 5 0 10 0 5 0 77 1 40 2 90 0 219 0 10 0 5 0 119 1 196 2 90 1 113 0 10 0 5 0 34 1
	116 0 94 2 39 0 10 0 5 0 98 1 111 2 90 2 20 0 10 0 5 0 18 1 106 2 90 1 193 0 10 0
	5 0 61 1 27 0 75 1 16 0 10 0 5 0 42 1 29 2 90 1 253 0 10 0 5 0 134 1 150 2 90 0 203
	0 10 0 5 0 81 0 168 2 90 1 101 0 10 0 5 0 54 1 220 2 90 2 4 0 10 0 5 0 105 1 58 2
	90 1 171 0 10 0 5 0 78 2 13 2 90 0 187 0 10 0 5 0 37 0 249 0 111 2 53 0 10 0 5 0 77
	1 232 2 90 1 83 0 10 0 5 0 119 2 86 2 90 1 239 0 10 0 5 0 98 1 128 2 90 0 188 0 10
	0 5 0 18 1 218 2 90 2 47 0 10 0 5 0 42 0 216 2 90 0 170 0 10 0 5 0 74 1 234 2 90 1
	64 0 10 0 5 0 31 1 9 2 90 1 227 0 10 0 5 0 28 2 52 2 90 0 177 0 10 0 5 0 105 1 169
	2 90 2 30 0 10 0 5 0 40 2 9 0 144 1 20 0 10 0 5 0 78 1 207 2 90 1 44 0 10 0 5 0 77
	1 161 2 90 1 217 0 10 0 5 0 121 1 168 2 90 0 158 0 10 0 5 0 98 1 125 2 90 1 54 0 10
	0 5 0 41 0 228 2 90 0 223 0 10 0 5 0 74 0 232 2 90 1 188 0 10 0 5 0 25 2 46 0 58 2
	74 0 10 0 5 0 31 1 8 2 90 2 78 0 10 0 5 0 28 2 22 2 90 1 35 0 10 0 5 0 105 2 65 2
	90 0 209 0 10 0 5 0 78 2 16 2 90 1 165 0 10 0 5 0 77 1 91 2 90 2 61 0 10 0 5 0 89
	1 93 2 90 1 3 0 10 0 5 0 110 1 243 2 90 1 177 0 10 0 5 0 50 0 167 2 90 1 89 0 10 0
	5 0 130 1 185 0 83 1 191 0 10 0 5 0 74 0 229 2 90 2 41 0 10 0 5 0 31 0 180 2 90 0
	244 0 10 0 5 0 28 1 221 2 90 1 159 0 10 0 5 0 105 1 68 2 90 1 71 0 10 0 5 0 78 0 179
	2 90 2 25 0 10 0 5 0 77 1 2 2 90 0 235 0 10 0 5 0 32 1 203 0 117 0 227 0 10 0 5 0
	106 0 182 2 90 1 139 0 10 0 5 0 110 1 248 2 90 2 33 0 10 0 5 0 30 0 230 2 90 1 214
	0 10 0 5 0 51 1 135 2 90 0 217 0 10 0 5 0 99 2 50 2 90 1 121 0 10 0 5 0 28 1 141 2
	90 2 18 0 10 0 5 0 68 0 197 2 90 1 192 0 10 0 5 0 34 1 116 0 27 2 85 0 10 0 5 0 78
	2 45 2 90 0 204 0 10 0 5 0 77 1 120 2 90 1 97 0 10 0 5 0 143 0 176 2 90 2 3 0 10 0
	5 0 110 1 143 2 90 0 205 0 10 0 5 0 132 1 184 2 90 2 64 0 10 0 5 0 51 0 164 2 90 1
	84 0 10 0 5 0 151 0 181 2 90 1 240 0 10 0 5 0 32 1 112 0 19 2 14 0 10 0 5 0 33 1 211
	2 90 0 213 0 10 0 5 0 28 1 67 2 90 0 189 0 10 0 5 0 68 1 100 2 90 2 48 0 10 0 5 0
	78 1 247 2 90 1 65 0 10 0 5 0 77 1 39 2 90 1 228 0 10 0 5 0 106 0 182 2 90 0 173 0
	10 0 5 0 110 1 75 2 90 1 74 0 10 0 5 0 14 2 24 2 90 0 240 0 10 0 5 0 131 0 193 0 57
	2 81 0 10 0 5 0 138 0 253 2 90 1 216 0 10 0 5 0 114 2 2 2 90 0 162 0 10 0 5 0 28 1
	181 2 90 1 53 0 10 0 5 0 86 1 96 2 90 0 224 0 10 0 5 0 33 1 55 2 90 2 43 0 10 0 5
	0 118 1 172 2 90 1 187 0 10 0 5 0 29 1 118 2 90 2 79 0 10 0 5 0 119 1 81 2 90 1 34
	0 10 0 5 0 39 2 70 0 38 1 178 0 10 0 5 0 110 1 145 2 90 1 202 0 10 0 5 0 14 1 201
	2 90 1 104 0 10 0 5 0 145 1 129 2 90 2 60 0 10 0 5 0 120 1 183 2 90 1 7 0 10 0 5 0
	28 1 107 2 90 1 174 0 10 0 5 0 36 2 82 2 90 1 90 0 10 0 5 0 52 1 51 2 90 0 156 0 10
	0 5 0 148 0 166 0 92 1 47 0 10 0 5 0 95 2 15 2 90 2 42 0 10 0 5 0 29 2 76 2 90 0 248
	0 10 0 5 0 119 1 197 2 90 1 157 0 10 0 5 0 110 1 13 2 90 2 44 0 10 0 5 0 14 2 36 2
	90 1 235 0 10 0 5 0 44 0 194 2 90 0 233 0 10 0 5 0 72 1 108 2 90 1 136 0 10 0 5 0
	28 1 199 2 90 2 27 0 10 0 5 0 36 1 205 2 90 1 215 0 10 0 5 0 67 1 126 0 55 0 184 0
	10 0 5 0 65 1 180 2 90 1 1 0 10 0 5 0 95 1 213 2 90 0 218 0 10 0 5 0 29 2 75 2 90
	1 115 0 10 0 5 0 119 1 196 2 90 2 17 0 10 0 5 0 113 1 11 2 90 0 220 0 10 0 5 0 22
	0 211 2 90 2 84 0 10 0 5 0 24 2 21 0 152 0 191 0 10 0 5 0 44 2 55 2 90 1 98 0 10 0
	5 0 72 1 33 2 90 1 255 0 10 0 5 0 28 0 186 2 90 0 206 0 10 0 5 0 150 2 11 2 90 2 66
	0 10 0 5 0 65 1 176 2 90 1 133 0 10 0 5 0 95 2 19 2 90 1 85 0 10 0 5 0 29 1 18 2 90
	1 241 0 10 0 5 0 33 1 19 2 90 1 22 0 10 0 5 0 119 2 86 2 90 0 190 0 10 0 5 0 113 1
	131 2 90 1 87 0 10 0 5 0 46 1 59 2 90 0 250 0 10 0 5 0 84 1 49 0 60 0 231 0 10 0 5
	0 44 1 246 2 90 1 229 0 10 0 5 0 56 1 140 2 90 0 174 0 10 0 5 0 28 0 183 2 90 1 73
	0 10 0 5 0 96 2 7 2 90 0 239 0 10 0 5 0 65 1 66 2 90 1 252 0 10 3 62 3 64 3 66 2 91
	3 32 2 95 2 97 2 98 3 41 3 42 3 53 3 54 2 117 2 131 2 140 2 151 2 158 2 168 2 175
	2 184 2 191 2 199 2 207 2 216 2 225 2 233 2 243 2 250 3 6 3 15 3 26 3 34 3 47 3 57
	2 94 2 105 2 116 2 127 2 138 2 148 3 14 3 25 0 5 0 154 1 26 2 90 1 212 0 10 0 5 0
	64 1 250 0 47 1 17 0 10 0 5 0 53 1 4 0 17 1 15 0 10 0 5 0 20 2 1 2 90 0 160 0 10 0
	5 0 91 2 6 2 90 1 52 0 10 0 5 0 113 1 124 2 90 1 222 0 10 0 5 0 46 1 251 2 90 1 122
	0 10 0 5 0 43 1 170 2 90 2 80 0 10 0 5 0 56 1 78 2 90 1 32 0 10 0 5 0 28 1 46 2 90
	1 198 0 10 0 5 0 115 0 222 2 90 1 105 0 10 0 5 0 137 0 242 2 90 0 171 0 10 0 5 0 34
	1 116 0 100 1 25 0 10 0 5 0 105 2 65 0 104 2 57 0 10 0 5 0 154 1 23 2 90 2 59 0 10
	0 5 0 20 0 172 2 90 1 6 0 10 0 5 0 91 1 200 2 90 1 173 0 10 0 5 0 113 0 212 2 90 2
	68 0 10 0 5 0 46 1 179 2 90 1 244 0 10 0 5 0 126 2 69 0 129 1 57 0 10 0 5 0 43 2 26
	2 90 0 246 0 10 0 5 0 29 1 18 0 70 2 73 0 10 0 5 0 49 1 156 2 90 1 155 0 10 0 5 0
	28 1 41 2 90 2 51 0 10 0 5 0 59 1 166 2 90 1 236 0 10 0 5 0 11 1 72 2 90 1 21 0 10
	0 5 0 87 0 245 2 90 2 38 0 10 0 5 0 103 1 190 2 90 0 234 0 10 0 6 0 139 0 69 1 42
	0 10 0 7 0 125 0 45 0 255 0 10 2 108 2 121 2 135 2 149 2 161 2 172 2 182 2 193 2 203
	2 214 2 226 2 237 2 248 3 4 3 18 3 30 3 45 3 59 2 101 2 114 2 129 2 143 2 155 2 166
	2 177 2 187 2 197 2 209 2 219 2 230 2 241 2 253 3 9 3 22 3 36 3 50 3 65 2 106 2 120
	2 134 2 147 2 160 2 171 2 181 2 192 2 202 2 213 2 224 2 236 2 247 3 3 3 17 3 29 3
	44 3 58 2 100 2 113 2 126 2 142 2 154 2 165 2 176 2 186 2 196 2 206 2 218 2 229 2
	240 2 252 3 8 3 21 3 35 3 49 3 63 2 104 2 119 2 133 2 146 2 159 2 170 2 180 2 190
	2 201 2 212 2 223 2 235 2 246 3 1 3 16 3 28 3 43 3 56 2 99 2 112 2 125 2 141 2 153
	2 164 2 174 2 185 2 195 2 205 2 217 2 228 2 239 2 251 3 7 3 20 3 33 3 48 3 61 2 103
	2 118 2 132 2 145 2 157 2 169 2 179 2 189 2 200 2 211 2 222 2 234 2 245 3 0 3 13 3
	27 3 40 3 55 2 96 2 111 2 124 2 139 2 152 2 163 3 2 2 128 2 208 2 221 2 232 2 244
	2 255 3 11 3 24 3 38 3 52 2 93 2 109 2 122 2 136 3 39 0 5 0 20 1 14 2 90 1 137 0 10
	0 5 0 91 1 123 2 90 2 32 0 10 0 5 0 79 2 87 2 90 0 237 0 10 0 5 0 35 1 103 2 90 0
	165 0 10 0 5 0 65 1 66 0 21 1 148 0 10 0 5 0 43 1 224 2 90 1 117 0 10 0 5 0 49 0 159
	2 90 2 10 0 10 0 5 0 28 0 198 2 90 0 221 0 10 0 5 0 59 1 28 2 90 2 83 0 10 0 5 0 11
	1 210 2 90 1 152 0 10 0 5 0 98 1 128 0 73 1 130 0 10 0 7 0 123 0 90 1 61 0 10 2 110
	2 123 2 137 2 150 2 162 2 173 2 183 2 194 2 204 2 215 2 227 2 238 2 249 3 5 3 19 3
	31 3 46 3 60 2 102 2 115 2 130 2 144 2 156 2 167 2 178 2 188 2 198 2 210 2 220 2 231
	2 242 2 254 3 10 3 23 3 37 3 51 2 92 2 107 0 5 0 66 2 37 2 90 1 99 0 10 0 5 0 20 2
	63 2 90 2 0 0 10 0 5 0 13 1 5 0 80 1 225 0 10 0 5 0 71 1 45 2 90 0 207 0 10 0 5 0
	79 0 214 2 90 1 102 0 10 0 5 0 35 1 38 2 90 1 12 0 10 0 5 0 43 2 31 2 90 1 242 0 10
	0 5 0 97 0 199 0 15 1 82 0 10 0 5 0 49 0 157 2 90 0 196 0 10 0 5 0 62 2 88 0 23 1
	95 0 10 0 5 0 140 2 67 2 90 1 88 0 10 0 6 0 62 0 128 0 210 0 10 3 12]! !

Object subclass: #GTADateAndTimeStringBuilder
	instanceVariableNames: 'dateAndTime duration numberOfLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Utilities'!

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
dateAndTime
	^ dateAndTime! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
dateAndTime: anObject
	dateAndTime := anObject! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
duration
	^ duration! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:21'!
duration: anObject
	duration := anObject! !

!GTADateAndTimeStringBuilder methodsFor: 'printing' stamp: 'JurajKubelka 5/18/2015 12:13'!
humanReadablePrintString
	self duration days > self numberOfLabels ifTrue: [ ^ self dateAndTime asDate printString ].
	self duration days > 1 ifTrue: [ ^ String streamContents: [ :aStream | 
			self dateAndTime printSeparateDateAndTimeOn: aStream ] ]. 
	^ self dateAndTime asTime print24! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:24'!
numberOfLabels
	^ numberOfLabels! !

!GTADateAndTimeStringBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 18:24'!
numberOfLabels: anObject
	numberOfLabels := anObject! !

Object subclass: #GTADefaultTimelineConfiguration
	instanceVariableNames: 'lastBuilder withEdges layout shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Activity'!

GTADefaultTimelineConfiguration class
	instanceVariableNames: 'uniqueInstance'!

GTADefaultTimelineConfiguration class
	instanceVariableNames: 'uniqueInstance'!

!GTADefaultTimelineConfiguration class methodsFor: 'cleanup' stamp: 'JurajKubelka 4/15/2015 16:10'!
cleanUp
	self reset.! !

!GTADefaultTimelineConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 16:09'!
reset
	"self reset"
	uniqueInstance := nil! !

!GTADefaultTimelineConfiguration class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:52'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'api' stamp: 'JurajKubelka 4/17/2015 11:32'!
configure: builder 
	builder
		withEdges: self withEdges;
		layout: self layout.
	builder shape shape: self shape.
	builder interaction
		popupText: #asEventAnalysisString;
		draggable.
	builder interaction showEdge
		connectTo: [ :event | 
			event isUserSelection
				ifFalse: [ RTGroup new ]
				ifTrue: [ 
					builder view elements
						select: [ :eachElement | eachElement model isSpotterEvent
								and: [ eachElement model isUserSelection
								and: [ eachElement model elementName = event elementName ] ] ]
						thenCollect: #model ] ];
		shape: [ :el | RTLine new color: (Color blue alpha: 0.4) ] ! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 14:56'!
layout
	^ layout ifNil: [ layout := GTAHorizontalDivingLineLayout new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:04'!
layout: aLayout 
	layout := aLayout! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 14:11'!
shape
	^ shape ifNil: [ shape := GTAOrthogonalSymbolBuilder new ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:05'!
shape: aShape 
	shape := aShape! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/17/2015 14:32'!
withEdges
	^ withEdges ifNil: [ withEdges := false ]! !

!GTADefaultTimelineConfiguration methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:05'!
withEdges: aBoolean 
	withEdges := aBoolean! !

Object subclass: #GTAEmptyBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

GTAEmptyBookmark subclass: #GTABookmark
	instanceVariableNames: 'item description dateAndTime garbage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTABookmark class methodsFor: 'instance creation' stamp: 'JurajKubelka 5/20/2015 11:05'!
from: pathCollection computers: aGTAComputers 
	^ pathCollection first new from: pathCollection computers: aGTAComputers! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:30'!
dateAndTime
	^ dateAndTime! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:30'!
dateAndTime: anObject
	dateAndTime := anObject! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:25'!
description
	^ description! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:25'!
description: anObject
	description := anObject! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:13'!
garbage
	^ garbage! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:14'!
garbage: aBoolean
	garbage := aBoolean! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:14'!
garbageString
	^ self garbage
		ifTrue: 'yes'
		ifFalse: 'no'! !

!GTABookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 10:13'!
initialize
	super initialize.
	dateAndTime := DateAndTime now.
	garbage := false.! !

!GTABookmark methodsFor: 'testing' stamp: 'JurajKubelka 5/14/2015 10:59'!
isRelatedTo: anObject 
	^ self item = anObject ! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:29'!
item
	^ item! !

!GTABookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/13/2015 16:29'!
item: anObject
	item := anObject! !

!GTABookmark methodsFor: 'instance creation' stamp: 'JurajKubelka 5/19/2015 15:26'!
newDetachedBookmark: aPathCollection
	^ GTADetachedBookmark new
			path: aPathCollection;
			yourself! !

!GTABookmark methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 10:22'!
toggleGarbage
	self garbage: self garbage not! !

GTABookmark subclass: #GTAComputerBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTAComputerBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:26'!
from: aCollection computers: aGTAComputers 
	| computer |
	computer := aGTAComputers 
						detect: [ :each | each computerUUID = aCollection second ]
						ifNone: [ ^ self newDetachedBookmark: aCollection ].
	self
		item: computer;
		description: aCollection third;
		dateAndTime: aCollection fourth;
		garbage: aCollection fifth! !

!GTAComputerBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:54'!
path
	^ Array
		with: self class
		with: self item computerUUID
		with: self description
		with: self dateAndTime
		with: self garbage! !

!GTAComputerBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:05'!
typeName
	^ 'computer'! !

GTABookmark subclass: #GTASessionBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTASessionBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:22'!
from: aCollection computers: aGTAComputers 
	| computer session |
	computer := aGTAComputers 
						detect: [ :each | each computerUUID = aCollection second ] 
						ifNone: [ ^ self newDetachedBookmark: aCollection ].
	session := computer 
						detect: [ :each | each start = aCollection third ] 
						ifNone: [ ^ self newDetachedBookmark: aCollection ].
	self
		item: session;
		description: aCollection fourth;
		dateAndTime: aCollection fifth;
		garbage: aCollection sixth! !

!GTASessionBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:55'!
path
	^ Array
		with: self class
		with: self item computerUUID
		with: self item start
		with: self description
		with: self dateAndTime
		with: self garbage! !

!GTASessionBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 10:05'!
typeName
	^ 'session'! !

GTABookmark subclass: #GTASomeSessionsBookmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTASomeSessionsBookmark methodsFor: 'as yet unclassified' stamp: 'JurajKubelka 5/31/2015 12:59'!
from: aCollection computers: aGTAComputers 
	| computer |
	self item: (GTASomeSessions new: aCollection size - 5).
	computer := aGTAComputers 
		detect: [ :eachComputer | eachComputer computerUUID = (aCollection at: 2) ]
		ifNone: [  ^ self newDetachedBookmark: aCollection ].
	self item computer: computer.
	self description: (aCollection at: 3).
	self dateAndTime: (aCollection at: 4).
	self garbage: (aCollection at: 5).
	6 to: aCollection size do: [ :index |
		self item add: (GTABookmark from: (aCollection at: index) computers: aGTAComputers) item ].
! !

!GTASomeSessionsBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 11:19'!
path
	| collection |
	collection := (Array new: self item size + 5).
	collection at: 1 put: self class.
	collection at: 2 put: self item computer computerUUID.
	collection at: 3 put: self description.
	collection at: 4 put: self dateAndTime.
	collection at: 5 put: self garbage.
	1 to: self item size do: [ :index |
		collection at: index + 5 put: (GTASessionBookmark new item: (self item at: index)) path.
	].
	^ collection! !

!GTASomeSessionsBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 10:10'!
typeName
	^ 'sessions'! !

GTAEmptyBookmark subclass: #GTADetachedBookmark
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Bookmarks'!

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:32'!
description
	^ String streamContents: [ :aStream |
		aStream 
			nextPutAll: 'Not found bookmark of ';
			print: self path
		 ]! !

!GTADetachedBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:24'!
from: aCollection computers: aGTAComputers 
	self shouldNotImplement ! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/20/2015 11:30'!
garbageString
	^ ''! !

!GTADetachedBookmark methodsFor: 'testing' stamp: 'JurajKubelka 5/19/2015 15:25'!
isRelatedTo: anObject
	^ false! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:32'!
item
	^ self path! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:23'!
path
	^ path! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:23'!
path: aPathCollection
	path := aPathCollection! !

!GTADetachedBookmark methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 15:24'!
toggleGarbage
	"do nothing"! !

!GTADetachedBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:23'!
typeName
	^ 'detached'! !

!GTAEmptyBookmark methodsFor: 'initialization' stamp: 'JurajKubelka 5/19/2015 15:19'!
from: aCollection computers: aGTAComputers 
	self subclassResponsibility! !

!GTAEmptyBookmark methodsFor: 'testing' stamp: 'JurajKubelka 5/19/2015 15:18'!
isRelatedTo: anObject
	^ self subclassResponsibility! !

!GTAEmptyBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:19'!
path
	^ self subclassResponsibility.! !

!GTAEmptyBookmark methodsFor: 'api' stamp: 'JurajKubelka 5/19/2015 15:19'!
toggleGarbage
	self subclassResponsibility! !

!GTAEmptyBookmark methodsFor: 'accessing' stamp: 'JurajKubelka 5/19/2015 15:19'!
typeName
	^ self subclassResponsibility! !

Object subclass: #GTAEventIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Obsolete'!

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:36'!
actOnIcon
	^ Smalltalk ui icons glamorousPlay! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:43'!
contextChangedIcon
	^ Smalltalk ui icons glamorousEdit  ! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:20'!
diveInCategoryIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon  ! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInCategoryMissStepIcon
	^ Smalltalk ui icons glamorousDiveAllRightIcon
		deepCopy 
			mapColor: (Color r: 0.581 g: 0.581 b: 0.581 alpha: 1.0)
			to: Color red! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
diveInElementIcon
	^ Smalltalk ui icons glamorousDiveRightIcon  ! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 20:55'!
diveInElementMissStepIcon
	^ Smalltalk ui icons glamorousDiveRightIcon 
			deepCopy mapColor: Color black to: Color red! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:41'!
diveOutIcon
	^ Smalltalk ui icons glamorousLeft  ! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:46'!
exitIcon
	^ Smalltalk ui icons glamorousClose  ! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
hidePreviewIcon
	^ Smalltalk ui icons glamorousZoomOut! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:26'!
noIcon
	^ Smalltalk ui icons protocolNoneIcon! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 12:45'!
selectedCandidateChangedIcon
	^ Smalltalk ui icons glamorousGrayCircle  ! !

!GTAEventIcons class methodsFor: 'icons' stamp: 'JurajKubelka 4/9/2015 13:37'!
showPreviewIcon
	^ Smalltalk ui icons glamorousZoomIn! !

Object subclass: #GTAMenuTimelineBuilder
	instanceVariableNames: 'timelineBuilder menuBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTAMenuTimelineBuilder methodsFor: 'building' stamp: 'JurajKubelka 5/18/2015 15:23'!
build
	self renderIn: timelineBuilder view.! !

!GTAMenuTimelineBuilder methodsFor: 'event handling' stamp: 'JurajKubelka 6/9/2015 14:00'!
clean
	| elements normalizer  |
	elements := timelineBuilder elements.
	normalizer := RTMultiLinearColorForIdentity new 
							objects: elements;
							yourself.
	elements do: [ :element |
		element trachelShape 
			color: (normalizer rtValue: element);
			strokePaint: Color transparent ].
	timelineBuilder view signalUpdate! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - intensity' stamp: 'JurajKubelka 5/19/2015 14:22'!
divingUsage
	self numberOfOccurrences: #divesIn inform: 'No dives-in.'
! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - usage' stamp: 'JurajKubelka 6/4/2015 17:06'!
highlightComposedQueries
	self highlightSessionsWithEvents: [ :eachEvent | 
		(eachEvent isSearchFinished and: [ (eachEvent currentQuerySpecials reject: [ :b | b = true ]) size > 1 ]) 
			and: [ eachEvent notEmptyCategories isEmpty ] ]! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - usage' stamp: 'JurajKubelka 6/9/2015 15:18'!
highlightDivesIn
	self highlightSessionsWithEvents: [ :eachEvent | eachEvent isDiveIn ]! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - usage' stamp: 'JurajKubelka 6/4/2015 17:38'!
highlightPharo5Users
	self highlightSessionsWithEvents: [ :eachEvent | 
		eachEvent latestUpdate >= 50000 ]! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - usage' stamp: 'JurajKubelka 6/4/2015 17:06'!
highlightSessionsWithEvents: aBlock
	timelineBuilder elements do: [ :eachElement | | color |
		(eachElement model anyEventSatisfy: aBlock)
			ifTrue: [ color := Color red ]
			ifFalse: [ color := Color white ].
		eachElement trachelShape 
			color: color;
			strokePaint: (Color black alpha: 0.4) ].
	timelineBuilder view signalUpdate! !

!GTAMenuTimelineBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/18/2015 15:23'!
initialize
	super initialize.
	menuBuilder := RTMenuBuilder new.! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - intensity' stamp: 'JurajKubelka 5/19/2015 14:18'!
keywordUsage
	self numberOfOccurrences: #specialKeywords inform: 'No keywords.'
! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - intensity' stamp: 'JurajKubelka 5/20/2015 16:30'!
numberOfOccurrences: aSymbol inform: aNoOccurrencesString
	| elements keywords normalizer maxKeywords |
	elements := timelineBuilder elements.
	keywords := elements collect: [ :e | e -> (e model perform: aSymbol) size ].
	maxKeywords := keywords max: [ :assoc | assoc value ].
	maxKeywords = 0 ifTrue: [ 
		self inform: aNoOccurrencesString.
		^ self ].
	normalizer := RTGrayLinearColor new.
	normalizer command: #yourself; scope: (0 to: maxKeywords).
	elements do: [ :element | | elementKeywords |
		elementKeywords := keywords detect: [ :assoc | assoc key == element ].
		element trachelShape 
			color: (normalizer rtValue: elementKeywords value);
			strokePaint: (Color black alpha: 0.4) ].
	timelineBuilder view signalUpdate! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - intensity' stamp: 'JurajKubelka 6/9/2015 13:55'!
numberOfSessions
	self numberOfOccurrences: #sessions inform: 'There is not any session.'
! !

!GTAMenuTimelineBuilder methodsFor: 'hooks' stamp: 'JurajKubelka 6/9/2015 15:19'!
renderIn: aView
	menuBuilder view: aView.
	menuBuilder menu: 'Feature Intensity' submenu: 'Number of Sessions' callback: [ self numberOfSessions ].
	menuBuilder menu: 'Feature Intensity' submenu: 'Keyword Usage' callback: [ self keywordUsage ].
	menuBuilder menu: 'Feature Intensity' submenu: 'Diving Usage' callback: [ self divingUsage ].
	menuBuilder menu: 'Feature Intensity' submenu: 'Unknown items' callback: [ self unknownItems ].

	menuBuilder menu: 'Feature Usage' submenu: 'Composed Queries Usage' callback: [ self highlightComposedQueries ].
	menuBuilder menu: 'Feature Usage' submenu: 'Dive-In Usage' callback: [ self highlightDivesIn ].
	menuBuilder menu: 'Feature Usage' submenu: 'Pharo 5 Images Usage' callback: [ self highlightPharo5Users ].

	menuBuilder menu: 'Clean' callback: [ self clean ].
! !

!GTAMenuTimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 15:22'!
timelineBuilder
	^ timelineBuilder! !

!GTAMenuTimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/18/2015 15:22'!
timelineBuilder: anObject
	timelineBuilder := anObject! !

!GTAMenuTimelineBuilder methodsFor: 'event handling - intensity' stamp: 'JurajKubelka 5/19/2015 12:30'!
unknownItems
	self numberOfOccurrences: #unknownNames inform: 'No unknown names.'! !

Object subclass: #GTAMultipleSelectionSendCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Utilities'!

GTAMultipleSelectionSendCommand class
	instanceVariableNames: 'uniqueInstance'!

GTAMultipleSelectionSendCommand class
	instanceVariableNames: 'uniqueInstance'!

!GTAMultipleSelectionSendCommand class methodsFor: 'api' stamp: 'JurajKubelka 5/11/2015 11:01'!
selection: result in: aCollection
	^ self new selection: result in: aCollection! !

!GTAMultipleSelectionSendCommand class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 19:42'!
selection: result in: aCollection as: aCollectionClass
	^ self new selection: result in: aCollection as: aCollectionClass! !

!GTAMultipleSelectionSendCommand class methodsFor: 'accessing' stamp: 'JurajKubelka 4/15/2015 15:24'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!GTAMultipleSelectionSendCommand methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 19:39'!
selection: result in: aCollection
	^ self selection: result in: aCollection as: aCollection species! !

!GTAMultipleSelectionSendCommand methodsFor: 'api' stamp: 'JurajKubelka 5/14/2015 12:28'!
selection: result in: aCollection as: aCollectionClass
	^ result notNil 
		ifTrue: [ 
			(result size = 1)
				ifTrue: [result anyOne] 
				ifFalse: [ aCollectionClass withAll: result ] ]
		ifFalse: [ result ]! !

Object subclass: #GTAObsoleteActivityBuilder
	instanceVariableNames: 'data view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Obsolete'!

!GTAObsoleteActivityBuilder class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 18:34'!
viewOn: objects
	^ self new
			data: objects;
			build;
			view! !

!GTAObsoleteActivityBuilder methodsFor: 'building' stamp: 'JurajKubelka 4/14/2015 11:17'!
build
	| shape elements visibleData levels |
	view := RTView new.
	view @ RTDraggableView.
	shape := RTBitmap new.
	shape form: #analysisIcon.
	visibleData := self visibleData.
	levels := visibleData deepestDiveIn.
	elements := shape elementsOn: visibleData.
	elements @ RTDraggable @ (RTPopup text: #asEventAnalysisString).
	view addAll: elements.
	"RTGridLayout on: elements."
	RTMetricNormalizer new
		elements: elements;
		normalizeX: [ :eachEvent | self xFor: eachEvent ] min: 0 max: 500;
		normalizeY: [ :eachEvent | self yFor: eachEvent ] min: 0 max: (levels * 4).
! !

!GTAObsoleteActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data
	^ data! !

!GTAObsoleteActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:34'!
data: anObject
	data := anObject! !

!GTAObsoleteActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view
	^ view! !

!GTAObsoleteActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 18:35'!
view: anObject
	view := anObject! !

!GTAObsoleteActivityBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 4/9/2015 19:52'!
visibleData
	^ self data select: #isForTimelineView! !

!GTAObsoleteActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/11/2015 23:14'!
xFor: aSpotterEvent
	| currentTimeStamp index events nextTimestamp duration relIndex relDuration xPosition |
	aSpotterEvent relativeXPosition ifNotNil: [ :value | ^ value ].
	currentTimeStamp := aSpotterEvent dateAndTimeWithFixedTimeZone.
	index := aSpotterEvent myPositionAmongSameTimeEvents - 1.
	events := aSpotterEvent sameTimeEvents size.
	events < 2 ifTrue: [ 
		aSpotterEvent relativeXPosition: currentTimeStamp. 
		^ currentTimeStamp ].
	relIndex := index / events.
	nextTimestamp := aSpotterEvent followingDifferentTime.
	duration := nextTimestamp - currentTimeStamp / 2.
	relDuration := duration * relIndex.
	xPosition := currentTimeStamp + relDuration.
	aSpotterEvent relativeXPosition: xPosition.
	^ xPosition! !

!GTAObsoleteActivityBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 4/9/2015 20:15'!
yFor: aSpotterEvent
	^ aSpotterEvent diveInLevel! !

Object subclass: #GTAPrintDateAndTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Utilities'!

!GTAPrintDateAndTime class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 13:48'!
yyyyMmDdAndHhMmSs: aDateAndTimeOrZero
	"Returns YYYY-MM-DD, HH:MM:SS in UTC time."
	aDateAndTimeOrZero = 0 ifTrue: [ ^ 'unknown' ].
	^ String streamContents: [ :aStream |
		aDateAndTimeOrZero asUTC printYMDOn: aStream.
		aStream nextPutAll: ', '.
		aDateAndTimeOrZero asUTC printHMSOn: aStream ] ! !

Object subclass: #GTARoughDataSetBuilder
	instanceVariableNames: 'objects groups comparator gap newGroupBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTARoughDataSetBuilder methodsFor: 'adding' stamp: 'JurajKubelka 5/11/2015 17:09'!
addToActualGroup: anObject 
	self ensureGroup.
	self groups last addLast: anObject.! !

!GTARoughDataSetBuilder methodsFor: 'adding' stamp: 'JurajKubelka 5/14/2015 17:58'!
addToNewGroup: anObject
	^ self groups add: (self newGroupObject add: anObject; yourself) ! !

!GTARoughDataSetBuilder methodsFor: 'building' stamp: 'JurajKubelka 5/11/2015 18:14'!
build
	| lastObject |
	lastObject := self objects first.
	self objects doWithIndex: [ :object :index |
		index > 1 
			ifTrue: [ 
				(comparator cull: object cull: lastObject) < self gap
					ifTrue: [ self addToActualGroup: object ]
					ifFalse: [ self addToNewGroup: object ] ]
			ifFalse: [ self addToNewGroup: object ].
		lastObject := object.
	 ].
! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:50'!
comparator
	^ comparator! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:50'!
comparator: anObject
	comparator := anObject! !

!GTARoughDataSetBuilder methodsFor: 'private' stamp: 'JurajKubelka 5/14/2015 17:57'!
ensureGroup
	self groups ifEmpty: [ :aGroup | aGroup add: self newGroupObject ]! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 18:14'!
gap
	^ gap! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 18:14'!
gap: anInteger 
	gap := anInteger! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
groupClass: aClass
	self newGroupBlock: [ aClass new ]! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:55'!
groups
	^ groups ifNil: [ groups := GTAGroups new ]! !

!GTARoughDataSetBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/14/2015 17:58'!
initialize
	super initialize.
	comparator := [ :actualObject :previousObject | actualObject - previousObject ].
	newGroupBlock := [ GTAGroup new ].! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupBlock
	^ newGroupBlock! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupBlock: aBlockClosure 
	newGroupBlock := aBlockClosure! !

!GTARoughDataSetBuilder methodsFor: 'instance creation' stamp: 'JurajKubelka 5/14/2015 17:59'!
newGroupObject
	^ self newGroupBlock value! !

!GTARoughDataSetBuilder methodsFor: 'helpers' stamp: 'JurajKubelka 5/11/2015 17:13'!
numberOfGroups
	^ self groups size ! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/11/2015 17:07'!
objects
	^ objects! !

!GTARoughDataSetBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 5/12/2015 09:55'!
objects: aCollection 
	objects := aCollection.
	groups := nil.! !

!GTARoughDataSetBuilder methodsFor: 'initialization' stamp: 'JurajKubelka 5/12/2015 09:51'!
setSessionComparator
	self comparator: [ :actualObject :previousObject | actualObject start - previousObject end ]! !

Object subclass: #GTASessionAnalysis
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTASessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 3/31/2015 11:50'!
executeOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) execute! !

!GTASessionAnalysis class methodsFor: 'instance creation' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: aGTSpotterSession 
	^ self new session: aGTSpotterSession; yourself! !

!GTASessionAnalysis class methodsFor: 'api' stamp: 'JurajKubelka 4/9/2015 11:13'!
updateOn: aGTSpotterSession
	^ (self session: aGTSpotterSession) clean; execute! !

!GTASessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 4/13/2015 14:52'!
analyze: aCollection 
	self 
		session: aCollection;
		clean; 
		execute! !

!GTASessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 6/4/2015 14:07'!
clean
	(GTACommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command clean ].
	^ self session! !

!GTASessionAnalysis methodsFor: 'execute' stamp: 'JurajKubelka 6/4/2015 14:07'!
execute
	(GTACommand allSubclasses 
		sort: [ :a :b | a analysisOrder < b analysisOrder ]) 
			do: [ :each | | command |
				command := each context: self.
				command execute ].
	^ self session! !

!GTASessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session
	^ session! !

!GTASessionAnalysis methodsFor: 'accessing' stamp: 'JurajKubelka 3/31/2015 11:28'!
session: anObject
	session := anObject! !

Object subclass: #GTASessionBuilder
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Builders'!

!GTASessionBuilder commentStamp: 'JurajKubelka 3/31/2015 11:24' prior: 0!
I'm a session builder, I receive collected announcements and split events per computer and per session. Session starts with opening Spotter and finishs on closing Spotter.!

!GTASessionBuilder class methodsFor: 'api' stamp: 'JurajKubelka 3/30/2015 15:48'!
fromEvents: aCollection 
	^ self new events: aCollection; sessions! !

!GTASessionBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 3/30/2015 15:48'!
events: aCollection 
	events := aCollection! !

!GTASessionBuilder methodsFor: 'enumerating' stamp: 'JurajKubelka 5/11/2015 16:11'!
sessions 
	| borders pairs openOrExit previousAssociation computer |
	events ifEmpty: [ ^ GTAComputer new ].
	borders := events withIndexCollect: [ :event :index |
		event isOpenOrCloseSpotter 
				ifTrue: [ index -> event ]
				ifFalse: [ nil ]
		 ].
	borders := borders select: [ :each | each notNil ].
	pairs := OrderedCollection new.
	openOrExit := #open.
	previousAssociation := borders first.
	borders do: [ :eachAssociation |
		(openOrExit = #open) 
			ifTrue: [ 
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs addLast: eachAssociation. 
					openOrExit := #exit ] ]
			ifFalse: [ 
				eachAssociation value isCloseSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> eachAssociation. 
					openOrExit := #open ].
				eachAssociation value isOpenSpotter ifTrue: [ 
					pairs at: (pairs size) put: (pairs last) -> previousAssociation.
					pairs addLast: eachAssociation.
					openOrExit := #exit ] ].
		previousAssociation := eachAssociation.
	].
	openOrExit = #exit ifTrue: [ pairs removeLast ].
	computer := pairs collect: [ :eachPair | | open exit |
		open := eachPair key.
		exit := eachPair value.
		GTASession withAll: (events copyFrom: open key to: exit key).
		 ] as: GTAComputer.
	computer do: [ :eachSession | eachSession computer: computer ].
	^ computer! !

Object subclass: #GTASessionExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Tests'!

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 6/8/2015 17:15'!
allRecordedExamples
	"self allRecordedExamples"
	^ GTAAnnouncements spotterUsersAndDevelopersFromAllByteArrays: self recordedSessionExamples.! !

!GTASessionExamples class methodsFor: 'utility' stamp: 'JurajKubelka 6/8/2015 17:01'!
compileCurrentDataInto: aMethodName
	"It compiles data stored in GTSpotterEventRecorder."
	"self compileCurrentDataInto: #dataSample"
	| collection |
	collection := OrderedCollection new.
	GTSpotterEventRecorder instance primitivePrepareDeliveryData.
	GTSpotterEventRecorder instance deliveryQueue
		flush: [ :eachItem | collection add: eachItem ].
	collection ifEmpty: [ ^ self inform: 'No data.' ].
	self class compile: (String streamContents: [ :methodStream | | chars |
			chars := 0.
			methodStream 
				nextPutAll: aMethodName asString; cr;
				tab; nextPutAll: '"Automatically created by class method #compileCurrentDataInto: #';
					nextPutAll: aMethodName asString; nextPutAll: '."'; cr;
				tab; nextPut: $"; nextPutAll: GTAAnnouncements name asString; space; 
					nextPutAll: #spotterUsersAndDevelopersFrom: asString;
					nextPutAll: ' self '; nextPutAll: aMethodName asString; nextPutAll: '."'; cr;
				tab; nextPutAll: '<gtaRecordedSessionExamples: '; 
					print: self recordedSessionPragmas size + 1; nextPut: $>; cr;
				tab; nextPutAll: '^ '.
			(String streamContents: [ :s | 
				collection first storeOn: s ]) do: [ :char | 
					(char isSeparator and: [ (chars > 80) ]) 
						ifTrue: [ chars := 0. methodStream cr; tab ]
						ifFalse: [ chars := chars + 1. methodStream nextPut: char ] ] ])
				! !

!GTASessionExamples class methodsFor: 'accessing - recorded sessions' stamp: 'JurajKubelka 6/8/2015 16:49'!
lotOfSelectionsDataSample
	"Automatically created by class method #compileCurrentDataInto: #lotOfSelectionsDataSample."
	"GTAAnnouncements spotterUsersAndDevelopersFrom: self lotOfSelectionsDataSample."
	<gtaRecordedSessionExamples: 1>
	^ #[31 139 8 0 0 0 0 0 0 0 133 88 121 56 148 253 26 30 100 23 217 119 146 146 50 182
49 52 36 14 34 203 144 125 73 140 193 96 52 11 51 99 203 146 37 100 45 90 144 45 68
182 16 77 246 125 203 190 100 77 141 93 72 6 33 100 57 234 244 157 190 115 157 239
59 231 119 93 239 123 189 239 115 63 207 239 121 126 247 253 252 241 190 143 150 153
38 20 208 68 1 0 0 88 0 255 90 180 28 90 208 107 40 172 61 28 165 129 130 227 241
26 40 15 60 1 129 59 6 168 233 180 160 218 8 184 35 2 199 166 227 136 192 16 144 4
159 171 72 7 2 18 139 129 227 124 24 212 125 8 8 19 31 180 61 22 197 122 29 119 236
131 112 212 192 162 80 136 159 56 139 25 198 17 225 132 196 32 28 175 219 187 30 155
132 180 160 134 88 60 146 128 244 68 64 76 208 112 20 74 7 67 64 56 35 112 191 115
81 1 40 40 185 142 211 97 177 183 12 113 72 244 79 215 223 40 5 21 11 14 225 128 253
145 198 28 129 195 31 103 248 31 190 212 199 231 209 66 122 255 145 251 79 8 197 9
94 55 28 66 31 126 252 138 132 163 144 183 225 63 106 85 251 89 49 158 21 238 232
136 252 121 54 212 191 226 240 124 110 88 60 225 175 157 89 208 255 105 22 212 130
254 102 230 55 13 127 74 77 249 227 198 171 5 53 65 162 221 80 136 191 114 161 60
241 75 15 192 73 38 102 134 31 238 244 116 127 88 24 143 47 222 95 207 12 127 39 23
13 253 15 73 212 112 56 248 47 113 8 56 36 198 249 79 58 49 94 61 174 90 13 227 104
138 68 35 68 174 153 154 184 97 9 199 145 198 191 136 61 6 225 106 24 12 214 3 227
128 64 31 171 205 240 251 68 194 191 229 147 85 248 107 253 40 210 178 255 94 18 74
202 179 16 135 75 142 114 114 246 96 73 89 25 144 188 36 24 100 47 39 9 113 116 0
75 130 225 32 123 123 57 144 131 60 28 12 162 51 116 129 227 176 96 41 153 255 223
46 148 116 255 163 91 142 153 60 23 96 45 174 112 122 10 176 199 123 52 220 255 147
182 99 11 235 141 80 113 192 209 147 95 150 191 143 167 163 162 71 162 225 206 8 109
56 222 229 132 227 49 45 236 120 4 254 71 211 105 224 16 63 229 254 65 32 147 3 22
237 230 113 28 96 102 166 115 149 158 112 108 193 19 224 104 55 14 132 231 49 119
198 255 217 172 76 168 99 226 241 4 51 183 227 205 16 76 63 247 254 133 252 137 89
57 208 223 48 75 77 52 0 178 107 65 127 232 248 223 29 13 0 48 223 16 142 250 163
81 122 172 124 111 154 34 72 71 7 66 60 24 42 166 75 156 167 8 166 134 28 87 53 141
238 214 76 137 235 168 157 226 214 48 193 39 42 54 45 126 72 145 19 119 201 78 202
174 118 66 87 101 87 94 120 242 70 47 7 105 158 227 57 0 142 233 100 68 39 231 101
87 162 115 146 136 85 227 69 195 82 101 245 120 200 91 124 24 197 184 42 169 239 83
107 31 62 237 211 238 97 64 31 249 80 25 159 230 96 187 251 156 18 114 15 240 44 228
73 125 67 98 77 240 196 203 88 221 172 97 59 249 200 204 198 27 162 85 212 220 172
96 53 31 234 135 212 89 86 110 154 243 201 212 213 19 51 69 201 46 178 149 146 204
213 3 102 220 160 140 94 201 71 35 227 23 5 71 222 158 225 94 167 115 10 105 118 229
116 172 42 250 128 225 114 178 94 9 174 204 197 49 171 213 110 48 68 10 102 182 162
147 164 29 31 191 143 54 191 85 247 81 210 148 190 72 193 38 32 176 240 114 30 30
178 192 85 13 84 72 34 198 68 6 40 37 216 225 180 93 115 232 164 226 192 132 166 2
145 59 27 64 226 203 42 69 134 189 118 69 27 245 140 184 28 174 172 225 210 126 241
241 167 18 214 64 45 190 30 167 168 149 100 34 34 149 135 76 184 135 153 236 86 74
230 51 232 150 112 137 130 90 243 64 134 161 183 91 230 57 31 221 64 25 20 76 69 133
238 74 236 6 150 244 175 157 138 184 2 201 229 28 48 6 149 62 118 191 121 109 41 114
192 224 108 1 238 203 2 40 74 127 17 239 107 149 247 110 90 76 55 130 173 98 208 181
61 216 62 65 102 242 12 48 17 156 94 186 148 42 42 149 33 130 238 221 196 158 111
255 135 110 190 64 81 149 177 26 78 77 166 171 105 191 235 166 124 176 88 159 11 103
232 230 246 83 78 131 144 1 204 155 68 100 101 198 123 151 98 99 243 55 185 30 213
192 237 252 22 79 137 243 198 78 81 174 31 64 14 190 122 98 195 55 62 84 122 86 103
181 97 216 80 45 34 101 72 156 141 148 131 77 60 139 104 180 148 137 71 90 43 134
181 128 115 248 192 111 185 171 252 122 233 155 136 207 227 177 225 186 207 222 74
189 155 153 24 136 76 81 103 204 59 120 226 130 141 107 84 75 126 54 210 67 43 154
71 21 117 195 65 74 110 11 51 1 229 21 245 35 139 249 5 180 91 198 162 199 180 39
81 76 229 179 196 88 175 120 174 125 209 5 6 15 83 112 166 54 77 164 88 150 9 29 146
234 204 68 24 7 190 61 24 231 252 154 27 52 240 170 161 136 243 66 153 233 186 121
20 18 99 23 227 95 148 90 34 243 112 230 122 82 43 154 243 181 186 94 13 25 244 30
19 219 181 156 162 126 9 164 216 103 239 209 229 142 146 20 148 181 76 44 238 191
172 72 121 186 196 97 6 116 230 188 170 119 241 246 242 58 255 212 133 109 191 247
103 201 23 213 75 71 39 236 51 118 229 153 35 234 149 113 212 222 145 144 19 66 138
108 140 105 108 204 244 182 187 222 162 222 32 197 179 47 221 23 206 185 144 218 68
106 155 154 122 67 62 5 216 246 190 30 56 57 197 219 37 66 49 234 53 20 252 34 101
84 101 185 27 232 18 16 170 17 214 50 122 41 232 218 220 131 92 34 25 70 121 157 58
220 229 142 95 228 107 236 194 3 96 247 160 6 254 74 56 147 180 172 66 126 220 61
180 206 220 210 21 129 120 69 71 164 172 55 131 162 163 221 220 252 185 254 154 184
209 67 219 102 67 23 82 131 72 72 14 137 183 64 203 184 220 166 143 242 126 234 253
235 31 219 168 250 107 146 97 8 136 70 0 2 127 79 138 168 66 167 252 109 29 103 31
192 83 220 107 209 73 210 10 92 248 164 120 118 161 105 108 125 121 229 196 243 214
64 165 23 240 40 22 163 186 213 185 7 42 220 194 131 33 215 166 30 8 73 103 23 26
126 23 106 234 21 2 220 127 168 49 179 241 204 50 85 16 82 186 205 1 38 79 61 48 236
153 18 243 144 186 13 118 244 213 233 93 82 192 157 247 22 240 171 11 16 199 5 191
136 215 200 100 204 25 86 255 74 65 42 22 225 235 252 126 70 229 197 43 246 94 141
175 159 5 6 209 7 172 51 23 102 103 191 170 3 205 134 184 152 117 222 215 186 176
128 201 243 167 182 59 30 3 137 61 31 153 68 139 242 241 124 239 42 170 110 188 244
215 158 217 183 90 238 132 90 221 126 226 157 191 211 89 99 128 21 200 103 210 178
80 209 221 125 218 171 167 178 223 102 70 156 219 153 249 124 97 25 226 124 211 218
179 163 203 228 51 237 107 47 167 53 219 15 222 9 126 233 221 34 205 43 215 232 173
222 58 59 119 62 124 244 78 128 153 183 202 247 72 136 56 183 88 253 205 120 206 107
253 125 122 90 128 70 207 195 220 93 167 243 224 250 110 139 166 13 175 127 216 132
211 7 112 231 177 241 65 90 142 26 132 74 199 123 68 66 18 234 160 151 17 66 48 143
239 171 207 110 8 54 138 116 240 90 215 24 196 7 181 175 12 47 191 165 189 11 36 228
223 10 120 189 112 118 184 77 197 246 59 209 199 214 89 125 99 97 137 115 89 87 219
170 144 222 216 89 70 79 162 99 218 34 59 38 230 165 89 186 71 51 172 169 99 25 95
216 71 61 225 179 117 168 107 48 169 98 251 69 115 76 227 171 235 112 53 232 172 221
172 193 86 172 158 183 194 76 190 82 152 44 236 197 77 227 118 43 118 175 10 245 47
213 98 243 75 246 196 30 163 199 233 198 41 228 169 111 83 7 243 182 3 218 163 152
76 118 36 132 252 221 75 206 60 215 11 81 190 231 110 176 117 200 183 214 245 202
106 185 54 101 209 182 150 86 185 204 187 254 73 17 95 113 47 178 94 62 252 122 144
179 0 44 92 206 226 165 201 173 62 104 186 81 134 202 165 248 58 225 254 231 69 164
231 159 218 6 123 63 246 138 100 9 25 192 50 183 37 66 122 110 153 142 150 97 186
13 58 55 92 14 193 1 43 59 74 46 164 78 95 37 238 148 229 131 225 201 35 245 194 170
27 123 166 212 222 75 186 59 121 222 169 74 176 11 102 233 22 185 215 227 167 52 79
62 250 166 196 28 49 188 249 220 53 169 169 107 247 57 73 175 247 89 235 123 14 98
168 162 71 241 125 11 114 227 208 203 246 148 229 201 212 161 85 19 139 220 190 244
192 183 195 47 134 112 4 170 61 105 163 163 85 166 167 184 12 29 52 126 229 61 241
211 240 229 162 163 220 20 49 15 112 48 73 105 248 121 239 70 201 148 196 229 225
56 225 149 250 139 154 181 94 160 242 34 22 227 116 64 135 153 170 115 158 36 84 223
218 75 247 64 34 133 21 225 106 172 23 251 148 40 102 110 51 109 212 199 36 156 31
112 61 80 50 143 115 25 86 32 194 178 233 106 152 254 128 126 18 147 191 189 119 46
191 106 96 204 211 222 107 155 134 171 165 246 14 115 223 218 193 225 184 116 13 118
44 39 16 240 234 204 226 198 144 234 108 229 192 187 215 47 72 111 233 175 88 7 104
77 124 234 87 135 166 185 155 151 225 18 141 44 42 246 29 237 200 244 211 20 233 61
31 86 95 20 92 153 38 187 220 200 28 79 245 9 185 2 135 133 100 49 81 173 5 74 145
38 61 17 204 19 86 197 163 40 75 194 153 197 169 240 202 70 88 237 65 129 148 164
140 37 119 90 237 105 48 180 155 30 146 184 139 238 175 220 99 207 192 219 250 159
45 36 75 37 175 206 246 36 29 118 149 189 8 179 250 202 78 152 44 214 239 247 43 47
158 30 241 26 18 95 44 191 149 125 170 30 202 45 244 70 68 220 112 150 220 94 82 70
183 227 1 133 134 61 104 232 224 26 208 47 110 96 165 9 143 145 122 186 25 95 232
85 29 205 85 158 43 201 77 109 4 19 187 223 140 127 105 94 107 105 130 140 199 220
14 230 177 22 175 136 17 107 116 245 88 92 218 144 153 48 54 155 141 47 78 207 12
35 61 164 150 45 25 115 121 122 171 144 237 245 67 234 2 19 178 39 68 82 76 22 12
171 194 234 22 15 49 39 228 166 186 100 220 2 199 0 131 199 178 30 20 9 63 225 130
159 11 118 84 99 20 122 78 199 26 34 54 204 151 77 180 191 215 232 34 63 108 25 115
149 108 132 146 31 49 171 92 108 67 140 36 71 139 85 105 47 165 178 97 223 126 172
188 29 18 149 2 142 136 219 204 33 23 18 120 108 156 252 11 194 37 203 205 14 252
68 63 38 74 188 172 153 99 131 43 212 126 124 183 165 31 253 88 186 236 118 148 13
129 31 73 106 19 48 154 57 77 41 137 181 225 184 102 80 241 121 51 101 215 160 117
230 222 19 23 69 234 4 182 226 213 236 193 231 250 185 250 110 22 151 187 237 223
82 202 218 16 250 138 244 185 93 41 79 50 156 255 148 152 186 42 18 9 99 221 181 213
163 138 178 105 187 152 108 196 36 73 128 92 13 138 150 97 52 31 168 55 44 25 189
75 132 244 119 90 140 13 94 155 47 199 139 87 181 138 179 247 9 153 47 115 64 55 21
213 96 174 30 21 173 177 117 176 171 26 175 197 198 244 19 124 217 144 248 61 235
149 50 193 12 174 87 87 235 90 244 120 71 146 92 111 74 45 225 174 150 119 250 157
209 130 100 127 174 203 210 66 81 43 177 117 159 14 243 161 95 93 227 103 88 172 234
205 255 114 177 64 184 164 168 212 73 221 205 194 202 227 212 42 185 53 63 201 66
180 191 92 226 69 151 154 252 249 193 39 139 113 22 50 154 29 209 223 54 90 79 209
148 242 199 251 75 214 122 221 106 77 2 57 221 252 106 251 233 147 166 134 176 114
97 20 143 116 177 168 85 221 90 44 170 98 152 15 91 217 29 14 92 104 77 24 137 136
65 218 90 22 27 108 126 47 13 250 24 92 47 90 141 213 180 24 159 116 127 165 229 73
164 244 213 8 244 162 38 237 111 27 217 21 114 20 102 116 126 99 166 74 85 94 141
229 12 243 244 239 211 244 46 35 109 76 204 241 244 187 77 47 230 174 207 191 227
61 56 210 248 28 47 153 26 16 173 185 247 42 65 133 19 209 160 232 210 224 179 73
208 22 133 132 99 114 49 188 3 245 212 67 123 211 160 155 20 236 136 58 179 29 142
196 185 129 175 155 224 206 172 158 205 154 175 11 145 206 243 156 197 83 152 61 239
254 200 131 233 5 151 152 154 25 192 149 207 136 58 141 177 19 154 27 139 87 246 121
196 38 231 146 47 56 92 91 7 43 7 176 251 66 109 125 35 211 146 54 22 129 87 210 225
25 50 97 91 225 180 86 16 148 99 156 76 106 73 117 158 100 246 155 208 208 6 195 156
208 239 86 60 221 206 172 118 8 35 153 40 205 102 52 144 166 212 202 75 219 225 163
157 84 84 40 28 200 60 104 165 12 116 186 2 167 209 11 60 44 228 222 143 59 215 196
144 19 62 95 120 73 185 115 47 232 225 86 144 233 147 19 245 14 254 141 13 241 112
0 63 160 217 138 129 201 137 10 206 192 127 162 175 204 212 178 103 208 238 52 63
147 222 152 161 182 253 146 97 115 88 131 174 2 19 10 72 149 83 202 186 38 195 207
252 217 82 76 185 69 171 73 76 129 161 173 12 88 17 62 223 240 5 5 46 68 148 171 137
240 83 213 59 59 76 151 163 4 128 14 236 83 58 10 66 192 110 192 183 82 187 196 118
74 56 29 99 230 104 62 190 226 148 112 224 192 144 116 91 246 131 51 154 52 94 77
54 184 35 126 239 216 180 91 107 200 83 115 187 201 50 218 171 147 128 178 15 197
161 147 253 120 246 67 250 5 195 201 192 106 59 145 173 137 117 101 229 51 239 38
195 117 54 193 25 130 105 57 164 96 121 55 225 45 243 148 235 3 42 225 48 251 115
43 65 101 37 143 55 220 185 122 196 237 56 99 72 129 22 238 10 230 179 2 144 147 176
6 77 136 174 165 234 14 221 167 204 147 130 119 229 159 177 219 136 179 205 159 37
206 174 137 185 203 79 81 22 182 42 121 243 27 116 88 82 73 53 125 95 87 75 242 100
53 232 247 163 87 185 203 210 124 121 99 239 218 154 209 77 169 175 232 115 95 78
238 88 223 140 184 223 241 218 66 123 20 233 39 144 222 112 158 254 72 176 168 109
178 139 203 79 231 245 253 183 35 239 74 146 205 31 168 100 22 53 111 85 196 237 57
175 89 21 182 171 78 209 248 49 51 55 57 95 205 226 172 160 134 53 168 234 214 189
181 173 17 221 13 148 158 49 255 32 102 5 176 208 94 184 195 81 217 179 70 191 15
157 237 26 194 244 235 62 179 29 220 197 186 90 228 249 235 127 225 35 234 13 5 4
203 173 93 90 174 207 222 246 114 157 212 96 223 87 87 170 15 90 117 75 29 169 187
43 61 203 60 62 203 213 103 219 58 186 182 117 36 129 230 144 188 112 81 245 65 14
108 154 103 159 241 118 32 109 221 179 163 55 187 60 113 21 189 236 237 247 215 184
119 104 253 24 142 238 246 77 75 60 133 157 38 145 115 143 36 144 219 89 135 207 4
98 250 220 88 86 91 189 230 114 87 155 203 215 109 252 24 191 205 54 38 143 127 208
120 84 158 167 206 60 203 186 31 40 19 81 204 170 218 52 187 35 34 212 204 206 49
127 105 94 92 111 39 125 93 218 155 77 181 241 250 186 92 83 54 42 189 177 111 157
113 124 228 13 68 32 27 34 176 197 26 62 123 164 33 16 107 44 16 219 233 206 163 67
60 164 36 106 14 233 230 234 108 104 46 103 123 88 109 236 131 231 12 165 91 191 80
44 103 11 64 179 108 227 229 212 146 184 13 165 231 209 101 77 233 5 253 22 29 59
58 60 5 83 187 67 122 138 222 186 113 170 6 57 194 225 198 154 100 84 104 177 122
163 4 231 174 207 198 190 120 69 94 2 104 251 188 166 65 170 186 180 197 222 86 164
32 130 193 255 238 25 236 163 65 172 225 220 200 197 141 149 206 154 200 165 41 250
17 170 85 187 241 41 251 202 13 105 45 44 132 210 95 132 98 115 45 3 52 153 215 93
142 255 154 246 97 95 254 233 249 193 125 15 196 225 19 208 29 163 180 111 34 7 254
34 177 182 254 117 115 115 237 248 141 111 93 132 227 111 183 59 247 159 19 209 222
153 193 114 62 36 208 118 246 59 223 195 120 208 228 139 238 73 19 191 177 236 110
47 113 149 154 220 197 232 45 164 239 119 69 236 67 240 100 193 78 169 126 82 125
97 183 234 226 93 210 195 44 223 137 47 250 119 38 187 86 155 109 191 90 191 188 99
145 225 101 130 115 191 217 209 170 25 74 202 237 183 158 23 92 139 39 127 169 247
66 123 23 147 107 184 48 61 100 65 24 108 207 247 246 176 129 243 62 137 160 66 182
201 227 39 217 214 25 248 13 171 81 38 56 147 107 190 88 44 132 43 221 203 146 174
158 133 28 30 232 10 238 110 224 121 15 57 217 101 104 78 46 54 174 66 232 105 101
90 48 139 247 53 100 67 101 83 130 94 241 132 213 174 195 32 212 33 238 64 82 168
234 20 48 186 1 85 195 45 159 216 12 112 182 167 91 46 225 38 133 171 65 24 238 168
139 134 205 156 170 161 165 122 69 119 20 148 205 19 115 32 195 93 223 12 138 110
169 131 48 31 197 188 75 162 57 10 139 224 137 45 159 246 0 182 19 160 109 166 192
22 166 148 123 173 16 190 59 141 202 53 129 15 215 65 6 13 78 208 102 217 29 9 177
105 249 238 150 59 246 194 251 151 73 65 9 37 170 204 205 211 16 54 189 53 6 167 233
62 203 192 73 123 21 219 22 53 8 207 150 55 39 185 141 236 174 124 72 75 110 193 202
48 103 185 157 32 53 48 68 183 11 241 4 82 173 95 75 105 219 95 151 88 137 184 81
35 88 223 150 7 12 220 125 21 113 68 173 120 218 78 123 75 4 0 248 219 73 10 53 5
131 227 191 199 3 255 127 250 65 243 227 175 250 199 0 131 142 147 158 149 238 20
19 59 35 219 73 102 46 22 110 14 90 158 127 2 212 190 109 102 144 18 0 0]! !

!GTASessionExamples class methodsFor: 'accessing - recorded sessions' stamp: 'JurajKubelka 6/8/2015 16:49'!
openCloseDataSample
	"Automatically created by class method #compileCurrentDataInto: #openCloseDataSample."
	"GTAAnnouncements spotterUsersAndDevelopersFrom: self openCloseDataSample."
	<gtaRecordedSessionExamples: 2>
	^ #[31 139 8 0 0 0 0 0 0 0 115 11 117 245 97 56 196 200 192 192 192 207 0 1 236 34 110
	62 238 57 249 73 137 57 206 57 137 197 197 206 57 165 197 37 169 69 64 9 86 14 55
	31 143 212 196 148 212 34 33 207 148 212 188 146 204 146 74 151 204 228 146 204 252
	188 196 162 74 46 167 202 146 212 224 202 220 164 252 28 65 255 34 160 154 212 20
	231 252 156 156 84 176 60 127 104 94 74 106 90 102 94 106 138 127 82 22 80 72 206
	205 39 32 191 56 179 36 179 44 213 34 56 55 49 39 199 51 175 36 53 61 181 8 97 23
	51 3 35 147 24 208 186 252 252 236 128 162 204 92 176 82 132 44 35 51 127 81 106 114
	62 200 154 176 212 162 98 160 13 120 212 178 2 253 227 150 89 1 179 27 73 134 145
	69 178 160 40 213 55 17 200 205 76 204 201 172 74 4 185 213 17 236 226 98 193 196
	148 148 76 176 223 114 32 250 138 165 10 242 139 75 176 43 230 207 69 21 150 117 243
	65 132 12 34 24 144 172 102 2 17 146 110 62 193 153 185 5 57 169 216 148 48 177 64
	227 131 129 151 135 143 11 164 156 147 3 38 194 13 196 146 80 54 23 174 232 98 227
	4 69 137 99 81 81 34 52 114 74 138 50 243 210 145 226 137 219 5 232 106 199 188 148
	144 204 220 84 69 247 144 224 130 252 18 160 206 32 104 192 2 37 19 29 243 242 242
	75 243 146 83 115 129 177 205 133 240 145 60 34 250 12 205 176 199 31 227 188 165
	184 163 132 137 73 197 34 217 60 197 216 56 201 68 215 208 192 200 84 215 196 40 201
	88 215 34 37 217 68 215 36 209 40 41 201 216 40 217 52 209 196 136 35 32 35 177 40
	223 68 207 128 112 114 97 226 192 147 90 128 33 169 90 23 205 254 74 61 128 145 235
	204 255 171 23 192 193 6 20 97 155 149 102 192 200 119 3 42 130 91 63 7 51 103 102
	110 98 122 170 71 98 113 6 75 10 48 88 132 139 83 139 65 137 206 185 40 21 28 221
	160 0 228 73 206 207 45 40 5 106 8 13 245 116 225 44 1 138 20 151 36 230 22 136 164
	150 1 195 46 8 53 177 242 228 0 3 190 184 36 180 0 104 88 42 15 216 108 168 12 82
	200 26 27 225 8 89 214 173 126 58 194 110 62 160 120 196 76 209 64 223 110 146 239
	134 37 148 222 144 179 65 87 28 4 252 190 177 127 179 239 94 170 161 144 240 35 148
	127 218 82 246 175 29 220 140 107 30 40 113 199 217 156 205 155 149 170 50 179 211
	120 179 131 77 197 199 7 39 219 63 132 214 48 93 185 212 204 126 122 177 123 252 129
	75 51 55 100 79 139 221 52 97 213 18 181 248 122 219 187 151 255 250 70 91 107 111
	251 22 120 221 228 236 5 191 121 15 79 79 219 251 234 146 85 145 182 222 163 61 143
	182 237 96 80 227 125 217 147 186 158 177 168 33 54 170 188 129 67 167 41 245 142
	192 12 161 35 77 119 30 59 56 232 126 120 117 69 118 165 209 73 198 229 78 177 226
	78 187 55 58 203 220 56 202 50 39 235 239 210 150 101 58 213 147 139 116 62 48 218
	172 169 60 81 122 189 179 65 109 131 70 88 208 101 225 197 70 50 75 127 207 230 169
	86 52 221 244 202 179 217 177 121 149 193 249 198 66 201 68 6 115 221 243 201 15 23
	251 189 209 235 158 39 245 89 50 71 225 103 247 196 238 120 229 169 175 131 102 24
	202 59 246 53 31 222 188 83 189 174 230 206 242 152 57 190 102 123 46 127 88 146 234
	62 181 243 212 5 81 171 133 118 201 211 98 15 207 123 127 40 114 138 203 170 187 252
	107 35 52 158 138 216 206 126 169 80 249 243 94 238 250 211 133 111 181 238 69 222
	93 247 51 228 196 254 181 101 27 179 22 28 58 113 78 225 81 130 251 179 152 155 206
	75 56 207 157 106 204 89 126 211 255 254 226 246 217 60 124 6 50 109 61 127 54 149
	68 42 157 51 251 166 32 46 91 176 240 124 225 83 142 110 85 167 140 110 147 3 147
	251 22 150 219 175 85 218 158 29 36 86 114 137 43 243 239 43 201 247 197 107 126 57
	56 21 221 114 210 107 23 126 203 217 230 89 188 206 158 99 234 45 43 161 187 234 111
	47 101 173 55 90 174 156 122 111 127 249 54 19 225 99 199 118 231 31 155 255 94 158
	45 67 111 250 45 134 75 86 241 207 52 125 229 189 142 189 55 158 114 229 217 253 61
	21 95 178 30 69 232 215 254 250 253 213 34 103 135 139 92 72 250 181 47 151 166 235
	165 124 60 126 254 254 114 203 205 239 221 235 231 186 25 249 223 243 90 127 254 110
	199 215 53 50 138 31 43 151 112 71 6 180 222 230 171 57 113 58 109 229 60 59 215 123
	255 183 30 106 143 78 153 127 193 57 232 94 187 67 87 91 113 100 206 61 7 59 30 141
	224 178 134 181 18 213 185 159 95 174 153 192 245 132 169 178 142 107 114 108 212
	129 26 237 156 69 167 142 102 108 145 8 182 60 185 108 189 119 242 205 112 174 101
	186 247 24 147 190 251 170 84 125 235 77 229 91 90 53 227 168 91 244 41 179 85 205
	209 25 211 151 42 233 55 116 204 183 19 231 155 190 211 192 248 238 105 155 114 161
	214 100 183 222 255 79 14 100 46 225 215 182 140 51 204 159 241 44 180 248 140 78
	127 207 253 93 105 125 247 66 166 117 102 62 173 189 59 99 198 44 29 205 75 135 222
	156 249 115 231 209 219 122 222 83 6 161 145 108 12 12 56 75 104 86 70 174 20 120
	177 67 184 84 101 3 229 86 80 193 200 33 202 41 200 33 192 35 204 45 196 203 39 198
	47 46 194 46 1 0 59 104 243 82 232 6 0 0]! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 6/8/2015 16:59'!
recordedSessionExamples
	^ self recordedSessionPragmas collect: [ :eachPragma |
		self perform: eachPragma selector ]! !

!GTASessionExamples class methodsFor: 'accessing' stamp: 'JurajKubelka 6/8/2015 16:52'!
recordedSessionPragmas
	^ Pragma allNamed: #gtaRecordedSessionExamples: in: self class sortedByArgument: 1! !

!GTASessionExamples class methodsFor: 'accessing - recorded sessions' stamp: 'JurajKubelka 6/8/2015 16:49'!
selections1
	"Automatically created by class method #compileCurrentDataInto: #selections1."
	"GTAAnnouncements spotterUsersAndDevelopersFrom: self selections1."
	<gtaRecordedSessionExamples: 3>
	^ #[31 139 8 0 0 0 0 0 0 0 133 86 9 56 84 123 27 71 89 198 54 141 45 203 69 138 22 98
	152 177 103 201 110 108 195 48 99 187 104 150 67 195 108 230 12 70 214 251 41 100
	45 69 17 19 221 137 178 134 38 110 11 69 146 22 169 108 173 202 86 183 36 212 215
	71 26 190 225 234 171 251 124 183 123 207 243 156 243 156 243 254 222 247 255 190
	239 239 247 62 207 121 157 177 78 30 66 29 194 66 66 66 80 161 63 46 113 5 103 15
	23 10 157 128 167 56 80 240 32 232 64 137 1 89 0 83 0 136 74 56 123 184 2 120 18 192
	148 67 145 0 26 139 204 138 119 36 19 89 100 58 13 207 140 151 180 143 103 1 190 241
	84 2 157 2 67 51 5 62 0 201 129 78 161 0 171 56 20 75 35 1 225 100 26 64 66 19 34
	5 38 13 103 15 111 58 72 102 145 99 1 115 95 42 158 66 65 209 88 64 4 192 252 150
	107 157 144 176 136 146 32 29 157 30 229 205 36 83 87 93 191 161 194 235 160 76 128
	72 95 73 131 3 152 160 32 195 223 248 138 10 250 113 38 179 191 230 254 14 17 94 175
	194 96 2 158 120 193 39 25 79 33 239 195 175 212 106 183 90 49 8 195 147 72 228 213
	222 40 127 196 129 170 12 58 200 250 107 103 40 245 207 102 117 103 143 111 204 124
	163 225 187 212 34 43 15 21 103 15 95 50 149 65 1 254 202 69 100 253 154 30 66 50
	210 178 146 43 238 16 137 175 22 41 193 173 178 246 46 249 35 185 196 32 43 146 216
	49 153 248 53 113 88 76 50 45 226 59 157 164 28 5 85 219 209 72 126 100 42 160 229
	226 231 203 160 179 4 145 152 53 98 5 32 222 142 70 163 199 208 136 0 85 160 182 228
	183 142 52 191 201 103 100 250 215 250 9 115 78 255 88 18 17 17 9 239 189 120 38 221
	216 192 80 219 156 104 70 66 34 9 198 250 70 134 8 19 125 99 4 1 169 111 78 34 26
	235 27 227 17 4 2 18 65 52 193 27 35 254 121 92 68 36 254 102 90 4 76 234 36 135 234
	206 154 180 10 181 107 46 15 244 173 210 38 176 152 168 67 207 8 43 116 172 89 126
	28 47 177 14 66 166 226 35 0 87 60 184 119 61 73 64 139 60 8 128 43 67 231 192 4 86
	229 94 33 80 154 72 167 50 98 4 1 88 44 202 17 194 18 88 64 22 158 202 80 0 98 5 220
	97 254 60 172 210 20 1 241 32 11 203 16 28 6 72 175 158 189 134 124 199 44 18 241
	3 102 69 121 94 59 229 157 61 86 116 252 255 137 22 200 126 82 51 251 235 160 212
	225 200 140 159 6 96 75 206 69 231 245 222 185 69 5 70 61 106 210 73 216 185 63 247
	26 204 116 126 212 48 160 246 124 81 71 61 239 181 225 176 249 245 95 203 170 6 202
	31 21 227 159 215 114 121 191 161 193 17 51 101 226 166 82 49 34 195 80 118 61 168
	61 131 156 240 195 120 77 156 25 71 39 155 163 176 186 95 80 167 179 180 173 127 245
	33 135 115 121 229 89 117 111 146 30 134 165 52 92 10 107 71 90 244 21 119 68 136
	164 42 111 77 174 96 35 120 78 3 226 58 38 21 110 165 219 250 69 90 142 163 210 179
	24 136 129 46 237 226 226 15 23 129 202 192 44 236 148 119 83 209 169 168 130 192
	218 182 218 189 141 109 132 100 111 255 183 251 60 70 13 45 42 106 116 193 169 70
	97 207 112 135 172 27 227 156 107 81 144 160 2 15 128 85 31 112 107 251 147 225 99
	199 252 120 193 205 1 121 197 190 141 147 187 183 71 149 51 46 218 20 24 21 94 118
	40 107 146 4 9 91 111 191 137 61 78 189 51 174 240 210 248 169 164 42 26 163 114 50
	231 93 163 196 68 110 122 207 3 185 179 89 92 221 75 58 187 134 98 183 17 67 183 245
	52 141 230 120 150 189 238 222 168 98 217 18 190 181 123 46 185 213 162 184 164 250
	142 159 138 85 197 237 169 246 27 164 106 116 143 154 238 137 131 24 220 116 175 120
	228 41 222 128 233 21 93 171 131 142 174 9 143 249 245 112 147 144 198 65 125 126
	82 58 237 240 224 91 37 189 10 223 178 238 186 235 231 184 19 199 159 90 184 29 121
	93 220 242 230 108 105 21 26 207 77 75 31 174 239 225 187 113 244 79 76 182 210 3
	52 111 31 167 248 225 137 121 67 89 92 46 115 208 180 172 155 18 55 238 255 128 228
	180 53 255 185 159 238 99 79 95 221 11 189 125 40 68 115 39 202 201 119 254 156 123
	136 113 110 63 209 240 174 145 254 73 155 200 172 35 15 239 142 146 102 228 206 247
	70 119 69 14 25 95 41 7 2 57 202 178 250 173 204 109 183 128 226 172 162 96 75 94
	230 61 91 250 36 246 169 50 57 18 13 241 231 166 132 88 47 187 27 205 77 234 208 15
	160 169 182 62 106 207 109 113 131 252 174 48 123 194 199 95 74 138 58 227 95 54 196
	77 193 76 181 113 126 73 252 68 112 224 109 212 137 206 117 203 11 101 51 85 82 177
	253 172 106 107 176 132 70 171 253 249 226 123 209 151 108 138 207 124 167 175 59
	241 247 75 201 193 242 234 150 62 139 25 237 138 132 101 118 211 217 185 190 166 117
	28 171 193 218 147 22 80 59 243 128 125 105 198 155 112 101 135 250 41 118 133 59
	159 73 199 236 40 45 33 156 127 18 122 60 86 157 117 196 197 82 225 49 253 227 105
	67 141 91 199 49 6 240 217 244 28 93 69 112 107 161 187 146 201 142 123 164 251 135
	152 57 254 249 179 166 52 153 220 150 70 251 248 18 242 1 81 114 16 232 86 116 182
	218 224 19 162 211 171 63 186 217 240 238 78 178 72 37 214 130 59 46 89 217 28 195
	118 194 248 168 228 87 198 148 33 141 234 110 123 76 196 64 176 70 98 49 61 71 157
	204 46 137 114 94 4 238 216 101 165 146 68 107 240 74 216 141 233 234 141 238 233
	61 105 134 153 196 249 124 212 198 187 62 130 101 88 54 146 175 251 28 52 157 222
	228 179 37 196 195 196 209 221 236 232 78 40 250 19 52 226 231 125 153 115 234 131
	128 6 51 86 101 172 89 19 175 117 29 151 158 49 41 113 90 175 93 78 209 252 195 141
	40 28 205 178 53 44 83 115 105 132 158 60 65 217 107 63 168 162 249 94 113 20 158
	112 40 62 162 65 254 192 188 124 104 111 253 184 150 214 82 129 56 204 43 249 3 90
	43 249 102 90 237 200 66 216 188 245 16 221 58 166 255 253 111 181 45 136 49 151 18
	85 179 118 165 155 17 247 26 207 217 14 206 149 157 136 131 204 198 89 185 190 77
	43 140 16 157 59 152 101 92 191 69 131 91 29 28 248 238 85 173 53 209 122 2 188 154
	118 135 62 226 50 182 239 134 154 53 248 66 111 121 216 127 170 108 104 194 69 105
	121 233 66 202 162 203 253 171 121 233 252 210 34 25 151 75 51 183 101 52 28 19 63
	206 86 237 159 191 164 193 253 156 175 230 191 200 223 223 242 201 27 59 242 97 242
	97 202 171 147 124 78 103 18 47 108 193 66 255 201 124 171 45 238 237 180 231 54 62
	39 184 65 83 246 206 220 104 131 166 60 63 147 65 16 31 120 21 8 197 44 100 223 203
	151 154 245 191 242 211 194 169 156 20 5 106 183 18 38 189 129 29 17 175 221 118 251
	125 96 226 124 230 235 247 188 196 4 250 30 47 189 246 47 155 54 212 112 178 79 240
	147 35 151 219 222 112 83 120 181 159 253 221 195 35 139 220 225 203 134 183 38 243
	206 109 126 166 118 190 98 220 139 83 40 141 179 21 237 163 150 231 199 188 38 6 157
	41 207 221 219 143 51 90 116 156 134 171 214 26 92 85 53 220 76 25 61 215 84 7 243
	170 66 134 84 87 23 168 23 95 111 121 0 137 41 49 19 177 175 66 14 22 37 218 109 194
	224 128 251 185 55 245 45 13 110 41 82 93 225 158 117 6 80 111 189 122 61 195 125
	230 42 149 156 211 21 125 70 193 23 27 188 97 175 213 176 236 6 16 254 40 45 27 144
	170 36 67 57 211 159 104 136 94 147 169 154 0 248 12 106 143 29 130 119 215 122 178
	114 177 190 41 130 140 61 59 172 229 152 22 63 68 122 38 101 162 35 131 48 121 131
	51 183 203 104 196 222 114 71 118 140 180 121 23 142 112 130 228 185 189 159 231 130
	236 209 238 137 240 205 137 67 54 85 73 211 144 237 113 180 253 52 133 198 92 110
	166 26 67 145 159 191 107 36 130 136 28 60 92 234 208 36 246 174 245 232 99 79 237
	26 148 129 86 160 211 3 103 166 86 79 80 65 54 42 121 55 83 216 50 218 134 247 234
	112 237 182 71 169 178 165 217 235 13 78 185 170 161 70 80 109 84 190 100 36 117 170
	187 191 94 43 113 35 207 212 204 189 238 157 3 115 38 246 140 65 155 104 195 158 13
	182 118 208 208 174 1 182 12 159 173 46 249 124 183 24 125 115 70 75 249 216 166 11
	163 27 12 186 159 40 119 236 154 215 122 238 180 81 118 76 245 114 134 194 115 241
	78 116 180 190 205 85 137 60 251 27 25 202 87 141 190 72 216 58 192 109 58 10 231
	149 159 204 130 123 231 215 119 154 231 25 219 56 105 192 137 226 93 211 157 176 170
	18 98 128 100 222 91 239 221 53 53 112 237 103 155 147 14 212 116 135 36 184 67 18
	182 252 94 89 181 220 148 218 30 47 124 197 162 28 206 228 235 71 255 123 1 57 236
	98 253 233 64 125 18 98 105 78 104 57 39 181 141 93 244 229 202 197 221 35 233 217
	102 119 49 199 246 132 18 82 195 54 246 169 137 124 254 87 170 141 153 119 119 115
	248 193 48 77 229 161 98 141 37 183 169 46 234 112 238 186 86 141 123 47 195 167 174
	141 177 85 227 198 2 159 230 103 68 195 53 174 90 179 197 22 103 55 115 186 125 91
	229 91 70 97 151 83 51 24 187 56 215 61 217 27 254 243 18 242 52 51 169 85 42 238
	133 145 85 86 240 140 156 205 162 109 54 45 68 248 165 172 144 208 15 215 49 81 97
	73 210 255 118 140 127 94 161 196 86 126 205 43 91 144 132 162 4 12 178 65 90 94 74
	78 70 86 9 186 81 65 92 249 191 51 215 97 242 213 10 0 0]! !

!GTASessionExamples class methodsFor: 'accessing - recorded sessions' stamp: 'JurajKubelka 6/8/2015 16:49'!
selections2
	"Automatically created by class method #compileCurrentDataInto: #selections2."
	"GTAAnnouncements spotterUsersAndDevelopersFrom: self selections2."
	<gtaRecordedSessionExamples: 4>
	^ #[31 139 8 0 0 0 0 0 0 0 115 11 117 245 97 56 196 200 192 192 192 207 0 1 236 34 110
	62 238 57 249 73 137 57 206 57 137 197 197 206 57 165 197 37 169 69 64 9 86 14 55
	31 143 212 196 148 212 34 33 207 148 212 188 146 204 146 74 151 204 228 146 204 252
	188 196 162 74 46 167 202 146 212 224 202 220 164 252 28 65 255 34 160 154 212 20
	231 252 156 156 84 176 60 127 104 94 74 106 90 102 94 106 138 127 82 22 80 72 206
	205 39 32 191 56 179 36 179 44 213 34 56 55 49 39 199 51 175 36 53 61 181 8 97 23
	51 3 35 147 24 208 186 252 252 236 128 162 204 92 176 82 132 44 35 51 127 81 106 114
	62 200 154 176 212 162 98 160 13 120 212 178 2 253 227 150 89 1 179 27 73 134 145
	69 178 160 40 213 55 17 200 205 76 204 201 172 74 4 185 213 17 236 226 98 193 196
	148 148 76 176 223 114 32 250 138 165 10 242 139 75 176 43 230 207 69 21 150 117 243
	65 132 12 34 24 144 172 102 2 17 146 110 62 193 153 185 5 57 169 216 148 48 177 64
	227 131 129 151 135 143 11 164 156 147 3 38 194 13 196 146 80 54 23 174 232 98 227
	4 69 137 99 81 81 34 52 114 74 138 50 243 210 145 226 137 219 5 232 106 199 188 148
	144 204 220 84 69 247 144 224 130 252 18 160 206 32 104 192 2 37 19 29 243 242 242
	75 243 146 83 115 129 177 205 133 240 145 60 34 250 12 205 176 199 31 227 188 165
	184 163 132 137 73 197 34 217 60 197 216 56 201 68 215 208 192 200 84 215 196 40 201
	88 215 34 37 217 68 215 36 209 40 41 201 216 40 217 52 209 196 136 35 32 35 177 40
	223 68 207 128 112 114 97 226 192 147 90 128 33 169 90 23 167 62 101 98 3 163 88 202
	255 171 23 192 193 6 20 209 250 104 186 131 97 191 60 84 4 183 126 14 102 206 204
	220 196 244 84 143 196 226 12 150 20 96 176 8 23 167 22 131 18 157 115 81 42 56 186
	65 1 200 147 156 159 91 80 10 212 16 26 234 233 194 89 2 20 41 46 73 204 45 16 73
	45 3 134 93 16 106 98 229 201 1 6 124 113 73 104 1 208 176 84 30 176 217 80 25 164
	144 53 54 194 17 178 172 91 253 116 132 221 124 64 241 136 153 162 25 24 88 202 228
	187 97 9 165 55 236 108 241 109 23 145 237 50 214 101 57 234 94 179 30 213 92 80 243
	155 93 231 56 213 33 104 214 180 247 46 27 39 53 204 153 97 225 185 208 225 101 212
	173 27 222 97 81 27 181 213 205 14 23 60 229 58 220 168 92 158 86 245 240 72 35 243
	225 248 11 220 60 234 109 220 60 226 239 238 60 240 156 118 124 147 236 242 175 61
	111 174 190 255 123 239 248 190 239 223 214 110 253 187 71 238 103 100 151 139 82
	209 146 159 158 115 174 127 225 61 117 170 99 149 8 231 194 75 179 10 12 217 29 109
	86 190 156 45 49 115 198 252 219 70 27 223 10 109 223 232 199 51 221 64 250 163 91
	214 218 135 143 130 14 107 25 91 109 59 220 216 236 59 53 176 171 118 231 158 252
	217 63 38 220 184 113 71 179 158 231 66 207 50 241 153 10 122 150 199 202 189 196
	22 149 156 46 43 100 253 188 109 125 99 135 200 217 38 235 99 125 93 115 34 236 182
	234 78 101 75 233 227 125 182 211 242 64 76 67 187 241 142 194 27 253 110 175 116
	239 43 118 138 204 46 178 208 83 168 80 237 152 228 63 81 252 245 42 249 141 18 206
	203 60 255 236 189 184 108 222 140 178 25 5 254 234 167 195 212 107 2 47 223 158 153
	185 92 241 137 213 171 90 223 204 170 206 8 190 163 203 3 23 109 92 32 55 241 225
	25 143 83 139 249 85 163 61 164 230 229 55 127 173 216 95 116 242 179 116 181 106
	251 206 15 219 164 85 188 83 39 60 223 181 58 108 98 236 193 180 127 18 93 18 171
	162 87 201 22 231 115 94 126 189 225 104 232 237 59 202 98 243 94 27 198 172 218 52
	89 233 248 113 150 249 63 194 30 75 45 98 210 255 242 105 67 58 223 27 165 219 42
	106 17 60 237 66 241 79 101 76 159 249 7 58 221 89 145 117 68 109 145 84 192 242 106
	15 107 190 109 181 23 175 222 139 109 158 207 245 184 119 218 103 187 45 53 115 119
	172 222 118 54 107 91 163 110 194 143 45 239 206 229 46 59 253 244 200 186 51 219
	102 87 84 190 252 162 39 55 165 110 127 117 188 94 205 199 213 127 206 155 139 183
	233 215 230 171 230 249 228 123 105 191 218 58 225 93 247 118 255 235 83 151 184 255
	157 109 165 173 206 117 99 173 81 176 143 200 130 101 71 14 76 217 116 71 175 204
	102 113 143 176 142 17 235 49 150 115 162 51 58 87 158 16 211 204 10 177 200 57 123
	230 230 137 67 105 231 28 69 117 212 156 54 52 246 100 113 207 103 185 189 34 83 200
	234 217 132 144 172 59 249 217 19 131 4 77 179 68 26 187 87 150 30 186 235 166 247
	228 174 227 177 137 203 101 181 19 118 79 59 115 125 226 245 155 73 91 110 206 222
	153 204 242 124 49 143 131 148 136 226 196 186 9 47 125 125 230 206 57 45 147 212
	177 195 205 97 214 135 217 18 87 202 36 255 52 197 157 62 55 195 171 51 56 173 99
	246 78 95 37 135 189 19 111 126 98 137 91 42 33 126 50 233 129 173 160 135 176 107
	159 150 152 208 74 225 141 10 119 14 255 98 90 103 91 249 74 69 41 232 83 129 67 223
	87 255 61 50 253 49 63 255 28 252 116 235 240 156 41 186 127 190 159 78 254 207 193
	164 148 190 241 114 231 157 170 41 63 194 79 221 227 86 188 94 183 42 110 250 38 246
	196 39 199 237 235 95 184 4 21 139 101 188 109 157 56 243 188 155 245 196 131 235
	255 159 42 205 226 173 51 253 16 173 62 105 102 15 211 114 17 183 99 225 251 222 184
	136 253 44 175 247 184 249 86 96 211 158 192 250 59 59 187 63 206 156 184 223 122
	226 209 166 184 124 229 191 198 83 123 150 21 110 182 169 230 101 239 151 123 200
	198 195 161 177 118 166 56 91 81 193 162 52 249 155 111 142 200 29 58 206 152 186
	198 183 209 241 128 223 183 185 31 245 82 100 127 232 46 190 125 225 88 38 227 113
	129 101 234 170 199 46 74 138 59 60 226 185 233 113 255 180 162 172 108 81 226 53
	78 241 95 250 110 111 156 175 77 159 217 85 106 248 120 254 21 131 59 29 124 233 108
	44 252 119 111 254 103 235 42 95 153 214 113 227 235 243 222 237 238 55 87 20 190
	75 101 79 251 38 198 225 46 155 127 100 211 172 12 70 225 89 117 2 115 86 203 93 118
	142 171 204 251 246 89 230 124 9 187 109 14 75 114 144 123 170 143 177 227 172 80
	9 190 188 120 229 147 203 207 93 124 16 108 220 190 123 166 255 30 31 118 118 27 219
	255 254 206 215 139 159 177 106 87 138 175 249 51 233 95 219 58 241 235 95 182 151
	254 93 100 180 212 102 249 25 189 216 192 60 13 243 169 156 79 119 125 218 99 180
	252 140 182 229 211 73 70 155 107 28 103 134 172 211 60 191 207 96 111 133 101 117
	232 206 213 254 250 235 14 124 238 170 179 252 45 101 147 255 106 179 247 118 185
	61 127 46 206 109 95 191 232 250 233 213 191 222 242 219 242 223 218 37 126 244 90
	165 238 250 190 159 171 11 115 157 109 175 111 173 114 187 29 226 222 124 53 250 159
	151 222 158 253 197 27 246 215 214 191 191 103 253 126 234 189 187 127 15 252 144
	95 251 251 72 194 82 78 6 6 156 181 44 43 35 87 10 188 234 32 92 51 178 129 74 92
	80 229 198 33 202 41 200 33 192 43 204 45 196 195 39 198 47 46 194 46 1 0 111 177
	25 54 172 8 0 0]! !

!GTASessionExamples class methodsFor: 'accessing - recorded sessions' stamp: 'JurajKubelka 6/8/2015 17:12'!
selections3
	"Automatically created by class method #compileCurrentDataInto: #dataSample."
	"GTAAnnouncements spotterUsersAndDevelopersFrom: self dataSample."
	<gtaRecordedSessionExamples: 5>
	^ #[31 139 8 0 0 0 0 0 0 0 115 11 117 245 97 56 196 200 192 192 192 207 0 1 236 34 110
	62 238 57 249 73 137 57 206 57 137 197 197 206 57 165 197 37 169 69 64 9 86 14 55
	31 143 212 196 148 212 34 33 207 148 212 188 146 204 146 74 151 204 228 146 204 252
	188 196 162 74 46 167 202 146 212 224 202 220 164 252 28 65 255 34 160 154 212 20
	231 252 156 156 84 176 60 127 104 94 74 106 90 102 94 106 138 127 82 22 80 72 206
	205 39 32 191 56 179 36 179 44 213 34 56 55 49 39 199 51 175 36 53 61 181 8 97 23
	51 3 35 147 24 208 186 252 252 236 128 162 204 92 176 82 132 44 35 51 127 81 106 114
	62 200 154 176 212 162 98 160 13 120 212 178 2 253 227 150 89 1 179 27 73 134 145
	69 178 160 40 213 55 17 200 205 76 204 201 172 74 4 185 213 17 236 226 98 193 196
	148 148 76 176 223 114 32 250 138 165 10 242 139 75 176 43 230 207 69 21 150 117 243
	65 132 12 34 24 144 172 102 2 17 146 110 62 193 153 185 5 57 169 216 148 48 177 64
	227 131 129 151 135 143 11 164 156 147 3 38 194 13 196 146 80 54 23 174 232 98 227
	4 69 137 99 81 81 34 52 114 74 138 50 243 210 145 226 137 219 5 232 106 199 188 148
	144 204 220 84 69 247 144 224 130 252 18 160 206 32 104 192 2 37 19 29 243 242 242
	75 243 146 83 115 129 177 205 133 240 145 60 34 250 12 205 176 199 31 227 188 165
	184 163 132 137 137 35 32 35 177 40 223 68 207 64 197 34 217 60 197 216 56 201 68
	215 208 192 200 84 215 196 40 201 88 215 34 37 217 68 215 36 209 40 41 201 216 40
	217 52 209 196 136 112 114 97 226 192 147 90 128 33 169 90 23 167 245 209 116 7 195
	126 249 255 87 47 128 131 13 40 162 124 63 112 3 163 244 63 168 8 110 253 28 204 156
	153 185 137 233 169 30 137 197 25 44 41 192 96 17 46 78 45 6 37 58 231 162 84 112
	116 131 2 144 39 57 63 183 160 20 168 33 52 212 211 133 179 4 40 82 92 146 152 91
	32 146 90 6 12 187 32 212 196 202 147 3 12 248 226 146 208 2 160 97 169 60 96 179
	161 50 72 33 107 108 132 35 100 89 183 250 233 8 187 249 128 226 17 51 69 3 177 130
	124 55 44 161 180 6 198 122 31 118 16 216 227 29 181 230 171 114 136 203 138 5 251
	15 135 247 206 19 83 210 109 249 85 247 114 237 166 93 39 91 119 7 247 216 159 143
	127 166 106 184 36 105 237 239 13 5 214 197 103 222 172 137 184 167 242 102 178 241
	49 165 107 215 206 109 244 200 243 76 159 148 52 233 218 177 47 89 178 18 252 60 238
	74 59 153 87 30 144 57 43 34 194 23 91 218 171 221 190 107 194 50 169 248 80 190 75
	90 231 77 124 159 29 43 118 56 58 139 67 202 38 74 140 75 110 35 131 233 249 121 127
	95 196 168 112 231 94 124 40 29 179 100 167 202 44 81 190 121 7 190 68 41 62 62 216
	57 253 242 175 212 68 131 252 21 182 167 14 159 56 224 117 221 136 63 97 77 248 141
	67 178 191 106 89 246 149 223 202 230 144 247 241 102 254 126 201 62 80 168 238 196
	173 215 169 143 111 248 45 9 186 241 198 237 173 125 117 84 214 107 179 201 139 255
	60 255 225 163 82 107 84 203 147 125 201 241 238 50 37 79 67 125 78 179 192 166 131
	223 109 111 28 252 247 112 199 178 247 125 187 78 198 77 14 136 126 24 255 252 209
	254 247 31 234 223 205 201 53 61 90 153 174 248 135 73 91 60 228 171 37 48 227 225
	44 15 88 25 185 82 224 137 156 112 30 102 3 165 13 80 54 228 16 229 16 228 20 224
	17 230 22 226 229 19 227 23 23 97 151 0 0 12 246 216 162 86 5 0 0]! !

!GTASessionExamples class methodsFor: 'accessing - artificial sessions' stamp: 'JurajKubelka 5/11/2015 17:24'!
session1
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveInCategoryEvent new;
				add: GTSpotterRecorderContextChangedEvent new;
				add: GTSpotterRecorderSelectedCandidateChangedEvent new;
				add: GTSpotterRecorderCategorySelectedEvent new;
				add: GTSpotterRecorderDiveOutEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing - artificial sessions' stamp: 'JurajKubelka 5/11/2015 17:24'!
session2
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderShowPreviewEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing - artificial sessions' stamp: 'JurajKubelka 5/11/2015 17:24'!
session3
	"Miss-steps"
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderContextChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderSelectedCandidateChangedEvent new;
		add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderDiveInCategoryEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
			add: GTSpotterRecorderSearchFinishedEvent new;
			add: GTSpotterRecorderDiveOutEvent new;
		add: GTSpotterRecorderSearchFinishedEvent new;
		add: GTSpotterRecorderDiveInElementEvent new;
			add: GTSpotterRecorderContextChangedEvent new;
			add: GTSpotterRecorderSelectedCandidateChangedEvent new;
			add: GTSpotterRecorderCategorySelectedEvent new;
		add: GTSpotterRecorderExitAnnouncementEvent new;
		yourself! !

!GTASessionExamples class methodsFor: 'accessing - artificial sessions' stamp: 'JurajKubelka 5/11/2015 17:24'!
session4
	^ GTASession new
		add: GTSpotterRecorderOpenEvent new; 
		add: GTSpotterRecorderShowPreviewEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderContextChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderCategorySelectedEvent new; 
		add: GTSpotterRecorderSearchFinishedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderSelectedCandidateChangedEvent new; 
		add: GTSpotterRecorderActOnEvent new; 
		yourself! !

Object subclass: #GTATimelineBuilder
	instanceVariableNames: 'computers builder width height'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Roassal-Timeline'!

!GTATimelineBuilder methodsFor: 'building' stamp: 'JurajKubelka 6/5/2015 16:34'!
build
	| minTime dataSetBuilder user |
	builder := RTTimeline new.
	minTime := self computers start asUnixTime.
	dataSetBuilder := GTARoughDataSetBuilder new
		gap: self computers duration / 108;
		setSessionComparator;
		yourself.
	self computers reverseWithIndexDo: [ :eachComputer :index | | set objects |
		dataSetBuilder 
			objects: eachComputer; 
			newGroupBlock: [ GTASomeSessions new computer: eachComputer; yourself ];
			build.
		objects := dataSetBuilder groups collect: [ :eachGroup |
			eachGroup size = 1 ifTrue: [ eachGroup any ] ifFalse: [ eachGroup ] ].
		set := RTTimelineSet new.
		set
			lineIdentifier: index;
			objects: objects;
			start: [ :eachSession | eachSession start asUnixTime - minTime ];
			end: [ :eachSession | eachSession end asUnixTime - minTime ].
		set interaction popupText: #humanReadablePrintString.
		set shape color: (RTMultiLinearColorForIdentity new 
							command: [ :eachSession | objects indexOf: eachSession ]; 
							objects: (1 to: objects size);
							yourself).
		builder add: set.
	 ].
	builder axisX 
		numberOfLabels: 5;
		labelRotation: 0;
		labelFontHeight: 8;
		labelConversion: [ :unixTime | 
			GTADateAndTimeStringBuilder new
				dateAndTime: (DateAndTime fromUnixTime: unixTime + minTime);
				duration: self computers duration;
				numberOfLabels: 5;
				humanReadablePrintString ].
	builder timelineLabelBuilder shape fontSize: 8.
	builder 
		timelineLabel: [ :lineIdentifier | String streamContents: [ :aStream |
				aStream 
					nextPutAll: (self computers at: lineIdentifier) userOrDeveloperString;
					space;
					print: lineIdentifier ] ];
		extent: self extent.
	
	user := self computers detect: [ :e | e isDeveloper not ] ifNone: [ nil ].
	user ifNotNil: [ | threshold |
		threshold := RTHorizontalTimelineDecorator 	new.
		threshold addLineAboveIdentifier: (self computers indexOf: user).
		threshold shape line width: 1; color: (Color paleGreen alpha: 0.6).
		builder addDecorator: threshold ].
	
	builder build.
	^ builder view! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 14:33'!
computers
	^ computers! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 14:32'!
computers: aGTAComputers
	computers := aGTAComputers! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 15:09'!
extent
	^ self width @ self height! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/5/2015 16:35'!
height
	^ height ifNil: [ height := self computers size * 10 max: 200 ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 15:10'!
height: anObject
	^ height := anObject! !

!GTATimelineBuilder methodsFor: 'building' stamp: 'JurajKubelka 6/4/2015 14:35'!
menu
	GTAMenuTimelineBuilder new timelineBuilder: builder; build.
	^ builder! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 14:35'!
view
	^ builder view! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/5/2015 16:35'!
width
	^ width ifNil: [ width := 400 ]! !

!GTATimelineBuilder methodsFor: 'accessing' stamp: 'JurajKubelka 6/4/2015 15:10'!
width: anObject
	^ width := anObject! !

Object subclass: #GTATool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Spotter-EventRecorder-Analysis-Utilities'!

GTATool class
	instanceVariableNames: 'semaphore process'!

GTATool class
	instanceVariableNames: 'semaphore process'!

!GTATool class methodsFor: 'private' stamp: 'JurajKubelka 5/13/2015 11:58'!
checkProcess
	process isComplete ifTrue: [ semaphore signal ].
! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:15'!
defaultDownloadDirectory
	^ FileSystem disk workingDirectory! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:18'!
defaultDownloadFilename
	^ self defaultDownloadDirectory / 'gt-events.tar.gz'! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:42'!
defaultEventsDirectory
	^ self defaultDownloadDirectory / 'gt' / 'events'! !

!GTATool class methodsFor: 'defaults' stamp: 'JurajKubelka 5/13/2015 11:14'!
defaultUrl
	^ 'http://gc.dcc.uchile.cl:8080/gt/events/data'! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:17'!
download
	"self download"
 	UIManager default informUserDuring: [ :bar |
		bar label: 'Download Spotter Event Data...'.
		[ ZnClient new
			url: self defaultUrl;
			downloadTo: self defaultDownloadFilename ]
		on: HTTPProgress 
		do: [ :progress |
			progress isEmpty ifFalse: [ bar current: progress percentage ].
			progress resume ] 
	]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:40'!
ensureDownloadedData
	self defaultDownloadFilename exists ifFalse: [ self download ]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:41'!
ensureExctractedData
	self defaultEventsDirectory exists ifFalse: [ self extract ]! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:39'!
ensureLocalDirectory
	self 
		ensureDownloadedData;
		ensureExctractedData! !

!GTATool class methodsFor: 'api' stamp: 'JurajKubelka 5/13/2015 11:58'!
extract
	semaphore := Semaphore new.
	process := ExternalUnixOSProcess 
		forkAndExec: '/usr/bin/tar' 
		arguments: (Array with: 'xzf' with: self defaultDownloadFilename fullName)
		environment: nil 
		descriptors: nil 
		workingDir: self defaultDownloadDirectory fullName.
	process addDependent: self.
	self checkProcess.
	semaphore wait.
	process := nil.
	semaphore := nil.! !

!GTATool class methodsFor: 'updating' stamp: 'JurajKubelka 5/13/2015 11:57'!
update: aParameter
	aParameter = #runState ifTrue: [ self checkProcess ]! !

!Object methodsFor: '*GT-Spotter-EventRecorder-Analysis' stamp: 'JurajKubelka 4/17/2015 10:37'!
isSpotterEvent
	^ false! !
